package com.rootcloud;

import com.rootcloud.common.constant.TemplateConstant;
import com.rootcloud.domain.dao.ConfigDao;
import com.rootcloud.domain.vo.ConfigVO;
import org.mybatis.spring.annotation.MapperScan;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.data.mongo.MongoDataAutoConfiguration;
import org.springframework.boot.autoconfigure.mongo.MongoAutoConfiguration;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.scheduling.annotation.EnableScheduling;
import springfox.documentation.oas.annotations.EnableOpenApi;

import java.util.List;

@EnableScheduling  //扫描定时器
@EnableOpenApi
@MapperScan({"com.rootcloud.domain.*.*","com.rootcloud.domain.*"})
@SpringBootApplication(exclude = {MongoAutoConfiguration.class, MongoDataAutoConfiguration.class})
public class NXGXBaseApp implements CommandLineRunner {

    private static final Logger log = LoggerFactory.getLogger(NXGXBaseApp.class);

    public static void main(String[] args) {
        SpringApplication app = new SpringApplication(NXGXBaseApp.class);
        app.run(args);
    }
    @Override
    public void run(String... args) throws Exception {
        initData();
    }

    @Autowired
    private ConfigDao configDao;

    @Autowired
    private RedisTemplate redisTemplate;


    private void  initData(){
        List<ConfigVO> zhidTableList= configDao.listTable_zhid();
        for (ConfigVO ztable:zhidTableList) {
            redisTemplate.opsForValue().set(TemplateConstant.NXGX_ZH_SPLIT_TABLES+ztable.getName(),ztable.getValue());
        }
        List<ConfigVO> szhidTableList= configDao.listTable_syzhid();
        for (ConfigVO ztable:szhidTableList) {
            redisTemplate.opsForValue().set(TemplateConstant.NXGX_ZH_SPLIT_TABLES+ztable.getName(),ztable.getValue());
        }
    }

}
