/*
 * Licensed Materials - Property of ROOTCLOUD
 * THIS MODULE IS "RESTRICTED MATERIALS OF ROOTCLOUD"
 * (c) Copyright ROOTCLOUD Inc. 2018 All Rights Reserved
 *
 * The source code for this program is not published or
 * otherwise divested of its trade secrets
 */

package com.rootcloud.common;

import java.io.ByteArrayOutputStream;
import java.io.UnsupportedEncodingException;
import java.util.Base64;
import java.util.zip.DataFormatException;
import java.util.zip.Inflater;

/**
 * 解压缩字符串工具.
 */
public class DeflaterUtils {

/*
  */
/**
   * 压缩.
   * @param unzipString  {@code String}
   * @return
   *//*

  public static String zipString(String unzipString) throws UnsupportedEncodingException {
    */
/*
     *     0 ~ 9 压缩等级 低到高
     *     public static final int BEST_COMPRESSION = 9;            最佳压缩的压缩级别。
     *     public static final int BEST_SPEED = 1;                  压缩级别最快的压缩。
     *     public static final int DEFAULT_COMPRESSION = -1;        默认压缩级别。
     *     public static final int DEFAULT_STRATEGY = 0;            默认压缩策略。
     *     public static final int DEFLATED = 8;                    压缩算法的压缩方法(目前唯一支持的压缩方法)。
     *     public static final int FILTERED = 1;                    压缩策略最适用于大部分数值较小且数据分布随机分布的数据。
     *     public static final int FULL_FLUSH = 3;                  压缩刷新模式，用于清除所有待处理的输出并重置拆卸器。
     *     public static final int HUFFMAN_ONLY = 2;                仅用于霍夫曼编码的压缩策略。
     *     public static final int NO_COMPRESSION = 0;              不压缩的压缩级别。
     *     public static final int NO_FLUSH = 0;                    用于实现最佳压缩结果的压缩刷新模式。
     *     public static final int SYNC_FLUSH = 2;                  用于清除所有未决输出的压缩刷新模式;
     *                                                              可能会降低某些压缩算法的压缩率。
     *//*

    //使用指定的压缩级别创建一个新的压缩器。
    Deflater deflater = new Deflater(Deflater.BEST_COMPRESSION);
    //设置压缩输入数据。
    deflater.setInput(unzipString.getBytes("UTF-8"));
    //当被调用时，表示压缩应该以输入缓冲区的当前内容结束。
    deflater.finish();

    final byte[] bytes = new byte[256];
    ByteArrayOutputStream outputStream = new ByteArrayOutputStream(256);

    while (!deflater.finished()) {
      //压缩输入数据并用压缩数据填充指定的缓冲区。
      int length = deflater.deflate(bytes);
      outputStream.write(bytes, 0, length);
    }
    //关闭压缩器并丢弃任何未处理的输入。
    deflater.end();
    return Base64.encodeToString(outputStream.toByteArray());
  }
*/

  /**
   * 解压.
   * @param zipString {@code String}
   * @return
   */
  public static String unzipString(String zipString) throws UnsupportedEncodingException {
    byte[] decode = Base64.getDecoder().decode(zipString.getBytes("UTF-8"));
    //创建一个新的解压缩器
    Inflater inflater = new Inflater();
    //设置解压缩的输入数据。
    inflater.setInput(decode);

    final byte[] bytes = new byte[256];
    ByteArrayOutputStream outputStream = new ByteArrayOutputStream(256);
    try {
      //finished() 如果已到达压缩数据流的末尾，则返回true。
      while (!inflater.finished()) {
        //将字节解压缩到指定的缓冲区中。
        int length = inflater.inflate(bytes);
        outputStream.write(bytes, 0, length);
      }
    } catch (DataFormatException e) {
      e.printStackTrace();
      return null;
    } finally {
      //关闭解压缩器并丢弃任何未处理的输入。
      inflater.end();
    }
    return new String(outputStream.toByteArray(),"UTF-8");
  }

}
