package com.rootcloud.common;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

/**
 * 通用返回对象
 */
@Getter
@Setter
@ToString
@ApiModel("接口调用结果")
public class JsonPageResult<T> extends JsonResult<T> {
    /**
     * 提示信息
     */
    @ApiModelProperty(notes = "记录总数")
    private long total;

    public JsonPageResult(String code) {
        super(code);
    }

    public JsonPageResult(String code, T data) {
        super(code, data);
    }

    public JsonPageResult(String code, T data, String message) {
        super(code, data, message);
    }

    /**
     * 成功返回结果
     *
     * @param data 获取的数据
     */
    public static <T> JsonPageResult<T> success(T data, long total) {
        JsonPageResult<T> result = new JsonPageResult<>(CODE_SUCCESS, data);
        result.setTotal(total);
        return result;
    }
}
