package com.rootcloud.common;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;


/**
 * 2.0系统JSON输出类
 * */
public class JsonResult2 extends HashMap<String, Object> {
    private static final long serialVersionUID = 1648637553048061990L;

    public JsonResult2(){
        this.put("ret", JsonResultStatus.SUCCESS.getRet());
        this.put("msg", JsonResultStatus.SUCCESS.getMsg());
        this.put("data", new ArrayList<String>());
    }

    public JsonResult2(Object data){
        this.put("ret", JsonResultStatus.SUCCESS.getRet());
        this.put("msg", JsonResultStatus.SUCCESS.getMsg());
        this.put("data", data);
    }
//    public JsonResult2(Page page) {
//        this.put("ret", JsonResultStatus.SUCCESS.getRet());
//        this.put("msg", JsonResultStatus.SUCCESS.getMsg());
//        this.put("data", new ArrayList<String>());
//        this.put("pageNo", page.getPageNo());
//        this.put("count", page.getPageNo());
//        this.put("pageSize", page.getPageSize());
//    }

    public JsonResult2(String ret,String msg){
        this.put("ret", ret);
        this.put("msg", msg);
        this.put("data", new ArrayList<String>());
    }

    @SuppressWarnings({"rawtypes", "unchecked"})
    @Override
    public Object put(String key, Object value) {
        if(null != key){
            if("ret".equals(key.toLowerCase()) || "msg".equals(key.toLowerCase())){
                if(!(value instanceof String)){
                    return this.get(key);
                }
            }
            if("data".equals(key.toLowerCase())){
                if(null == value){
                    super.put("data", new ArrayList());
                    return null;
                }else if(!(value instanceof Collection || value instanceof Array
                        || value.getClass().isArray())){
                    ArrayList list = new ArrayList();
                    list.add(value);
                    super.put("data", list);
                    return list;
                }
            }
        }
        return super.put(key, value);
    }

    public String getRet() {
        return (String)this.get("ret");
    }


    public void setRet(String ret) {
        this.put("ret", ret);
    }


    public String getMsg() {
        return (String)this.get("msg");
    }


    public void setMsg(String msg) {
        this.put("msg", msg);
    }

    public void putRetMsg(String ret,String msg){
        this.put("msg", msg);
        this.put("ret", ret);
    }

    public <T> T getData() {
        return (T) this.get("data");
    }

    public boolean isSucceed() {
        return getRet().startsWith("2");
    }

    public boolean isFailed() {
        return !isSucceed();
    }

    public void setData(Object data) {
        this.put("data", data);
    }
}
