package com.rootcloud.common;


public enum JsonResultStatus {
    SUCCESS("200", "执行成功"),
    REQ_REDIRECT("301", "请求已被永久移动到新位置"),
    REQ_GRAMMAR_ERROR("400", "服务器不理解请求的语法"),
    REQ_UN_AUTHORIZED( "401", "API访问资源未授权"),
    REQ_REFUSE("403", "访问被服务器拒绝"),
    REQ_NOT_FOUND("404", "请求地址不存在"),
    REQ_EMPTY_PARAMS( "406", "请求参数错误或为空"),
    REQ_NOT_OVERTIME("408", "服务器等候请求时超时"),
    SYS_EXCEPTION("500", "系统服务存在异常"),
    SYS_UNENFORCED( "501", "服务器不具备完成请求的功能"),
    SYS_GATEWAY_ERROR("502", "服务器作为网关或代理，从后续服务收到了无效的响应"),
    SYS_UNAVAILABLE_ERROR("503","目前无法使用服务（由于超载或进行停机维护）"),
    SYS_GATEWAY_TIMEOUT("504", "服务器作为网关或代理，未及时从后续服务接收请求"),
    SYS_VERSION_ERROR("505","HTTP版本不被支持"),
    NO_LOGIN("600", "用户未登录或登录已失效"),
    NO_RECORDS("691", "记录不存在"),
    HTTP_REQ_ERROR("900", "服务请求失败"),
    USER_TENANT_MATCHING_ERROR( "902", "用户请求与所属租户不匹配"),
    HTTP_URL_ERROR("903", "请求地址非法或为空"),
    USER_TENANT_LOST_ERROR("904", "用户所属租户序号丢失"),

    /*业务状态码*/
    DEVICE_UN_AUTHORIZED("50060001", "用户无权限操作"),
    DEVICE_FAIL("50060002", "执行失败"),
    DEVICE_ENQUIRE("50060003", "询问状态"),
    PARAM_REP_TYPE_NULL("50060004", "报表类型不能为空"),
    PARAM_REP_YEAR_NULL("50060005", "报表年份不能为空"),
    PARAM_DATE_NULL("50060008", "日期参数不能为空"),
    REST_GET_DEVICES_BY_OFFICE_NULL("50060006", "调用Base服务根据机构编号获取设备清单返回为空，请联系管理员"),
    REST_REQUEST_FAILED("50060007", "内部服务请求失败，请联系管理员"),

    PRINTER_HEALTH_CHECK_CONFIG_NOT_EXISTS("50060009", "健康度检查配置项不存在"),
    WORK_DATA_QUERY_CONFIG_NOT_EXISTS("50060010", "工况查询配置信息不存在，请联系管理员"),
    WORK_DATA_READ_PROPERTY_VALUE_FAILED("50060011", "读取工况结果属性值失败，请联系管理员")
    ;

    private String ret;

    private String msg;

    private JsonResultStatus(String ret, String msg) {
        this.ret = ret;
        this.msg = msg;
    }

    public String getRet() {
        return ret;
    }

    public void setRet(String ret) {
        this.ret = ret;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

}

