package com.rootcloud.common;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Author: jun2.wang
 * @Date: 2021/5/28
 */
@Data
@ApiModel("查询分页参数")
public class PageRequest {
    @ApiModelProperty(value = "一页大小")
    private Integer size;
    @ApiModelProperty(value = "页数")
    private Integer page;
    private static PageRequest defaultPaging = new PageRequest(0, 20);
    private static int MAX_PAGESIZE = 2000;

    public static PageRequest normalize(PageRequest paging) {
        if (paging == null) {
            paging = defaultPaging;
        }
        if (paging.page < 0) {
            paging.setPage(0);
        }
        if (paging.size > MAX_PAGESIZE) {
            paging.setSize(MAX_PAGESIZE);
        }
        return paging;
    }

    public PageRequest() {
    }

    public PageRequest(Integer size, Integer page) {
        this.size = size;
        this.page = page;
    }
}
