package com.rootcloud.common.constant;

/**
 * 星期几转换
 * @author Adams.huang
 *
 */
public enum WeekTypeEnum {

	SUN(1, "日"),
	MON(2, "一"), 
	TUES(3, "二"), 
	WEDNES(4, "三"), 
	THURS(5, "四"), 
	FRI(6, "五"), 
	SAT(7, "六");

	private WeekTypeEnum(int key, String display) {
		this.key = key;
		this.display = display;
	}

	private int key;
	private String display;

	public int getKey() {
		return key;
	}

	public void setKey(int key) {
		this.key = key;
	}

	public String getDisplay() {
		return display;
	}

	public void setDisplay(String display) {
		this.display = display;
	}

	public static String getDisplay(int key) {
		for (WeekTypeEnum item : WeekTypeEnum.values()) {
			if (item.getKey() == key) {
				return item.getDisplay();
			}
		}
		return null;
	}
}
