package com.rootcloud.common.enums;


/**
 * @Author yangyijun
 * @Description 订单枚举
 * @Date on 2022/5/18
 */
public interface OrderEnums {

    enum OrderStatus implements BaseEnums<String, String>{

        WORKERS_TO_BE_DISPATCHED("1", "待派工"),
        PENDING_ORDERS("2", "待接单"),
        PENDING_CHECK_IN("3", "待签到"),
        PENDING_REPORTING("4", "待报工"),
        PENDING_REVIEW("5", "待审核"),
        TO_BE_RETURNED("6", "待回访"),
        DONE("7", "已完成"),
        REJECTED("8", "已拒绝"),
        TRANSFERRED("9", "已转派"),
        DEPRECATED("10", "已废弃"),
        DELETED("11", "已删除");

        private String code;
        private String desc;

        OrderStatus(String code, String desc) {
            this.code = code;
            this.desc = desc;
        }

        @Override
        public String getCode() {
            return this.code;
        }

        @Override
        public String getDesc() {
            return this.desc;
        }
    }

    enum TodoStatus implements BaseEnums<String, String>{

        UNRESOLVED("0", "未解决"),
        RESOLVED("1", "已经解决");

        private String code;
        private String desc;

        TodoStatus(String code, String desc) {
            this.code = code;
            this.desc = desc;
        }

        @Override
        public String getCode() {
            return this.code;
        }

        @Override
        public String getDesc() {
            return this.desc;
        }
    }

}
