package com.rootcloud.common.enums;


/**
 * @Author yangyijun
 * @Description 订单枚举
 * @Date on 2022/5/18
 */
public interface ReportStatisticsEnums {

    enum DataStatus implements BaseEnums<String, String>{

        NEARLY_SEVEN_DAYS("1", "近七天"),
        NEARLY_A_MONTH("2", "近30天"),
        MONTH("3", "当月"),
        THAT_YEAR("4", "当年");

        private String code;
        private String desc;

        DataStatus(String code, String desc) {
            this.code = code;
            this.desc = desc;
        }

        @Override
        public String getCode() {
            return this.code;
        }

        @Override
        public String getDesc() {
            return this.desc;
        }
    }



    enum DeviceStatus implements BaseEnums<String, String>{

        HIRE("1", "出租"),
        SOLD("2", "变卖"),
        IDLE("3", "闲置"),
        SEALED("4", "封存"),
        ENABLE("5", "启用"),
        SCRAP("6", "报废"),
        IN_USE("7", "在用");

        private String code;
        private String desc;

        DeviceStatus(String code, String desc) {
            this.code = code;
            this.desc = desc;
        }

        @Override
        public String getCode() {
            return this.code;
        }

        @Override
        public String getDesc() {
            return this.desc;
        }
    }





}
