package com.rootcloud.common.enums;

import com.rootcloud.common.ResourceUtil;
import lombok.AllArgsConstructor;
import lombok.Getter;

@AllArgsConstructor
@Getter
public enum StatusCodeEnum {
    SUCCESS("200", ResourceUtil.getI18nMessage("200")),
    IMPORT_ERROR("409", ResourceUtil.getI18nMessage("409")),
    EXCEPTION("13500", ResourceUtil.getI18nMessage("13500")),
    INBOUND_SUCCESS("13501", ResourceUtil.getI18nMessage("13501")),
    OUTBOUND_SUCCESS("13512", ResourceUtil.getI18nMessage("13512")),
    OUTBOUND_FAIL("13503", ResourceUtil.getI18nMessage("13503")),
    OUTBOUND_NOT_ENOUGH("13514", ResourceUtil.getI18nMessage("13514")),
    USER_NOT_EXIST("13505", ResourceUtil.getI18nMessage("13505")),
    OUTBOUND_SOLD_SUCCESS("13502", ResourceUtil.getI18nMessage("13502")),
    PART_NOT_EXIST("13504", ResourceUtil.getI18nMessage("13504")),
    DEVICE_NOT_EXIST("13506", ResourceUtil.getI18nMessage("13506")),
    DEVICE_WORK_STATUS_NOT_EXIST("13508", ResourceUtil.getI18nMessage("13508")),
    HISTORY_DEVICE_NOT_EXIST("14001", ResourceUtil.getI18nMessage("14001")),
    ORDER_NOT_EXIST("15001", ResourceUtil.getI18nMessage("15001")),
    SING_IN_ONLY_STATUS("15002", ResourceUtil.getI18nMessage("15002")),
    SERVICE_PLAN_NOT_EXIST("16001", ResourceUtil.getI18nMessage("16001")),
    SERVICE_PLAN_NOT_DELETE("16002", ResourceUtil.getI18nMessage("16002")),
    SERVICE_PLAN_NOT_STOP("16003", ResourceUtil.getI18nMessage("16003")),
    SERVICE_PLAN_NOT_FINISH("16004", ResourceUtil.getI18nMessage("16004")),
    SERVICE_PLAN_NOT_STAR("16005", ResourceUtil.getI18nMessage("16005")),
    SERVICE_PLAN_NOT_CALENDAR("16006", ResourceUtil.getI18nMessage("16006")),
    SING_IN_NOT_PASS("17001", ResourceUtil.getI18nMessage("17001")),
    TODO_NOT_EXIST("18001", ResourceUtil.getI18nMessage("18001")),
    TODO_NOT_STATUS("18002", ResourceUtil.getI18nMessage("18002")),
    FAIL_CALL_INTERFACE("40000", ResourceUtil.getI18nMessage("40000")),
    ALARM_TYPE_REQUIRED("13507",ResourceUtil.getI18nMessage("13507")),
    ABNORMAL_CHECK_IN("60021",ResourceUtil.getI18nMessage("60021")),
    GET_CURRENT_LOCATION_EXCEPTION("60022",ResourceUtil.getI18nMessage("60022"))
    ;
    private String ret;
    private String message;
}
