package com.rootcloud.common.net;

import net.sf.json.JsonConfig;
import net.sf.json.processors.JsonValueProcessor;
import org.apache.commons.lang3.StringUtils;

import java.text.SimpleDateFormat;

/**
 * json日期转化工具类
 * 
 * @version 1.0
 * @author WuXiaoJun
 * @date 2015年9月22日 下午10:01:08
 */
public class DateJsonValueProcessor implements JsonValueProcessor {

	private String format;
	
	public DateJsonValueProcessor() {
	}
	public DateJsonValueProcessor(String format) {
		this.format = format;
	}

	public Object processArrayValue(Object value, JsonConfig jsonConfig) {
		
		return null;
	}

	public Object processObjectValue(String key, Object value,
			JsonConfig jsonConfig) {
		if (value == null) {
			return "";
		}
		if (value instanceof java.sql.Timestamp) {
			String str = new SimpleDateFormat(format)
					.format((java.sql.Timestamp) value);
			return str;
		}
		if (value instanceof java.util.Date) {
			if(StringUtils.isNotBlank(format)){
				String str = new SimpleDateFormat(format)
				.format((java.sql.Timestamp) value);
				return str;
			}else{
				Long time = ((java.util.Date) value).getTime();
				return time;
			}
		}

		return value.toString();
	}
}
