package com.rootcloud.common.util;

import java.text.SimpleDateFormat;
import java.util.Date;
import javax.annotation.Resource;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

@Component
public class OrderNumberUtils {


  @Resource
  private RedisTemplate redisTemplate;

  public String generateOrderNumber() {
    /* 由于之前人员将订单seq数据存储在内存中，服务重启后seq失效清零，导致后续订单从0开始，编码重复，现存入redis中
    *  逻辑修改为：每次自然天增加后，重置seq为0，且将seq,自然天等数据存入redis
    * */
    int callCount = (int) (redisTemplate.opsForValue().get("orderSeq") == null ? 0 :
        redisTemplate.opsForValue().get("orderSeq"));
    // 当前日期
    String currentDate =
        new SimpleDateFormat("yyyyMMdd").format(new Date());
    // 上次日期
    String lastDate =
        (String) (redisTemplate.opsForValue().get("orderLastDate") == null ? currentDate :
            redisTemplate.opsForValue().get("orderLastDate"));
    redisTemplate.opsForValue().set("orderLastDate", currentDate);
    if (!currentDate.equals(lastDate)) {
      callCount = 0;
      redisTemplate.opsForValue().set("orderLastDate", currentDate);
    }
    callCount++;
    redisTemplate.opsForValue().set("orderSeq", callCount);
    return currentDate + String.format("%03d", callCount);
  }


}
