package com.rootcloud.common.util;

import com.rootcloud.domain.vo.RepPrinterTargetDicVO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.text.DecimalFormat;
import java.util.*;

//平台设备转换帮助类
public class PlatformDeviceTransUtil {

    private static final Logger logger = LoggerFactory.getLogger(PlatformDeviceTransUtil.class);


    //将平台设备编码转换为用户设备编码
    public static List<Map<String, Object>> repalceDevice(Map<String,String> printerDeviceRelationData, List<Map<String, Object>> list ){
        List<Map<String, Object>> datas = new ArrayList<Map<String, Object>>();
        for( Map<String, Object> data : list ){
            //平台设备编码
            String platformDevice = data.get("deviceId")==null?data.get("device_id").toString():data.get("deviceId").toString();

            //获取用户设备编码[含设备位置]
            String userDeviceId = printerDeviceRelationData.get(platformDevice)==null?platformDevice:printerDeviceRelationData.get(platformDevice);
            data.put("deviceId", userDeviceId);
            data.put("device_id", userDeviceId);
            datas.add(data);
        }
        return datas;
    }

    //根据value获取key
    public static Set<String> repalceDevice2(Map<String,String> printerDeviceRelationData, String deviceCode ){

        if(!printerDeviceRelationData.containsValue(deviceCode))
        {
            return  null;
        }
        Set<String> keySet =new LinkedHashSet<String>();
        for(String k:printerDeviceRelationData.keySet())
        {
            if(printerDeviceRelationData.get(k).equals(deviceCode))
            {
                keySet.add(k);
            }
        }
        return keySet;

    }
    //按照设备机型分组
    public static Map<String, Object> groupByDeviceType(String[] deviceTypes, List<Map<String, Object>> list,Map<String, Object> targetmap){


        logger.info( "start开始按照设备机型对数据进行分组。deviceTypes："+deviceTypes+  " list:"+list );
        Map<String, Object> dyxlData = new HashMap<String, Object>();

        DecimalFormat df =new DecimalFormat("0.0");
        int length = list==null?0:list.size();

        Map<String, List<Map<String, Object>>> datas = new LinkedHashMap<String, List<Map<String, Object>>>();
        for( int i=0; i<length; i++ ){
            Map<String, Object> data = list.get(i);
            String deviceId = data.get("deviceId").toString();
            String deviceType = "" ;
            for( String tmp: deviceTypes){
//    			if( deviceId.indexOf(tmp) >=0 ){
                if( deviceId.startsWith(tmp)){
                    deviceType = tmp ;
                }
            }
            RepPrinterTargetDicVO DYXL = (RepPrinterTargetDicVO) targetmap.get("DYXL"+deviceType);
            if( DYXL!=null ){
                String targetValue = df.format(DYXL.getTargetValue()) ;
                if( datas.get(deviceType)!=null ){
                    List<Map<String, Object>> tmpList = datas.get(deviceType) ;
                    Map<String, Object> tmpdata= new HashMap<String, Object>();
                    tmpdata.put("deviceId", deviceId);
                    tmpdata.put("dyxl", data.get("dyxl"));
                    tmpdata.put("targetValue", targetValue);
                    tmpList.add(tmpdata);
                    datas.put(deviceType, tmpList);
                }else{
                    List<Map<String, Object>> tmpList = new ArrayList<Map<String, Object>>() ;
                    Map<String, Object> tmpdata= new HashMap<String, Object>();
                    tmpdata.put("deviceId", deviceId);
                    tmpdata.put("dyxl", data.get("dyxl"));
                    tmpdata.put("targetValue", targetValue);
                    tmpList.add(tmpdata);
                    datas.put(deviceType, tmpList);
                }
            }
        }
        logger.info("分组后数据："+datas);


        List<String> xListDYXL = new ArrayList<String>();
        List<String> dyxlList = new ArrayList<String>();
        List<List<String>> listTarget = new ArrayList<List<String>>();

        int index = 0;
        String ratelist = "";//2218机型为___，SDream机型为__；2218-1最低___，SDreamA最低____
        String aveRatelist = "";//2218机型为___，SDream机型为__；
        String lowRatelist = "";//2218-1最低___，SDreamA最低____
        for(Map.Entry<String, List<Map<String, Object>>> data: datas.entrySet() ){
            String deviceType = data.getKey();
            RepPrinterTargetDicVO DYXL = (RepPrinterTargetDicVO) targetmap.get("DYXL"+deviceType);
            String targetValue = "null";
            if( DYXL!=null ){
                targetValue = df.format(DYXL.getTargetValue()) ;
            }

            List<Map<String, Object>> listData = data.getValue();

            if( listData!=null && listData.size()>0 ){
                String[] targets = new String[length+datas.size()];

                float tota_dyxl=0;
                String ave = "0.00";
                int index2 = 0;
                for( int i=0; listData!=null && i<listData.size(); i++ ){
                    Map<String, Object> mapdata = listData.get(i);
                    float dyxl = Float.parseFloat(mapdata.getOrDefault("dyxl", "0").toString());
                    String deviceId = mapdata.get("deviceId")==null?"":mapdata.get("deviceId").toString();
                    xListDYXL.add(deviceId);
                    dyxlList.add(df.format(dyxl));
                    targets[index] = targetValue ;
                    index++;
                    index2++;
                    tota_dyxl += dyxl ;
                    if( i==(listData.size()-1) ){
                        String dyxlStr = "<span class='xh'>"+df.format(dyxl)+"</span>";
                        lowRatelist += deviceId+"的打印效率最低，为"+dyxlStr+"L/h；";
                    }
                }

                //平均值
                xListDYXL.add("平均值");
                ave = String.format("%.1f", index2==0?0:tota_dyxl/index2);
                dyxlList.add(ave);
                targets[index]=targetValue;
                index++;

                //打印效率加目标值  2020-12-1加
                String rate = "<span class='xh'>"+ave+"</span>";
                aveRatelist += deviceType+"机型为"+rate+"L/h(目标值:"+targetValue+"L/h)；";
                listTarget.add( Arrays.asList(targets) );
            }

        }

        ratelist = aveRatelist + lowRatelist ;
        logger.info("统计数据:"+ratelist);
        dyxlData.put("xList", xListDYXL);
        dyxlData.put("dyxlList", dyxlList);
        dyxlData.put("targetValue", listTarget);
        dyxlData.put("ratelist", ratelist.length()==0?"":ratelist.substring(0, ratelist.length()-1));//平均打印效率
        return dyxlData ;
    }


    public static Map<String, Object> groupByDeviceType2(String[] deviceTypes, List<Map<String, Object>> list,Map<String, Object> targetmap){


        logger.info( "start开始按照设备机型对数据进行分组。deviceTypes："+deviceTypes+  " list:"+list );
        Map<String, Object> dyxlData = new HashMap<String, Object>();

        DecimalFormat df =new DecimalFormat("0.0");
        int length = list==null?0:list.size();

        Map<String, List<Map<String, Object>>> datas = new LinkedHashMap<String, List<Map<String, Object>>>();

        Map<String, Object> data1 = list.get(0);
        String deviceId1 = data1.get("deviceId").toString();
        String deviceType1 = "" ;
        for( String tmp: deviceTypes){
//			if( deviceId1.indexOf(tmp) >=0 ){
            if( deviceId1.startsWith(tmp)){
                deviceType1 = tmp ;
            }
        }
        if(deviceType1.equals(""))
        {
            logger.info("系统配置中找不到设备"+deviceId1+"的机型...");
        }
        String targetValue ="";
        RepPrinterTargetDicVO DYXL1 = (RepPrinterTargetDicVO) targetmap.get("DYXL"+deviceType1);
        if( DYXL1!=null )
        {
            targetValue = df.format(DYXL1.getTargetValue()) ;
            List<Map<String, Object>> tmpList = new ArrayList<Map<String, Object>>() ;
            Map<String, Object> tmpdata= new HashMap<String, Object>();
            tmpdata.put("deviceId", deviceId1);//1800-10
            tmpdata.put("dyxl", data1.get("dyxl")); //打印效率
            tmpdata.put("targetValue", targetValue); //目标值
            tmpList.add(tmpdata);
            datas.put(deviceType1, tmpList);
        }
        else
            logger.info("系统配置中找不到设备"+deviceId1+"的目标值"+"DYXL"+deviceType1);

		/*
		for( int i=0; i<length; i++ )
		{
			Map<String, Object> data = list.get(i);
			String deviceId = data.get("deviceId").toString();
			String deviceType = "" ;
			for( String tmp: deviceTypes){
				if( deviceId.indexOf(tmp) >=0 ){
					deviceType = tmp ;
				}
			}
			RepPrinterTargetDicVO DYXL = (RepPrinterTargetDicVO) targetmap.get("DYXL"+deviceType);
			if( DYXL!=null ){
				String targetValue = df.format(DYXL.getTargetValue()) ;
				if( datas.get(deviceType)!=null ){
					List<Map<String, Object>> tmpList = datas.get(deviceType) ;
					Map<String, Object> tmpdata= new HashMap<String, Object>();
					tmpdata.put("deviceId", deviceId);
					tmpdata.put("dyxl", data.get("dyxl"));
					tmpdata.put("targetValue", targetValue);
					tmpList.add(tmpdata);
					datas.put(deviceType, tmpList);
				}else{
					List<Map<String, Object>> tmpList = new ArrayList<Map<String, Object>>() ;
					Map<String, Object> tmpdata= new HashMap<String, Object>();
					tmpdata.put("deviceId", deviceId);
					tmpdata.put("dyxl", data.get("dyxl"));
					tmpdata.put("targetValue", targetValue);
					tmpList.add(tmpdata);
					datas.put(deviceType, tmpList);
				}
			}
		} */
        logger.info("分组后数据："+datas);

        List<String> xListDYXL = new ArrayList<String>();

        float tota_dyxl=0;
        int index = 0;
        List<String> dyxlList = new ArrayList<String>();
        List<List<String>> listTarget = new ArrayList<List<String>>();
        for( Map<String, Object> item : list )
        {
            float dyxl = Float.parseFloat(item.getOrDefault("dyxl", "0").toString());
            tota_dyxl += dyxl ;
            String device = item.get("deviceId").toString();
            String days =  item.get("day")==null?"":item.get("day").toString();
            xListDYXL.add(days);
            dyxlList.add(df.format(dyxl));
            index++;
        }

        //平均值
        xListDYXL.add("平均值");
        String ave = String.format("%.1f", index==0?0:tota_dyxl/index);
        dyxlList.add(ave);

//		Map<String, Object> ave_map = new HashMap<String, Object>();
//		ave_map.put("dyxl", ave);
//		ave_map.put("day", "平均值");
//		dataList.add(ave_map);
//		logger.info("统计数据:"+ratelist);
        dyxlData.put("xList", xListDYXL);
        dyxlData.put("dyxlList", dyxlList);
        dyxlData.put("targetValue", targetValue);
        dyxlData.put("avgDyxlValue", ave);

//		dyxlData.put("targetValue", listTarget);
//		dyxlData.put("ratelist", ratelist.length()==0?"":ratelist.substring(0, ratelist.length()-1));//平均打印效率
        return dyxlData ;
    }

}
