package com.rootcloud.config;

import com.baomidou.mybatisplus.extension.plugins.PaginationInterceptor;
import com.rootcloud.common.intercept.DataScopeInterceptor;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.redis.core.RedisTemplate;

import javax.sql.DataSource;


/**
 * TODO
 *
 * @author wei.liao
 * @version 1.0
 * @date 2022/4/28 19:31
 */
@Configuration
public class MybatisPlusConfig {
    @Bean
    public PaginationInterceptor paginationInterceptor() {
        return new PaginationInterceptor();
    }


    /**
     * 数据权限插件
     *
     * @return DataScopeInterceptor
     */
    @Bean
    @ConditionalOnMissingBean
    public DataScopeInterceptor dataScopeInterceptor(DataSource dataSource,  RedisTemplate redisTemplate) {
        return new DataScopeInterceptor(dataSource,redisTemplate);
    }
}