package com.rootcloud.config.auth;

import com.rootcloud.common.UserOperationContext;

/**
 * @Author: jun2.wang
 * @Date: 2021/5/28
 */
public class UserContext {
    static ThreadLocal<LoginUserInfo> tls = new ThreadLocal<>();

    public static final LoginUserInfo emptyUser;

    static {
        emptyUser = new LoginUserInfo("SYSTEM","系统","SYSTEM",false,false,"");
    }

    public static LoginUserInfo current() {
        if (tls.get() == null) {
            return emptyUser;
        } else {
            return tls.get();
        }
    }

    public static String getTenantId() {
        return current().getTenantId();
    }

    public static String getUserTenantId() {
        if (tls.get() != null) {
            return tls.get().getTenantId();
        }
        return null;
    }


    public static String getUserId() {
        return current().getUserId();
    }

    public static void setLanguage(String language) {
        current().setLanguage(language);
    }

    public static UserOperationContext actionContext() {
        LoginUserInfo userInfo = current();
        UserOperationContext ctx = new UserOperationContext();
        ctx.setUserId(userInfo.getUserId());
        ctx.setUserName(userInfo.getUserName());
        ctx.setTenantId(userInfo.getTenantId());
        ctx.setIp("127.0.0.1");
        ctx.setBrowser("chrome 1.2.3");
        return ctx;
    }

    public static void set(String userId, String userName, String tenantId, boolean tenantAdmin, boolean supper,String currToken) {
        LoginUserInfo user = new LoginUserInfo(userId, userName, tenantId, tenantAdmin, supper,currToken);
        tls.set(user);
    }


    //清除用户信息
    public static void remove() {
        tls.remove();
    }
}
