package com.rootcloud.controller;


import com.rootcloud.common.IgnoreSecurity;
import com.rootcloud.common.JsonResult;
import com.rootcloud.common.SprintBeanUtils;
import com.rootcloud.domain.service.auth.RootCloudAuthService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import jline.internal.Log;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

@RestController
@Api(tags = "AbaBase需要转化接口")
@RequestMapping("/aba-base")
@IgnoreSecurity
public class AbaBaseController {

    @Value("${application.source}")
    private String source;

    private static RootCloudAuthService rootCloudAuthService;

    private void init() {
        if ("CLOUD".equals(source)) {
            rootCloudAuthService = SprintBeanUtils.getBean("cloudAuthService");
        }
    }

    @PostMapping("/get-verification-code")
    @ApiOperation(value = "获取短信", notes = "获取短信")
    public JsonResult<Object> getVerificationCode(@RequestBody Map<String, Object> param) {
        Log.info("获取短信参数"+param);
        init();
        return rootCloudAuthService.getCode(param);
    }

    @PostMapping("/send-confirm-verify-code")
    @ApiOperation(value = "获取短信", notes = "获取短信")
    public JsonResult<Object> sendConfirmVerifyCode(@RequestBody Map<String, Object> param) {
        Log.info("获取短信参数"+param);
        init();
        return rootCloudAuthService.getCode(param);
    }



    @PostMapping("/reset-password-by-contact")
    @ApiOperation(value = "修改密码提交", notes = "修改密码提交")
    public JsonResult<Object> modifyPassWord(HttpServletRequest request,@RequestBody Map<String, Object> param) {
        init();
        param.put("Authorization",request.getHeader("Authorization"));
        return rootCloudAuthService.modifyPassWord(param);
    }

    @PostMapping("/update-pwd")
    @ApiOperation(value = "找回密码提交", notes = "找回密码提交")
    public JsonResult<Object> findPassWord(HttpServletRequest request,@RequestBody Map<String, Object> param) {
        init();
        return rootCloudAuthService.findPassWord(param);
    }

    @PostMapping("/update-email")
    @ApiOperation(value = "修改邮箱", notes = "修改邮箱")
    public JsonResult<Object> updateEmail(HttpServletRequest request,@RequestBody Map<String, Object> param) {
        init();
        return rootCloudAuthService.updateEmail(param);
    }

}
