package com.rootcloud.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.rootcloud.common.JsonResult;
import com.rootcloud.domain.constant.AppConstant;
import com.rootcloud.domain.service.device.FaultCodeService;
import com.rootcloud.vo.faultcode.FaultCodeDetailVo;
import com.rootcloud.vo.faultcode.FaultCodeVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
@Api(tags = "APP知识库查询")
@RequestMapping("/app_faultCode")
public class AppNxZskFaultCodeController {

    @Resource(name = "faultCodeServiceImpl")
    private FaultCodeService faultCodeService;

    @ApiOperation("分页查询知识库")
    @GetMapping("/page")
    public JsonResult<IPage<FaultCodeVo>> faultCodePage(
            @ApiParam("页码数，默认为1") @RequestParam(value = "page", defaultValue = AppConstant.PAGE) int page,
            @ApiParam("每页数，默认为10") @RequestParam(value = "size", defaultValue = AppConstant.SIZE) int size,
            @ApiParam("查询条件(故障码、故障描述)") @RequestParam(value = "queryData", required = false) String queryData,
            @ApiParam("适用设备类型码") @RequestParam(value = "faultcodeSblxcode", required = false) String faultcodeSblxcode){
        return JsonResult.success(faultCodeService.getPage(page,size,queryData,faultcodeSblxcode));
    }


    @ApiOperation("查询知识库详情")
    @GetMapping("/faultCodeDetail")
    public JsonResult<FaultCodeDetailVo> selectDetailById(@ApiParam("知识库主键") @RequestParam(value = "nxZskFaultcodeId", required = true) String nxZskFaultcodeId){
        return JsonResult.success(faultCodeService.selectById(nxZskFaultcodeId));
    }

}
