package com.rootcloud.controller;

import com.rootcloud.common.IgnoreSecurity;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

/**
 * 公用接口
 */
@RestController
@Api(tags = "公用接口")
@RequestMapping("/common")
@IgnoreSecurity
public class CommonController {
    @Resource
    private RedisTemplate redisTemplate;
    /**
     *语言环境切换
     */
    @ApiOperation("切换语言环境")
    @GetMapping("/changeLanguage")
    public void changeLanguage(@RequestParam String language, HttpServletRequest request) {
        redisTemplate.opsForValue().set("user_id~language",language);
    }
}
