package com.rootcloud.controller;

import com.gexin.fastjson.JSON;
import com.rootcloud.common.IgnoreSecurity;
import com.rootcloud.common.JsonResult;
import com.rootcloud.domain.ao.ServicePlanAO;
import com.rootcloud.domain.dto.NxSparePartVo;
import com.rootcloud.domain.entity.NxSparePartEntity;
import com.rootcloud.domain.service.fittings.FittingsService;
import com.rootcloud.domain.service.fittings.SpareFileService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author:xxxxx
 * @create: 2022-05-06 14:39
 * @Description: 配件信息
 */
@RestController
@Api(tags = "配件信息")
@RequestMapping("/fittings")
public class FittingController {
    @Resource(name = "fittingsServiceImpl")
    FittingsService fittingsService;
    @Autowired
    SpareFileService spareFileService;

    /**
     * @Param:
     * @return:
     * @Author: w-lixiafen02
     * @date: 2022/5/6
     */
    @GetMapping("/total-price")
    public JsonResult<String> queryFittingTotalPrice(@RequestParam("fittingsSellId") String fittingsSellId) {
        return JsonResult.success(fittingsService.getTotalPrice(fittingsSellId));
    }


    /**
     * 订单更换配件更新设备列表配件
     *
     * @Param:
     * @return:
     */
    @GetMapping("/updateSparePart")
    public JsonResult<String> updateSparePart(@RequestParam("orderId") String orderId) {
        return JsonResult.success(spareFileService.updateSparePart(orderId));
    }

    /**
     * @Description 导入备件信息
     **/
    @PostMapping(path = "/importSparePart")
    @ApiOperation("导入备件信息")
    public JsonResult importSparePart(@RequestBody List<NxSparePartVo> nxSparePartVos) {
        spareFileService.importSparePart(nxSparePartVos);
        return JsonResult.success("导入备件信息成功");
    }

    @ApiOperation("备件信息异常处理")
    @GetMapping("/dealWith")
    @IgnoreSecurity
    public JsonResult<Object> dealWith(@RequestParam("sbId") String sbId, @RequestParam("partId") String partId) {
        spareFileService.dealWith(sbId,partId);
        return JsonResult.success();
    }

}
