package com.rootcloud.controller;

import com.rootcloud.common.JsonPageResult;
import com.rootcloud.domain.entity.base.ModelColor;
import com.rootcloud.domain.entity.base.ModelPropertyEntity;
import com.rootcloud.domain.service.gbsj.ModelColorService;
import com.rootcloud.domain.service.gbsj.ModelPropertyService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;
import java.util.List;
import java.util.Map;


/**
 * @author ruixiang.feng
 * @ClassName
 * @Description
 * @date 2022/4/14 14:40
 */
@Api(tags = "模型编辑接口")
@RestController
@RequestMapping("/model")
public class ModelController {
    @Resource(name = "propertyService")
    private ModelPropertyService modelPropertyService;

    @Resource(name = "colorService")
    private ModelColorService modelColorService;

    @ApiOperation(value = "查询实时工况接口")
    @GetMapping("getWorkingCondition")
    public Map<String, List<ModelPropertyEntity>> getWorkingCondition(@RequestParam String deviceSblx, String deviceSbxh, String workingConditionType,String dataSource) {
        return modelPropertyService.getWorkingCondition(deviceSblx,deviceSbxh,workingConditionType,dataSource);
    }

    @ApiOperation(value = "修改实时工况接口")
    @PostMapping("editWorkingCondition")
    public JsonPageResult updateWorkingCondition(@RequestBody @Valid List<ModelPropertyEntity> modelPropertyEntityList) {
        return modelPropertyService.updateWorkingCondition(modelPropertyEntityList);
    }
    @ApiOperation(value = "删除实时工况接口")
    @DeleteMapping ("delWorkingCondition")
    public JsonPageResult delWorkingCondition(@RequestParam String propertyTagCode,String workingConditionType) {
        return modelPropertyService.delWorkingCondition(propertyTagCode,workingConditionType);
    }

    @ApiOperation(value = "查询分组属性")
    @GetMapping("getGroupAtt")
    public List<ModelPropertyEntity> getGroupAtt(@RequestParam String workingConditionType, String propertyTagCode,String deviceSblx, String deviceSbxh) {
        return modelPropertyService.getGroupAtt(workingConditionType,propertyTagCode,deviceSblx, deviceSbxh);
    }

    @ApiOperation(value = "查询颜色属性")
    @GetMapping("getColor")
    public List<ModelColor> getColor() {
        return modelColorService.getColor();
    }

    @ApiOperation(value = "设备型号查询模型编辑数据")
    @PostMapping ("getmodelPropertyBySbxh")
    public List<ModelPropertyEntity> getmodelPropertyBySbxh(@RequestBody List<String> sbxh) {
        return modelPropertyService.getmodelPropertyBySbxh(sbxh);
    }
}
