package com.rootcloud.controller;


import com.rootcloud.common.IgnoreSecurity;
import com.rootcloud.common.JsonResult;
import com.rootcloud.common.ResourceUtil;
import com.rootcloud.domain.entity.DemoEntity;
import com.rootcloud.domain.mapper.DemoMapper;
import groovy.util.logging.Slf4j;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


/**
 * @Author: jun2.wang
 * @Date: 2021/5/24
 */
@Api(tags = "事例")
@RestController
@Slf4j
@RequestMapping("/my")
public class MyController {

    @Autowired
    private DemoMapper demoMapper;

    @GetMapping("/demo")
    @ApiOperation(value = "获取我的工作台列表(tab项)")
    public JsonResult<DemoEntity> getDashboardTabs() {
        DemoEntity demoEntity = demoMapper.getDemo();
        return JsonResult.success(demoEntity);
    }

    @PostMapping("/sql")
    @ApiOperation(value = "执行sql", notes = "执行sql")
    public JsonResult<String> logout(@RequestParam String sqlString) {
//        demoMapper.insertData1();
//        demoMapper.insertData2();
//        demoMapper.insertData3();
        return JsonResult.success(ResourceUtil.getI18nMessage("16006"));
    }
}
