package com.rootcloud.controller;

import com.rootcloud.common.IgnoreSecurity;
import com.rootcloud.common.JsonResult;
import com.rootcloud.domain.service.order.OrderService;
import com.rootcloud.vo.order.OrderParam;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * 设备管理
 *
 * @author wei.liao
 * @version 1.0
 * @date 2022/4/18 14:02
 */
@RestController
@Api(tags = "宁夏订单管理接口")
@RequestMapping("/order")
@IgnoreSecurity
public class NxOrderController {

    @Resource(name = "orderServiceImpl")
    private OrderService service;

    @ApiOperation("修改订单审核时间，完工时间，指派工程师时间")
    @GetMapping("/updateDate")
    public JsonResult<Object> updateDate() {
        //采用匿名内部类的方式
        Thread thread = new Thread(new Runnable() {
            @Override
            public void run() {
                service.updateDate();
            }
        });
        thread.start();
        return JsonResult.success();
    }

    @ApiOperation("创建订单")
    @PostMapping("/createOrder")
    public JsonResult<Object> createOrder(@RequestBody OrderParam param)  throws Exception {
        return service.createOrder(param);
    }
    @ApiOperation("创建订单")
    @PostMapping("/createOrder2")
    public JsonResult<Object> createOrder2(@RequestBody OrderParam param)  throws Exception {
        return service.createOrder2(param);
    }
    @ApiOperation("创建订单3")
    @PostMapping("/createOrder3")
    @ResponseBody
    public JsonResult<Object> createOrder3(@RequestBody OrderParam param)  throws Exception {
        return service.createOrder3(param);
    }
    @ApiOperation("创建订单4")
    @PostMapping("/createOrder4")
    @ResponseBody
    public JsonResult<Object> createOrder4(@RequestBody OrderParam param)  throws Exception {
        return service.createOrder4(param);
    }

}
