package com.rootcloud.controller;

import com.rootcloud.common.IgnoreSecurity;
import com.rootcloud.common.JsonResult;
import com.rootcloud.domain.entity.NxPartFileConfigEntity;
import com.rootcloud.domain.service.part.NxPartFileConfigService;
import com.rootcloud.domain.service.part.NxPartFileService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;


/**
 * @author lujiumin
 * @date 2022/10/13
 * 描述：
 */
@Api(tags = "配件档案配置表")
@RestController
@Slf4j
@RequestMapping("/nxPartFileConfig")
public class NxPartFileConfigController {

    @Resource(name = "nxpartFileConfigService")
    private NxPartFileConfigService nxPartFileConfigService;


    @ApiOperation("获取租户id配置")
    @GetMapping("/selectData")
    public JsonResult<NxPartFileConfigEntity> selectData() {
        return nxPartFileConfigService.selectData();
    }

    @ApiOperation("新增/修改")
    @PostMapping("/insertOrUpdate")
    public JsonResult insertOrUpdate(@RequestBody NxPartFileConfigEntity entity) {
        return nxPartFileConfigService.insertOrUpdate(entity);

    }

}
