package com.rootcloud.controller;

import com.rootcloud.common.IgnoreSecurity;
import com.rootcloud.common.JsonResult;
import com.rootcloud.config.auth.LoginUserInfo;
import com.rootcloud.config.auth.UserContext;
import com.rootcloud.domain.entity.NxPartFileConfigEntity;
import com.rootcloud.domain.entity.NxPartFileEntity;
import com.rootcloud.domain.service.part.NxPartFileConfigService;
import com.rootcloud.domain.service.part.NxPartFileService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import jline.internal.Log;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;


/**
 * @author qinzhengping
 * @date 2022/11/14
 * 描述：
 */
@Api(tags = "配件档案表")
@RestController
@Slf4j
@RequestMapping("/nxPartFile")
public class NxPartFileController {

    @Resource(name = "nxpartFileService")
    private NxPartFileService nxPartFileService;

    @ApiOperation("新增/修改")
    @PostMapping("/updateCkmc")
    public JsonResult insertOrUpdate(@RequestBody NxPartFileEntity entity) {
        LoginUserInfo current = UserContext.current();
        Log.info("获取用户信息:" + current);
        //采用匿名内部类的方式
        Thread thread = new Thread(new Runnable() {
            @Override
            public void run() {
                nxPartFileService.updateCkmc(entity, current);
            }
        });
        thread.start();
        return JsonResult.success("系统正在同步中，请稍后...");
    }
}
