package com.rootcloud.controller;

import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rootcloud.common.IgnoreSecurity;
import com.rootcloud.common.JsonResult;
import com.rootcloud.common.SendMessageUtils;
import com.rootcloud.config.unipush.UniPushVO;
import com.rootcloud.config.unipush.UnipushUtils;
import com.rootcloud.domain.vo.SMSVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import jline.internal.Log;
import lombok.extern.log4j.Log4j2;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.Collections;

/**
 * @author LiPingAn 2022/7/20 21:08
 * @version 1.0
 **/
@Slf4j
@IgnoreSecurity
@RestController
@RequestMapping("/note")
@Api(value = "send-note", tags = "短信")
public class SMSController {
    @Autowired
    SendMessageUtils sendMessageUtils;

    @ApiOperation(value = "发送短信接口")
    @PostMapping("/send-note")
    public JsonResult<String> sendNote(@RequestBody JSONObject smsvo) {
        log.info("发短信参数",JSON.toJSON(smsvo));
        //获取电话号码
        JSONArray jsonArray = smsvo.getJSONObject("recipients").getJSONArray("sms");
        String phone = (String) jsonArray.get(0);
//        sendMessageUtils.send(Collections.singletonList(smsvo.getPhone()), Collections.singletonList(smsvo.getYzm()),"19519820");
        sendMessageUtils.send(Collections.singletonList(phone),
                Collections.singletonList(smsvo.getJSONObject("params").getString("code")),smsvo.getString("tempId"));
        return JsonResult.success();
    }
}
