package com.rootcloud.controller;

import com.rootcloud.common.JsonResult;
import com.rootcloud.domain.model.WorkStatusMonitorModel;
import com.rootcloud.domain.service.gkjk.NxJeDeviceService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @author LiPingAn 2022/4/18 15:13
 * @version 1.0
 **/
@Api(tags = "设备详情工况监控接口")
@RestController
@Slf4j
@RequestMapping("/work-status-monitor")
public class WorkStatusMonitorController {

    @Resource(name = "nxJeDeviceServiceImpl")
    private NxJeDeviceService nxJeDeviceService;

    @ApiOperation(value = "查询设备详情实时工况数据")
    @GetMapping("query-work-status")
    public JsonResult<Object> queryWorkStatus(@RequestParam String deviceId, String dataSjy) {
        Map<String, List<WorkStatusMonitorModel>> stringListMap = nxJeDeviceService.queryWorkStatus(deviceId,dataSjy);
        return JsonResult.success(stringListMap);
    }

    @ApiOperation(value = "查询设备详情设备监测数据")
    @GetMapping("query-monitoring-data")
    public JsonResult<Object> queryMonitoringData(@RequestParam String deviceId) {
        Map<String, List<WorkStatusMonitorModel>> stringListMap = nxJeDeviceService.queryMonitoringData(deviceId);
        return JsonResult.success(stringListMap);
    }
}
