package com.rootcloud.domain.ao;

import com.rootcloud.domain.model.WorkStatusMonitorModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * @ClassName HistorySituttionAO
 * @Description 获取历史工况参数
 * @Author w-liuyi01
 * @Date 2022/4/20 15:07
 * @Version 1.0
 */
@Data
public class ExportHistorySituationAO {

    @ApiModelProperty("设备ID")
    @NotNull(message = "设备ID不能为空")
    private String deviceId;

    @ApiModelProperty("开始时间")
    private String startTime;

    @ApiModelProperty("结束时间")
    private String endTime;

    @ApiModelProperty("时区")
    private int timeZone;

    @ApiModelProperty("需要导出的工况属性")
    private List<WorkStatusMonitorModel> propertyList;

}
