package com.rootcloud.domain.ao;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotBlank;

/**
 * <p>
 *     订单派工请求参数
 * </p>
 * @author HeJia
 * @since 2022/5/18
 */
@Setter
@Getter
@ApiModel("派工Form")
public class OrderDispatchForm {

    @NotBlank(message = "订单主键不能为空")
    @ApiModelProperty("订单主键")
    private String nxOrderId;

    @NotBlank(message = "服务方式name不能为空")
    @ApiModelProperty("服务方式_NAME")
    private String orderServicemethodName;

    @NotBlank(message = "服务方式code不能为空")
    @ApiModelProperty("服务方式_CODE")
    private String orderServicemethodCode;

    @NotBlank(message = "计划完成时间不能为空")
    @ApiModelProperty("计划完成时间【yyyy-MM-dd HH:mm:ss】")
    private String orderPlanendtime;

    @NotBlank(message = "指派工程师不能为空")
    @ApiModelProperty("指派工程师")
    private String orderAssignengineer;

    @NotBlank(message = "指派工程师ID不能为空")
    @ApiModelProperty("指派工程师ID")
    private String orderAssignengineerid;

    @ApiModelProperty("协助工程师")
    private String orderAssistengineer;

    @ApiModelProperty("协助工程师ID")
    private String orderAssistengineerid;
}
