package com.rootcloud.domain.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.rootcloud.domain.entity.GbsjbEntity;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;
import java.util.Map;

/**
 * 过保商机表
 * 
 * @author lipingan
 * @email lpa2273597772@163.com
 * @date 2022-04-12 14:22:17
 */
@Mapper
public interface GbsjbDao extends BaseMapper<GbsjbEntity> {

    @Select("select * from je_core_enduser where loginlocked = '1'")
    List<Map<String,String>> queryLockUser();

    @Update("update je_core_enduser set loginlocked='0' where loginlocked = '1'")
    void unLockUser();

    @Select("select * from cftjpzb limit 1")
    Map<String,String> selectOne();

    @Select({
            "<script>",
            "select group_concat(userid) from (",
            "select",
            "userid",
            "from je_core_role_user",
            "where ROLEID in",
            "<foreach collection='roleList' item='id' open='(' separator=',' close=')'>",
            "#{id}",
            "</foreach> group by userid) t",
            "</script>"})
    String queryUserIds(@Param("roleList") List<String> roleList);



    @Select({
            "<script>",
            "select",
            "COMPANYEMAIL as email,userid as userId,USERNAME as userName",
            "from je_core_enduser",
            "where userid  = #{userId} ",
            "and COMPANYEMAIL IS NOT NULL AND COMPANYEMAIL !='' ",
            "</script>"})
    Map<String,String> selectByUserId(@Param("userId")String userId);
}
