package com.rootcloud.domain.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.rootcloud.config.auth.LoginUserInfo;
import com.rootcloud.config.auth.UserInfo;
import com.rootcloud.domain.dto.EnterpriseInfoDTO;
import com.rootcloud.domain.dto.UserRoleDeptDTO;
import com.rootcloud.domain.entity.JeCoreEnduserEntity;
import com.rootcloud.domain.entity.SiteDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 人员表
 * 
 * @author lipingan
 * @email lpa2273597772@163.com
 * @date 2022-04-12 14:22:06
 */
@Mapper
public interface JeCoreEnduserDao extends BaseMapper<JeCoreEnduserEntity> {


    LoginUserInfo getUserInfo(String userId);

    SiteDTO getSiteByUserId(String userId);

    String getCustomsBySiteAreaName(String areaName);

    String getCustomByUserId(String userId);

    EnterpriseInfoDTO getTenantInfo(String userId);

    String getTenantInfoNOSQL(String userId);

    UserRoleDeptDTO getUserLoginInfo(String userId);

    String getRolesByUserId(String userId);

    UserInfo getUser(String userId);

    List<JeCoreEnduserEntity> getUserListByRole(@Param("role") String role,@Param("zhid") String zhid);

    String getDataByKey(String key);
}
