package com.rootcloud.domain.dao;
import com.rootcloud.domain.vo.DeviceListVO;
import com.rootcloud.domain.vo.NxDeviceVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 宁夏共享-设备台账表DAO  --nx_je_device存储从4.0同步过来的物模型、物实例信息，modeId thingId
 * nx_jcxx_sblb 表为设备档案主表，除了从nx_je_device同步过来的设备外，还要存用户录入的设备信息
 * */

@Mapper
public interface NxDeviceDao {

    //查询设备类型、编号、物模型ID,物实例ID
    List<NxDeviceVO> getDeviceList(NxDeviceVO deviceVO);
    List<NxDeviceVO> getDeviceById(NxDeviceVO deviceVO);
    List<NxDeviceVO> getDeviceList2();

    //查询指定用户下所有的设备列表  --目前不存在这个关系
//    List<String> getDeviceListByUserId(@Param("userId")String userId, @Param("tenantId")String tenantId);

    //查询指定客户(机构)下所有的设备列表 --只返回设备编号
    List<String> getDeviceCodeListByCustomerCode(@Param("officeIds") List<String> officeIds, @Param("tenantId") String tenantId);

    //查询指定客户(机构)下所有的设备列表 --返回设备编号、名称等
    List<DeviceListVO> getDeviceListByCustomerId(@Param("officeId") String officeId, @Param("tenantId") String tenantId);


    List<NxDeviceVO> getDeviceListEurope(NxDeviceVO deviceVO);

}
