package com.rootcloud.domain.dao;

import com.rootcloud.domain.vo.PrinterEfficiencyWorkVO;
import com.rootcloud.web.dto.PrinterReportDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

@Mapper
public interface PrinterEfficiencyWorkDao {

    //测试
    List<Map<String, Object>> getPrinterEfficiencyData(@Param("year") int year, @Param("month") int monthValue, @Param("day") int dayOfMonth);

    //清理
    void clear(@Param("year") int year, @Param("month") int month, @Param("day") int day);
    // 批量新增
    void batchAdd(@Param("dataList") List<PrinterEfficiencyWorkVO> dataList,
                  @Param("year") int year, @Param("month") int month, @Param("day") int day);


    //单台机
    void clear2(@Param("year") int year, @Param("month") int month, @Param("day") int day);
    void batchAdd2(@Param("dataList") List<PrinterEfficiencyWorkVO> dataList,
                   @Param("year") int year, @Param("month") int month, @Param("day") int day);

    /**
     * 打印耗时
     */
    List<Map<String,Object>> getReportDYHSByDevice(PrinterReportDTO printerReportDTO);
    /**
     * 打印效率
     */
    List<Map<String,Object>> getReportDYXLByDevice(PrinterReportDTO printerReportDTO);
    /**
     * 布图率
     */
    List<Map<String,Object>> getReportBTLByDevice(PrinterReportDTO printerReportDTO);



}
