package com.rootcloud.domain.dao;

import com.rootcloud.domain.vo.RepPrinterEmailConfigVO;
import com.rootcloud.domain.vo.RepPrinterReportVO;
import com.rootcloud.domain.vo.RepPrinterWasteTypeVO;
import com.rootcloud.web.dto.PrinterReportDTO;
import com.rootcloud.web.dto.UpdateUserReportDTO;
import com.rootcloud.web.dto.WeiXuFeiYongTongJiDto;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;
import java.util.Map;

@Mapper
public interface RepPrinterReportDAO {

    /***
     *
     * @Title: insert
     * @Description: 新增
     * @param vo
     * @return
     */
    void insert(RepPrinterReportVO vo);

    /**
     *	根据用户报告id修改发送人字段信息
     */
    void updateEmailsById(Map<String, Object> params);

    /**
     *	修改用户报告备注
     */
    void updateUserReport(UpdateUserReportDTO params);

    /**
     *	根据id删除报告信息
     */
    void deleteReportById(Map<String, Object> params);

    /**
     * 	根据条件查询用户报告
     */
    List<RepPrinterReportVO> getPrinterUserReports(Map<String, Object> params);

    //分页
    List<RepPrinterReportVO> getPrinterUserReportsList(Map<String, Object> params);
    List<RepPrinterReportVO> getPrinterUserReportsCount(Map<String, Object> params);

    /**
     * 根据客户信息，查询客户邮箱配置
     */
    List<RepPrinterEmailConfigVO> getPrinterEmailConfigs(Map<String, Object> params);

    /**
     *  获取废品原因分类
     */
    List<RepPrinterWasteTypeVO> getRepPrinterWasteTypes();

    void updateUserReportValue(RepPrinterReportVO vo);

    List<WeiXuFeiYongTongJiDto> weiXuFeiYongTongJi(PrinterReportDTO printerReportDTO);

    List<WeiXuFeiYongTongJiDto> weiXuFeiYongTongJiV2(PrinterReportDTO printerReportDTO);

    List<WeiXuFeiYongTongJiDto> weiXuFeiYongTongJiWeiBo(PrinterReportDTO printerReportDTO);

}
