package com.rootcloud.domain.dao;

import com.rootcloud.domain.vo.RepPrinterSandPercentVO;
import com.rootcloud.web.dto.GuHuaJiDanHaoDto;
import com.rootcloud.web.dto.PinJunDaYinGaoDuDto;
import com.rootcloud.web.dto.PrinterReportDTO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;
import java.util.Set;

@Mapper
public interface RepPrinterSandPercentDAO {

    /***
     *
     * @Title: insert
     * @Description: 新增
     * @param vo
     * @return
     */
    void insert(RepPrinterSandPercentVO vo);

    /***
     *
     * @Title: update
     * @Description: 更新
     * @param vo
     * @return
     */
    void update(RepPrinterSandPercentVO vo);

    /***
     *
     * @Title: deleteById
     * @Description: 删除
     * @param id
     * @return
     */
    void deleteById(@Param("id") Long id);

    /***
     *
     * @Title: getRepPrinterSandPercentList
     * @Description: 获取数据集
     * @param params
     * @return List
     */
    List<Map<String,Object>> getRepPrinterSandPercentList(PrinterReportDTO printerReportDTO);

    List<Map<String,Object>> getRepPrinterSandSXMDList(PrinterReportDTO printerReportDTO);
    List<Map<String,Object>> getRepPrinterSandSXMDListV2(PrinterReportDTO printerReportDTO);
    //针对产业创新中心\潍坊的设备(陶粒砂1.5，其他1.4)
    List<Map<String,Object>> getRepPrinterSandSXMDListV3(PrinterReportDTO printerReportDTO);

    List<Map<String,Object>> getRepPrinterSandXJSZBList(PrinterReportDTO printerReportDTO);

    List<Map<String,Object>> getRepPrinterSandLSLList(PrinterReportDTO printerReportDTO);
    List<Map<String,Object>> getRepPrinterSandLSLListV2(PrinterReportDTO printerReportDTO);


    /**
     * 批量新增
     */
    void batchAdd(@Param("dataList") List<RepPrinterSandPercentVO> dataList,
                  @Param("year") int year, @Param("month") int month, @Param("day") int day);

    /**
     * 清空某天的数据
     */
    void clear(@Param("year") int year, @Param("month") int month, @Param("day") int day);

    /***
     *
     * @Title: getRepPrinterVolumeList
     * @Description: 获取打印机体积
     * @param printerReportDTO
     * @return List
     */
    List<Map<String,Object>> getRepPrinterVolumeList(PrinterReportDTO printerReportDTO);

    List<RepPrinterSandPercentVO>  getVosByJobIds(@Param("deviceId") String deviceId, @Param("jobIds") Set<String> jobIds
            , @Param("startDate") String startDate);

    List<PinJunDaYinGaoDuDto> pinJunDaYinGaoDu(PrinterReportDTO printerReportDTO);
    List<PinJunDaYinGaoDuDto> pinJunDaYinGaoDuV2(PrinterReportDTO printerReportDTO);


    List<GuHuaJiDanHaoDto> guHuaJiDanHao(PrinterReportDTO printerReportDTO);
    List<GuHuaJiDanHaoDto> guHuaJiDanHaoV2(PrinterReportDTO printerReportDTO);

    //提取打印耗时
    List<RepPrinterSandPercentVO> getHimTimesByDeviceCode(@Param("device_id") String device_id,
                                                          @Param("data_year") String data_year,
                                                          @Param("data_month") String data_month,
                                                          @Param("data_day") String data_day
    );

    //提取打印耗时
    List<RepPrinterSandPercentVO> getHimTimesByDeviceCode2(@Param("deviceId") String deviceId,
                                                           @Param("dataYear") String dataYear,
                                                           @Param("dataMonth") String dataMonth,
                                                           @Param("dataDay") String dataDay
    );

}
