package com.rootcloud.domain.dao;

import com.rootcloud.domain.vo.RepStarEvaluateVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 星级评价计算分析模型DAO
 * */
@Mapper
public interface RepPrinterStarEvaluateDAO {
    void addScore(RepStarEvaluateVO obj);

    void batchAdd(@Param("dataList") List<RepStarEvaluateVO> dataList);

    void deleteStarEvaluateByDate(@Param("data_year") String data_year, @Param("data_month") String data_month, @Param("statistics_type") String statistics_type, @Param("deviceIdList") List<String> deviceIdList);

    /**
     * 清空某天的数据
     */
    void ClearnStarEvaluateByDate(@Param("data_year") String data_year,
                                  @Param("data_month") String data_month);


    List<RepStarEvaluateVO> QueryCustomerInfo(@Param("officeid") String officeid);
    List<Map<String, String>> selectDistinctOfficeList(Map<String, Object> query);
    List<Map<String, String>> selectCurrentOfficeList(Map<String, Object> query);

    List<Map<String, String>> selectDistinctDeviceList(Map<String, Object> query);

    List<RepStarEvaluateVO> QueryCustomerDeviceInfo(@Param("officeid") String officeid,
                                                    @Param("jixing") String jixing,
                                                    @Param("devicetypeid") String devicetypeid,
                                                    @Param("data_year") String data_year,
                                                    @Param("data_month") String data_month);


    List<RepStarEvaluateVO> starEvaluateByCustomer(@Param("officeid") String officeid,
                                                   @Param("jixing") String jixing,
                                                   @Param("devicetypeid") String devicetypeid,
                                                   @Param("data_year") String data_year,
                                                   @Param("data_month") String data_month);

    List<RepStarEvaluateVO>  QueryDeviceInfo(@Param("officeid") String officeid,
                                             @Param("jixing") String jixing,
                                             @Param("devicetypeid") String devicetypeid,
                                             @Param("data_year") String data_year,
                                             @Param("data_month") String data_month);

}
