package com.rootcloud.domain.dao;

import com.rootcloud.domain.vo.RepPrinterTargetDicVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

@Mapper
public interface RepPrinterTargetDicDAO {

    /***
     *
     * @Title: insert
     * @Description: 新增
     * @param vo
     * @return
     */
    void insert(RepPrinterTargetDicVO vo);

    /***
     *
     * @Title: update
     * @Description: 更新
     * @param vo
     * @return
     */
    void update(RepPrinterTargetDicVO vo);

    /***
     *
     * @Title: deleteById
     * @Description: 删除
     * @param id
     * @return
     */
    void deleteById(@Param("id") Long id);

    /***
     *
     * @Title: getRepPrinterTargetDicById
     * @Description: 获取数据集
     * @param params id
     * @return RepPrinterTargetDicVO
     */
    RepPrinterTargetDicVO getRepPrinterTargetDicById(@Param("id") Long id);

    RepPrinterTargetDicVO getRepPrinterTargetDicByKey(@Param("statisticsType") String statisticsType, @Param("customerId") String customerId);


    /***
     *
     * @Title: getRepPrinterTargetDicList
     * @Description: 获取数据集
     * @param params
     * @return List
     */
    List<RepPrinterTargetDicVO> getRepPrinterTargetDicList(Map<String, Object> params);
    List<RepPrinterTargetDicVO> getRepPrinterTargetDicListCount(Map<String, Object> params);
    /**
     * 按统计类型分组获取最新目标值
     */
    List<RepPrinterTargetDicVO> groupByPrinterTargetDic();
}
