package com.rootcloud.domain.dao.gkjk;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.rootcloud.domain.dto.DeviceVO;
import com.rootcloud.domain.entity.NxJeDeviceEntity;
import com.rootcloud.vo.device.DeviceTypeVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

/**
 * 宁夏_设备台账
 *
 * @author lipingan
 * @email lpa2273597772@163.com
 * @date 2022-04-18 15:19:58
 */
@Mapper
public interface NxJeDeviceDao extends BaseMapper<NxJeDeviceEntity> {

    @Select({"<script>",
        " select DEVICE_SBBM AS deviceCode,DEVICE_SOURCE AS deviceSource,DEVICE_SBMC AS deviceName,DEVICE_SBLX AS deviceType,DEVICE_SBXH_NAME AS deviceSbxh,DEVICE_SBCCRQ AS deviceFactoryDate,",
        " (SELECT sum(ONLINED_TIMES) FROM nx_device_working_times_month  WHERE  DEVICE_ID = NX_JE_DEVICE_ID and DATE_FORMAT( TIME, '%Y-%m' ) =  DATE_FORMAT( SYSDATE(), '%Y-%m' )  GROUP BY  DATE_FORMAT( TIME, '%Y-%m-%d' ),DEVICE_ID ) AS onlineTime FROM nx_je_device", "where NX_JE_DEVICE_ID = #{deviceId}", "</script>"})
    DeviceTypeVO getByDeviceId(@Param("deviceId") String deviceId);

    /**
     * 查询设备list分页数据
     *
     * @param page
     *            分页对象
     * @param queryData
     *            查询条件(支持地点、状态、型号、名称)
     * @param isCare
     *            是否重要
     *
     * @param khmc 客户名称
     *
     * @return 分页数据
     */
    IPage<DeviceVO> devicePage(IPage<DeviceVO> page, @Param("queryData") String queryData,
        @Param("isCare") String isCare, @Param("khmc") String khmc, @Param("kh") String kh,@Param("syZhid") String syZhid);
}
