package com.rootcloud.domain.dto;


import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.util.Date;
import java.util.Objects;

/**
 * A DTO for the EnterpriseInfo entity.
 * 复制云杉的tenant-info接口返回的实体类
 */
public class EnterpriseInfoDTO implements Serializable {

    private Long id;

    private String tenantId;

    @Length(max=200)
    private String enterpriseName;

    @Length(max=50)
    private String enterpriseAbbreviation;

    private String userId;

    private String userName;

    private String loginName;

    @Length(max=500)
    private String enterprisePhoto;

    @Length(max=500)
    private String enterpriseMiniPhoto;

	private String phone;

    private String email;

    private String phoneNew;

    private String emailNew;

    private String enterpriseType;

    @Length(max=200)
    private String address;

    @Length(max=200)
    private String detailedAddress;

    private Integer enterpriseAge;

    @Length(max=200)
    private String enterpriseScale;

    @Length(max=200)
    private String enterpriseWebSite;

    private String enterprisePhone;

    private String enterpriseFax;

    @Length(max=600)
    private String enterpriseDesc;

    private Integer deleteFlag;

    private String targetUserId;

    private Integer support;

    private String targetUserName;

    private Date expireDate;

    private Date openDate;

    @Size(max = 10)
    private String industryId;

    @Size(max = 45)
    private String industry;

    @Size(max = 10)
    private String domainId;

    @Size(max = 45)
    private String domain;

    @Min(value = 0)
    @Max(value = 255)
    private Integer status;

    @Size(max = 256)
    private String remark;

    private Integer cycle;

    private Integer idtType;

    private String originate;

    private Date updateDate;
    private Date createDate;

    private String taxpayerNo;

    private String browserIcon;

    private String browserIconName;

    /**
     * 浅色系统图标
     */
    private String systemIcon;

    private String loginPage;

    private String bgColor;

    private String appSplashScreen;

    private Boolean homepageEnabled;

    private String homepageUrl;

    private String cardIconType;

    private Boolean headHiddenStatus;
    /**
     * 顶级机构id, 消息推送用
     */
    private Long deptId;
    /**
     * 客户性质 0(企业) 1(个人)
     */
    private Integer cusProperty;
    /**
     * 客户性质名称
     */
    private String cusPropertyName;
    /**
     * 企业联系电话(多个数据用逗号拼接)
     */
    private String comPhones;
    /**
     * 身份证号
     */
    private String idCard;
    /**
     * 深色系统图标
     */
    private String systemIconDeep;

    /**租户级参数配置*/
    private String profile;

    public String getProfile() {
        return profile;
    }

    public void setProfile(String profile) {
        this.profile = profile;
    }

    public String getSystemIconDeep() {
        return systemIconDeep;
    }

    public void setSystemIconDeep(String systemIconDeep) {
        this.systemIconDeep = systemIconDeep;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTenantId() {
        return tenantId;
    }

    public void setTenantId(String tenantId) {
        this.tenantId = tenantId;
    }

    public String getEnterpriseName() {
        return enterpriseName;
    }

    public void setEnterpriseName(String enterpriseName) {
        this.enterpriseName = enterpriseName;
    }

    public String getEnterpriseAbbreviation() {
        return enterpriseAbbreviation;
    }

    public void setEnterpriseAbbreviation(String enterpriseAbbreviation) {
        this.enterpriseAbbreviation = enterpriseAbbreviation;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public String getEnterprisePhoto() {
        return enterprisePhoto;
    }

    public void setEnterprisePhoto(String enterprisePhoto) {
        this.enterprisePhoto = enterprisePhoto;
    }

    public String getEnterpriseMiniPhoto() {
		return enterpriseMiniPhoto;
	}

	public void setEnterpriseMiniPhoto(String enterpriseMiniPhoto) {
		this.enterpriseMiniPhoto = enterpriseMiniPhoto;
	}

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPhoneNew() {
        return phoneNew;
    }

    public void setPhoneNew(String phoneNew) {
        this.phoneNew = phoneNew;
    }

    public String getEmailNew() {
        return emailNew;
    }

    public void setEmailNew(String emailNew) {
        this.emailNew = emailNew;
    }

    public String getEnterpriseType() {
        return enterpriseType;
    }

    public void setEnterpriseType(String enterpriseType) {
        this.enterpriseType = enterpriseType;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getDetailedAddress() {
        return detailedAddress;
    }

    public void setDetailedAddress(String detailedAddress) {
        this.detailedAddress = detailedAddress;
    }

    public Integer getEnterpriseAge() {
        return enterpriseAge;
    }

    public void setEnterpriseAge(Integer enterpriseAge) {
        this.enterpriseAge = enterpriseAge;
    }

    public String getEnterpriseScale() {
        return enterpriseScale;
    }

    public void setEnterpriseScale(String enterpriseScale) {
        this.enterpriseScale = enterpriseScale;
    }

    public String getEnterpriseWebSite() {
        return enterpriseWebSite;
    }

    public void setEnterpriseWebSite(String enterpriseWebSite) {
        this.enterpriseWebSite = enterpriseWebSite;
    }

    public String getEnterprisePhone() {
        return enterprisePhone;
    }

    public void setEnterprisePhone(String enterprisePhone) {
        this.enterprisePhone = enterprisePhone;
    }

    public String getEnterpriseFax() {
        return enterpriseFax;
    }

    public void setEnterpriseFax(String enterpriseFax) {
        this.enterpriseFax = enterpriseFax;
    }

    public String getEnterpriseDesc() {
        return enterpriseDesc;
    }

    public void setEnterpriseDesc(String enterpriseDesc) {
        this.enterpriseDesc = enterpriseDesc;
    }

    public Integer getDeleteFlag() {
        return deleteFlag;
    }

    public void setDeleteFlag(Integer deleteFlag) {
        this.deleteFlag = deleteFlag;
    }

    public String getTargetUserId() {
        return targetUserId;
    }

    public void setTargetUserId(String targetUserId) {
        this.targetUserId = targetUserId;
    }

    public String getTargetUserName() {
        return targetUserName;
    }

    public void setTargetUserName(String targetUserName) {
        this.targetUserName = targetUserName;
    }

    public Integer getSupport() {
        return support;
    }

    public void setSupport(Integer support) {
        this.support = support;
    }


    public Date getExpireDate() {
        return expireDate;
    }

    public void setExpireDate(Date expireDate) {
        this.expireDate = expireDate;
    }

    public String getIndustryId() {
        return industryId;
    }

    public void setIndustryId(String industryId) {
        this.industryId = industryId;
    }

    public String getIndustry() {
        return industry;
    }

    public void setIndustry(String industry) {
        this.industry = industry;
    }

    public String getDomainId() {
        return domainId;
    }

    public void setDomainId(String domainId) {
        this.domainId = domainId;
    }

    public String getDomain() {
        return domain;
    }

    public void setDomain(String domain) {
        this.domain = domain;
    }


    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }


    public Integer getCycle() {
        return cycle;
    }

    public void setCycle(Integer cycle) {
        this.cycle = cycle;
    }

    public Integer getIdtType() {
        return idtType;
    }

    public void setIdtType(Integer idtType) {
        this.idtType = idtType;
    }

    public Date getOpenDate() {
        return openDate;
    }

    public void setOpenDate(Date openDate) {
        this.openDate = openDate;
    }

    public String getOriginate() {
        return originate;
    }

    public void setOriginate(String originate) {
        this.originate = originate;
    }

    public Date getUpdateDate() {
        return updateDate;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }

    public String getTaxpayerNo() {
        return taxpayerNo;
    }

    public void setTaxpayerNo(String taxpayerNo) {
        this.taxpayerNo = taxpayerNo;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public String getBrowserIcon() {
        return browserIcon;
    }

    public void setBrowserIcon(String browserIcon) {
        this.browserIcon = browserIcon;
    }

    public String getSystemIcon() {
        return systemIcon;
    }

    public void setSystemIcon(String systemIcon) {
        this.systemIcon = systemIcon;
    }

    public String getLoginPage() {
        return loginPage;
    }

    public void setLoginPage(String loginPage) {
        this.loginPage = loginPage;
    }

    public String getBgColor() {
        return bgColor;
    }

    public void setBgColor(String bgColor) {
        this.bgColor = bgColor;
    }

    public String getBrowserIconName() {
        return browserIconName;
    }

    public void setBrowserIconName(String browserIconName) {
        this.browserIconName = browserIconName;
    }


    public String getAppSplashScreen() {
        return appSplashScreen;
    }

    public void setAppSplashScreen(String appSplashScreen) {
        this.appSplashScreen = appSplashScreen;
    }

    public Boolean getHomepageEnabled() {
        return homepageEnabled;
    }

    public void setHomepageEnabled(Boolean homepageEnabled) {
        this.homepageEnabled = homepageEnabled;
    }

    public String getHomepageUrl() {
        return homepageUrl;
    }

    public void setHomepageUrl(String homepageUrl) {
        this.homepageUrl = homepageUrl;
    }

    public Long getDeptId() {
        return deptId;
    }

    public void setDeptId(Long deptId) {
        this.deptId = deptId;
    }

    public Integer getCusProperty() {
        return cusProperty;
    }

    public String getComPhones() {
        return comPhones;
    }

    public void setComPhones(String comPhones) {
        this.comPhones = comPhones;
    }

    public String getCusPropertyName() {
        return cusPropertyName;
    }

    public void setCusPropertyName(String cusPropertyName) {
        this.cusPropertyName = cusPropertyName;
    }

    public String getIdCard() {
        return idCard;
    }

    public void setIdCard(String idCard) {
        this.idCard = idCard;
    }

    public String getCardIconType() {
        return cardIconType;
    }

    public void setCardIconType(String cardIconType) {
        this.cardIconType = cardIconType;
    }

    public Boolean getHeadHiddenStatus() {
        return headHiddenStatus;
    }

    public void setHeadHiddenStatus(Boolean headHiddenStatus) {
        this.headHiddenStatus = headHiddenStatus;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }

        EnterpriseInfoDTO enterpriseInfoDTO = (EnterpriseInfoDTO) o;
        if(enterpriseInfoDTO.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), enterpriseInfoDTO.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "EnterpriseInfoDTO{" +
            "id=" + id +
            ", tenantId='" + tenantId + '\'' +
            ", enterpriseName='" + enterpriseName + '\'' +
            ", enterpriseAbbreviation='" + enterpriseAbbreviation + '\'' +
            ", userId='" + userId + '\'' +
            ", userName='" + userName + '\'' +
            ", enterprisePhoto='" + enterprisePhoto + '\'' +
            ", enterpriseMiniPhoto='" + enterpriseMiniPhoto + '\'' +
            ", phone='" + phone + '\'' +
            ", email='" + email + '\'' +
            ", enterpriseType='" + enterpriseType + '\'' +
            ", address='" + address + '\'' +
            ", detailedAddress='" + detailedAddress + '\'' +
            ", enterpriseAge=" + enterpriseAge +
            ", enterpriseScale='" + enterpriseScale + '\'' +
            ", enterpriseWebSite='" + enterpriseWebSite + '\'' +
            ", enterprisePhone='" + enterprisePhone + '\'' +
            ", enterpriseFax='" + enterpriseFax + '\'' +
            ", enterpriseDesc='" + enterpriseDesc + '\'' +
            ", deleteFlag=" + deleteFlag +
            ", targetUserId='" + targetUserId + '\'' +
            ", support=" + support +
            ", targetUserName='" + targetUserName + '\'' +
            ", expireDate=" + expireDate +
            ", openDate=" + openDate +
            ", industryId='" + industryId + '\'' +
            ", industry='" + industry + '\'' +
            ", domainId='" + domainId + '\'' +
            ", domain='" + domain + '\'' +
            ", status=" + status +
            ", remark='" + remark + '\'' +
            ", cycle=" + cycle +
            ", idtType=" + idtType +
            ", originate='" + originate + '\'' +
            ", updateDate=" + updateDate +
            ", taxpayerNo='" + taxpayerNo + '\'' +
            '}';
    }
}
