package com.rootcloud.domain.dto;

import java.io.Serializable;
import java.sql.Timestamp;

public class UserRoleDeptDTO implements Serializable {

    private Long id;
    private String tenantId;
    private String userId;
    private String userName;
    private String nickName;
    private String loginName;
    private String userMobile;
    private String userEmail;
    private String employeeCode;
    /**
     * 1男 2女
     */
    private Integer sex;
    /**
     * 用户类型（0 机构用户 1代理商用户 2 终端客户用户）
     */
    private Integer userType;
    /**
     * 数据类型 0：系统数据（初始化数据） 1：业务数据
     */
    private Integer dataType;
    /**
     * '0：未激活；1 ：激活状态；2：邀请状态',
     */
    private Integer status;
    private Timestamp createDateTime;
    private Timestamp updateDateTime;
    private String createName;
    private String photo;
    private Integer passwordWhetherModifiedFlag;

    /**
     * 最近新增数据-用于新增用户时登录页面使用判断是否是刚新增用户，不影响旧账号使用 默认是0 若是1
     */
    private Integer recentAddFlag;
    private String contactWay;
    private String employeePosition;
    /**
     * 角色Id
     */
    private String roleIds;
    /**
     * 角色名称
     */
    private String roleNames;
    private String deptIds;
    private String deptNames;
    /**
     * 树根管理员 0 为否  1  是
     */
    private Boolean supper;
    private String theme;
    private String style;

    private Integer tenantConservator;


    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTenantId() {
        return tenantId;
    }

    public void setTenantId(String tenantId) {
        this.tenantId = tenantId;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getNickName() {
        return nickName;
    }

    public void setNickName(String nickName) {
        this.nickName = nickName;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getUserMobile() {
        return userMobile;
    }

    public void setUserMobile(String userMobile) {
        this.userMobile = userMobile;
    }

    public String getUserEmail() {
        return userEmail;
    }

    public void setUserEmail(String userEmail) {
        this.userEmail = userEmail;
    }

    public String getEmployeeCode() {
        return employeeCode;
    }

    public void setEmployeeCode(String employeeCode) {
        this.employeeCode = employeeCode;
    }

    public Integer getSex() {
        return sex;
    }

    public void setSex(Integer sex) {
        this.sex = sex;
    }

    public Integer getUserType() {
        return userType;
    }

    public void setUserType(Integer userType) {
        this.userType = userType;
    }

    public Integer getDataType() {
        return dataType;
    }

    public void setDataType(Integer dataType) {
        this.dataType = dataType;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Timestamp getCreateDateTime() {
        return createDateTime;
    }

    public void setCreateDateTime(Timestamp createDateTime) {
        this.createDateTime = createDateTime;
    }

    public Timestamp getUpdateDateTime() {
        return updateDateTime;
    }

    public void setUpdateDateTime(Timestamp updateDateTime) {
        this.updateDateTime = updateDateTime;
    }

    public String getCreateName() {
        return createName;
    }

    public void setCreateName(String createName) {
        this.createName = createName;
    }

    public String getPhoto() {
        return photo;
    }

    public void setPhoto(String photo) {
        this.photo = photo;
    }

    public Integer getPasswordWhetherModifiedFlag() {
        return passwordWhetherModifiedFlag;
    }

    public void setPasswordWhetherModifiedFlag(Integer passwordWhetherModifiedFlag) {
        this.passwordWhetherModifiedFlag = passwordWhetherModifiedFlag;
    }

    public Integer getRecentAddFlag() {
        return recentAddFlag;
    }

    public void setRecentAddFlag(Integer recentAddFlag) {
        this.recentAddFlag = recentAddFlag;
    }

    public String getContactWay() {
        return contactWay;
    }

    public void setContactWay(String contactWay) {
        this.contactWay = contactWay;
    }

    public String getEmployeePosition() {
        return employeePosition;
    }

    public void setEmployeePosition(String employeePosition) {
        this.employeePosition = employeePosition;
    }

    public String getRoleIds() {
        return roleIds;
    }

    public void setRoleIds(String roleIds) {
        this.roleIds = roleIds;
    }

    public String getRoleNames() {
        return roleNames;
    }

    public void setRoleNames(String roleNames) {
        this.roleNames = roleNames;
    }

    public String getDeptIds() {
        return deptIds;
    }

    public void setDeptIds(String deptIds) {
        this.deptIds = deptIds;
    }

    public String getDeptNames() {
        return deptNames;
    }

    public void setDeptNames(String deptNames) {
        this.deptNames = deptNames;
    }

    public Boolean getSupper() {
        return supper;
    }

    public void setSupper(Boolean supper) {
        this.supper = supper;
    }

    public String getTheme() {
        return theme;
    }

    public void setTheme(String theme) {
        this.theme = theme;
    }

    public String getStyle() {
        return style;
    }

    public void setStyle(String style) {
        this.style = style;
    }

    public Integer getTenantConservator() {
        return tenantConservator;
    }

    public void setTenantConservator(Integer tenantConservator) {
        this.tenantConservator = tenantConservator;
    }

    @Override
    public String toString() {
        return "UserRoleDeptDTO{" +
            "id=" + id +
            ", tenantId='" + tenantId + '\'' +
            ", userId='" + userId + '\'' +
            ", userName='" + userName + '\'' +
            ", nickName='" + nickName + '\'' +
            ", loginName='" + loginName + '\'' +
            ", userMobile='" + userMobile + '\'' +
            ", userEmail='" + userEmail + '\'' +
            ", employeeCode='" + employeeCode + '\'' +
            ", sex=" + sex +
            ", userType=" + userType +
            ", dataType=" + dataType +
            ", status=" + status +
            ", createDateTime=" + createDateTime +
            ", updateDateTime=" + updateDateTime +
            ", createName='" + createName + '\'' +
            ", photo='" + photo + '\'' +
            ", passwordWhetherModifiedFlag=" + passwordWhetherModifiedFlag +
            ", recentAddFlag=" + recentAddFlag +
            ", contactWay='" + contactWay + '\'' +
            ", employeePosition='" + employeePosition + '\'' +
            ", roleIds='" + roleIds + '\'' +
            ", roleNames='" + roleNames + '\'' +
            ", deptIds='" + deptIds + '\'' +
            ", deptNames='" + deptNames + '\'' +
            '}';
    }
}
