package com.rootcloud.domain.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * @Author w-yanxiang
 * @Date 2022/6/16 9:58
 * @Version 1.0
 * @Description 轮播图实体类
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="CarouselEntity对象", description="轮播图")
@TableName("NXGX_LBXX")
public class CarouselEntity implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "参数类型")
    @TableField("LBXX_CSLX")
    private String lbxxCslx;

    @ApiModelProperty(value = "参数值")
    @TableField("LBXX_CSZ")
    private String lbxxCsz;

    @ApiModelProperty(value = "是否生效")
    @TableField("LBXX_SFSX")
    private String lbxxSfsx;

    @ApiModelProperty(value = "描述")
    @TableField("LBXX_MS")
    private String lbxxMs;

    @ApiModelProperty(value = "主键ID")
    @TableId(value = "NXGX_LBXX_ID",type = IdType.ASSIGN_UUID)
    private String nxgxLbxxId;

    @ApiModelProperty(value = "登记时间")
    @TableField("SY_CREATETIME")
    private String syCreatetime;


    @ApiModelProperty(value = "登记人主键")
    @TableField("SY_CREATEUSERID")
    private String syCreateuserid;

    @ApiModelProperty(value = "租户id")
    @TableField("SY_ZHID")
    private String syZhid;

}
