package com.rootcloud.domain.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import java.math.BigDecimal;
import java.io.Serializable;
import java.util.Date;
import lombok.Data;

/**
 * 人员表
 * 
 * @author lipingan
 * @email lpa2273597772@163.com
 * @date 2022-04-12 14:22:06
 */
@Data
@TableName("je_core_enduser")
public class JeCoreEnduserEntity implements Serializable {
	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	@TableId
	private String userid;
	/**
	 * 审核标记
	 */
	private String audflag;
	/**
	 * 登记者所在部门编码
	 */
	private String createorg;
	/**
	 * 登记者所在部门名称
	 */
	private String createorgname;
	/**
	 * 登记时间
	 */
	private String createtime;
	/**
	 * 登记人编码
	 */
	private String createuser;
	/**
	 * 登记人姓名
	 */
	private String createusername;
	/**
	 * 是否启用本条数据
	 */
	private String flag;
	/**
	 * 修改人部门编码
	 */
	private String modifyorg;
	/**
	 * 修改人部门名称
	 */
	private String modifyorgname;
	/**
	 * 修改时间
	 */
	private String modifytime;
	/**
	 * 修改人编码
	 */
	private String modifyuser;
	/**
	 * 修改人姓名
	 */
	private String modifyusername;
	/**
	 * 数据状态
	 */
	private String status;
	/**
	 * 身份证号
	 */
	private String idcard;
	/**
	 * 排序字段
	 */
	private Integer orderindex;
	/**
	 * 密码
	 */
	private String password;
	/**
	 * 员工卡
	 */
	private String usercard;
	/**
	 * 帐号
	 */
	private String usercode;
	/**
	 * 用户名
	 */
	private String username;
	/**
	 * 部门外键
	 */
	private String deptid;
	/**
	 * 流程部署ID
	 */
	private String pdid;
	/**
	 * 流程实例ID
	 */
	private String piid;
	/**
	 * 是否主管
	 */
	private String ismanager;
	/**
	 * 监管部门编码
	 */
	private String monitordeptcode;
	/**
	 * 监管部门名称
	 */
	private String monitordept;
	/**
	 * RTX号
	 */
	private String rtxid;
	/**
	 * 性别
	 */
	private String gender;
	/**
	 * 是否系统用户
	 */
	private String issysuser;
	/**
	 * 工号
	 */
	private String jobnum;
	/**
	 * 简称
	 */
	private String easyname;
	/**
	 * 全称
	 */
	private String fullname;
	/**
	 * 
	 */
	private String deptname;
	/**
	 * 部门编码
	 */
	private String deptcode;
	/**
	 *  角色名称
	 */
	private String rolenames;
	/**
	 * 角色编码
	 */
	private String rolecodes;
	/**
	 * 岗位名称
	 */
	private String sentrynames;
	/**
	 * 岗位编码
	 */
	private String sentrycodes;
	/**
	 * 岗位主键
	 */
	private String sentryids;
	/**
	 * 是否分属部门
	 */
	private String shadow;
	/**
	 * 原用户名
	 */
	private String backusercode;
	/**
	 * 图标
	 */
	private String iconcls;
	/**
	 * 其他证件
	 */
	private String othercard;
	/**
	 * 公司邮箱
	 */
	private String companyemail;
	/**
	 * 其他邮箱
	 */
	private String otheremail;
	/**
	 * 出生年月
	 */
	private String birthday;
	/**
	 * 民族
	 */
	private String nation;
	/**
	 * 籍贯
	 */
	private String nativeplace;
	/**
	 * 文化程度
	 */
	private String degree;
	/**
	 * 婚姻状况
	 */
	private String married;
	/**
	 * 头像
	 */
	private String photo;
	/**
	 * 工作经历
	 */
	private String workexperience;
	/**
	 * 紧急联系人
	 */
	private String contacts;
	/**
	 * 工种
	 */
	private String craftname;
	/**
	 * 工种编码
	 */
	private String craftcode;
	/**
	 * 行政职务
	 */
	private String executivename;
	/**
	 * 行政职务编码
	 */
	private String executivecode;
	/**
	 * 电话
	 */
	private String phone;
	/**
	 * 有效期
	 */
	private String expirydate;
	/**
	 * 失效时间
	 */
	private String failuretime;
	/**
	 * 角色主键
	 */
	private String roleids;
	/**
	 * 座机
	 */
	private String zuoji;
	/**
	 * 部门排序字段
	 */
	private String deptorderindex;
	/**
	 * 用户排序
	 */
	private BigDecimal userorder;
	/**
	 * 集团公司ID
	 */
	private String jtgsid;
	/**
	 * 集团公司名称
	 */
	private String jtgsmc;
	/**
	 * 集团公司代码
	 */
	private String jtgsdm;
	/**
	 * 主题
	 */
	private String theme;
	/**
	 * 公司部门ID
	 */
	private String gsbmid;
	/**
	 * 直属领导
	 */
	private String zsldname;
	/**
	 * 直属领导ID
	 */
	private String zsldid;
	/**
	 * PLUS账号或者手机
	 */
	private String plususercode;
	/**
	 * PLUS密码
	 */
	private String plususerpass;
	/**
	 * PLUS是否记住密码
	 */
	private String plusrememberpass;
	/**
	 * PLUS是否自动登录
	 */
	private String plusautologin;
	/**
	 * 声音
	 */
	private String sound;
	/**
	 * 菜单类型
	 */
	private String menutype;
	/**
	 * 锁定
	 */
	private String loginlocked;
	/**
	 * SAAS用户ID
	 */
	private String zhid;
	/**
	 * SAAS用户名称
	 */
	private String zhmc;
	/**
	 * 登录时间
	 */
	private String logintime;
	/**
	 * 认证手机号
	 */
	private String identphone;
	/**
	 * 登录次数
	 */
	private Integer loginnumber;
	/**
	 * 入职日期
	 */
	private String rzrq;
	/**
	 * 离职日期
	 */
	private String lzrq;
	/**
	 * 是否有效
	 */
	private String valid;
	/**
	 * 在线
	 */
	private String onlinesys;
	/**
	 * 密码是否初始化
	 */
	private String initpassword;
	/**
	 * 年龄
	 */
	private Integer enduserAge;
	/**
	 * 婚姻状况_NAME
	 */
	private String enduserHyzkName;
	/**
	 * 婚姻状况
	 */
	private String enduserHyzkCode;
	/**
	 * 户籍性质_NAME
	 */
	private String enduserHjxzName;
	/**
	 * 户籍性质
	 */
	private String enduserHjxzCode;
	/**
	 * 首次参加工作日期
	 */
	private String enduserSccjgzrq;
	/**
	 * 总工龄
	 */
	private Integer enduserZgl;
	/**
	 * 政治面貌_NAME
	 */
	private String enduserZzmmName;
	/**
	 * 政治面貌
	 */
	private String enduserZzmmCode;
	/**
	 * 身份证反正照
	 */
	private String enduserSfzfzz;
	/**
	 * 联系人关系_NAME
	 */
	private String enduserLxrgxName;
	/**
	 * 联系人关系
	 */
	private String enduserLxrgxCode;
	/**
	 * 紧急联系人地址
	 */
	private String enduserJjlxrdz;
	/**
	 * 紧急联系人电话
	 */
	private String enduserJjlxrdh;
	/**
	 * 员工类型_NAME
	 */
	private String enduserYglxName;
	/**
	 * 员工类型
	 */
	private String enduserYglxCode;
	/**
	 * 试用期_NAME
	 */
	private String enduserSyqName;
	/**
	 * 试用期
	 */
	private String enduserSyqCode;
	/**
	 * 转正日期
	 */
	private String enduserZzrq;
	/**
	 * 司龄年
	 */
	private Integer enduserSln;
	/**
	 * 司龄月
	 */
	private Integer enduserSly;
	/**
	 * 工资开户银行
	 */
	private String enduserGzkhyx;
	/**
	 * 工资卡账号
	 */
	private String enduserGzkzh;
	/**
	 * 社保账号
	 */
	private String enduserSbzh;
	/**
	 * 公积金账号
	 */
	private String enduserGjjzh;
	/**
	 * 手写签名
	 */
	private String enduserSxqm;
	/**
	 * 法人主体_NAME
	 */
	private String enduserFrztName;
	/**
	 * 法人主体
	 */
	private String enduserFrztCode;
	/**
	 * 合同开始时间
	 */
	private String enduserHtkssj;
	/**
	 * 合同结束时间
	 */
	private String enduserHtjssj;
	/**
	 * 签约次数
	 */
	private Integer enduserQycs;
	/**
	 * 合同附件
	 */
	private String enduserHtfj;
	/**
	 * 签约时间
	 */
	private String enduserQysj;
	/**
	 * 合同类型_NAME
	 */
	private String enduserLdhtlxName;
	/**
	 * 合同类型
	 */
	private String enduserLdhtlxCode;
	/**
	 * 合同期限_NAME
	 */
	private String enduserHtqxName;
	/**
	 * 合同期限
	 */
	private String enduserHtqxCode;
	/**
	 * 审核员
	 */
	private String enduserShy;
	/**
	 * 试用期薪资
	 */
	private BigDecimal enduserSyqxz;
	/**
	 * 转正后薪资
	 */
	private BigDecimal enduserZzhxz;
	/**
	 * 是否超级管理员
	 */
	private String isSuperManager;
	/**
	 * unipush消息推送id
	 */
	private String cid;

}
