package com.rootcloud.domain.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 宁夏_待办库
 * </p>
 *
 * @author yangyijun
 * @since 2022-05-27
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="NxTodoLibrary对象", description="宁夏_待办库")
public class NxTodoLibrary implements Serializable {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "设备编码")
    @TableField("DEVICE_CODE")
    private String deviceCode;

    @ApiModelProperty(value = "设备类型")
    @TableField("DEVICE_TYPE")
    private String deviceType;

    @ApiModelProperty(value = "设备型号")
    @TableField("DEVICE_SBXH")
    private String deviceSbxh;

    @ApiModelProperty(value = "设备名称")
    @TableField("DEVICE_NAME")
    private String deviceName;

    @ApiModelProperty(value = "主题")
    @TableField("TITLE")
    private String title;

    @ApiModelProperty(value = "操作")
    @TableField("OPERATION")
    private String operation;

    @ApiModelProperty(value = "时间")
    @TableField("TIME")
    private String time;

    @ApiModelProperty(value = "内容")
    @TableField("CONTENT")
    private String content;

    @ApiModelProperty(value = "主键ID")
    @TableId(value = "NX_TODO_LIBRARY_ID")
    private String nxTodoLibraryId;

    @ApiModelProperty(value = "审核标记")
    @TableField("SY_AUDFLAG")
    private String syAudflag;

    @ApiModelProperty(value = "登记部门主键")
    @TableField("SY_CREATEORGID")
    private String syCreateorgid;

    @ApiModelProperty(value = "登记部门编码")
    @TableField("SY_CREATEORG")
    private String syCreateorg;

    @ApiModelProperty(value = "登记部门")
    @TableField("SY_CREATEORGNAME")
    private String syCreateorgname;

    @ApiModelProperty(value = "登记时间")
    @TableField("SY_CREATETIME")
    private String syCreatetime;

    @ApiModelProperty(value = "登记人主键")
    @TableField("SY_CREATEUSERID")
    private String syCreateuserid;

    @ApiModelProperty(value = "登记人编码")
    @TableField("SY_CREATEUSER")
    private String syCreateuser;

    @ApiModelProperty(value = "登记人")
    @TableField("SY_CREATEUSERNAME")
    private String syCreateusername;


    @ApiModelProperty(value = "数据状态")
    @TableField("SY_STATUS")
    private String syStatus;

    @ApiModelProperty(value = "排序字段")
    @TableField("SY_ORDERINDEX")
    private Integer syOrderindex;

    @ApiModelProperty(value = "流程实例ID")
    @TableField("SY_PIID")
    private String syPiid;

    @ApiModelProperty(value = "流程定义ID")
    @TableField("SY_PDID")
    private String syPdid;

    @ApiModelProperty(value = "集团公司名称")
    @TableField("SY_JTGSMC")
    private String syJtgsmc;

    @ApiModelProperty(value = "集团公司ID")
    @TableField("SY_JTGSID")
    private String syJtgsid;

    @ApiModelProperty(value = "服务类型")
    @TableField("SERVE_TYPE")
    private String serveType;


    //1：已经解决（关闭） 其他未解决

    @ApiModelProperty(value = "待办状态")
    @TableField("STATUS")
    private String status;

    @ApiModelProperty(value = "服务计划主键")
    @TableField("SERVICE_PLAN_ID")
    private String servicePlanId;

    @ApiModelProperty(value = "用户主键")
    @TableField("USERID")
    private String userid;

    @ApiModelProperty(value = "订单主键")
    @TableField("NX_ORDER_ID")
    private String nxOrderId;

    @ApiModelProperty(value = "服务时间")
    @TableField("SERVICE_TIME")
    private  String serviceTime;


    @ApiModelProperty("通知类型Code")
    @TableField("ADVICE_CODE")
    private String adviceCode;


    @ApiModelProperty("区分标志")
    @TableField("SIGN_DATA")
    private String signData;


    @ApiModelProperty("消息码")
    @TableField("TYPE_CODE")
    private String typeCode;

    @ApiModelProperty("SN")
    @TableField("LIBRARY_SN")
    private String sn;

    @ApiModelProperty("安装位号")
    @TableField("LIBRARY_AZWH")
    private String partAzwh;

    @ApiModelProperty("工作时长")
    @TableField("LIBRARY_GZSC")
    private String partGzsc;

    @ApiModelProperty("计划名称")
    @TableField("LIBRARY_JHMC")
    private String  planName;

    @ApiModelProperty("计划完成时间")
    @TableField("LIBRARY_JHWCSJ")
    private String  planEndTime;

    @ApiModelProperty("系统模块")
    @TableField("LIBRARY_XTMK")
    private String  partXtmk;

    @ApiModelProperty("系统模块")
    @TableField("LIBRARY_BJMC")
    private String  partBjmc;


    @ApiModelProperty("报警编码")
    @TableField("LIBRARY_BJBM")
    private String bjbm;

    @ApiModelProperty("故障等级")
    @TableField("LIBRARY_GZDJ")
    private String gzdj;


    @ApiModelProperty("报警时间")
    @TableField("LIBRARY_BJSJ")
    private String bjsj;

    @ApiModelProperty("订单编号")
    @TableField("LIBRARY_DDBH")
    private String ddbh;

    @ApiModelProperty("指派工程师")
    @TableField("LIBRARY_GCS")
    private String gcs;

    @ApiModelProperty("订单需求描述")
    @TableField("LIBRARY_XQMS")
    private String xqms;

}
