package com.rootcloud.domain.entity;


import java.math.BigDecimal;
import java.util.Date;

public class Part  {
    private static final long serialVersionUID = 149327001766321251L;

    /** 主键 */
    private Long id;

    /** 配件ID */
    private String partId;

    /** 租户ID */
    private String tenantId;

    /** 配件编码 */
    private String partCode;

    /** 配件名称 */
    private String partName;

    /** 配件英文名称 mmp，这个存的是机构名称*/
    private String partNameEn;

    /** 规格型号 */
    private String model;

    /** 是否关键配件(0.否 1.是) */
    private Integer isKeyPart;

    /** 序列号 */
    private String serialNo;

    /** 单价 */
    private BigDecimal price;

    /** 单位 */
    private String unit;

    /** 单位说明 */
    private String unitDesc;

    /** 币种（CNY.人民币；USD.美元；HKD.港元；JPY.日元；KRW.韩元） */
    private String currency;

    /** 毛重 */
    private BigDecimal weight;

    /** 重量 */
    private String weightUnit;

    /** 重量单位说明 */
    private String weightUnitDesc;

    /** 是否停用(0.否 1.是) */
    private Integer isDisable;

    /** 备注 */
    private String remark;

    /** 创建日期 */
    private Date createDate;

    /** 更新时间 */
    private Date updateDate;
    
    /** 配件编码 */
    private String code;

    /**
     * 设备类型（来源于设备分类档案）
     */
    private String deviceTypeId;

    /**
     * 配件库存数量
     */
    private Integer partInventoryCount;

    private Integer safeInventoryCount;

    /**
     * 采购周期
     */
    private Integer purchasingCycle;

    /**
     * 入库日期
     */
    private Date storeDate;

    /**
     * 2021-03-24
     * */
    private String picNum; //图号
    private String partType;//配件类型(正常、耗材、易损件)
    private String partLife;// 配件寿命(h)
    private String partLifeWarning;//配件寿命预警值(h)
    private Integer isLifeWarning;//寿命报警(bool 1-报警 0-不报警)
    private String purchasingCycleWarning;//采购周期预警值(天)
    private Integer isPurchasingCycle;//采购周期报警（bool 1-报警 0-不报警）
    private Integer isLifeMonitoring; //是否寿命监测

    /**
     * 获取主键
     *
     * @return
     *            主键
     */
    public Long getId() {
        return id;
    }

    /**
     * 设置主键
     *
     * @param id
     *            主键
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * 获取配件ID
     *
     * @return
     *            配件ID
     */
    public String getPartId() {
        return partId;
    }

    /**
     * 设置配件ID
     *
     * @param partId
     *            配件ID
     */
    public void setPartId(String partId) {
        this.partId = partId == null ? null : partId.trim();
    }

    /**
     * 获取租户ID
     *
     * @return
     *            租户ID
     */
    public String getTenantId() {
        return tenantId;
    }

    /**
     * 设置租户ID
     *
     * @param tenantId
     *            租户ID
     */
    public void setTenantId(String tenantId) {
        this.tenantId = tenantId == null ? null : tenantId.trim();
    }

    /**
     * 获取配件编码
     *
     * @return
     *            配件编码
     */
    public String getPartCode() {
        return partCode;
    }

    /**
     * 设置配件编码
     *
     * @param partCode
     *            配件编码
     */
    public void setPartCode(String partCode) {
        this.partCode = partCode == null ? null : partCode.trim();
    }

    /**
     * 获取配件名称
     *
     * @return
     *            配件名称
     */
    public String getPartName() {
        return partName;
    }

    /**
     * 设置配件名称
     *
     * @param partName
     *            配件名称
     */
    public void setPartName(String partName) {
        this.partName = partName == null ? null : partName.trim();
    }

    /**
     * 获取配件英文名称
     *
     * @return
     *            配件英文名称
     */
    public String getPartNameEn() {
        return partNameEn;
    }

    /**
     * 设置配件英文名称
     *
     * @param partNameEn
     *            配件英文名称
     */
    public void setPartNameEn(String partNameEn) {
        this.partNameEn = partNameEn == null ? null : partNameEn.trim();
    }

    /**
     * 获取规格型号
     *
     * @return
     *            规格型号
     */
    public String getModel() {
        return model;
    }

    /**
     * 设置规格型号
     *
     * @param model
     *            规格型号
     */
    public void setModel(String model) {
        this.model = model == null ? null : model.trim();
    }

    /**
     * 获取是否关键配件(0.否 1.是)
     *
     * @return
     *            是否关键配件(0.否 1.是)
     */
    public Integer getIsKeyPart() {
        return isKeyPart;
    }

    /**
     * 设置是否关键配件(0.否 1.是)
     *
     * @param isKeyPart
     *            是否关键配件(0.否 1.是)
     */
    public void setIsKeyPart(Integer isKeyPart) {
        this.isKeyPart = isKeyPart;
    }

    /**
     * 获取序列号
     *
     * @return
     *            序列号
     */
    public String getSerialNo() {
        return serialNo;
    }

    /**
     * 设置序列号
     *
     * @param serialNo
     *            序列号
     */
    public void setSerialNo(String serialNo) {
        this.serialNo = serialNo == null ? null : serialNo.trim();
    }

    /**
     * 获取单价
     *
     * @return
     *            单价
     */
    public BigDecimal getPrice() {
        return price;
    }

    /**
     * 设置单价
     *
     * @param price
     *            单价
     */
    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    /**
     * 获取单位
     *
     * @return
     *            单位
     */
    public String getUnit() {
        return unit;
    }

    /**
     * 设置单位
     *
     * @param unit
     *            单位
     */
    public void setUnit(String unit) {
        this.unit = unit == null ? null : unit.trim();
    }

    /**
     * 获取单位说明
     *
     * @return
     *            单位说明
     */
    public String getUnitDesc() {
        return unitDesc;
    }

    /**
     * 设置单位说明
     *
     * @param unitDesc
     *            单位说明
     */
    public void setUnitDesc(String unitDesc) {
        this.unitDesc = unitDesc == null ? null : unitDesc.trim();
    }

    /**
     * 获取币种（CNY.人民币；USD.美元；HKD.港元；JPY.日元；KRW.韩元）
     *
     * @return
     *            币种（CNY.人民币；USD.美元；HKD.港元；JPY.日元；KRW.韩元）
     */
    public String getCurrency() {
        return currency;
    }

    /**
     * 设置币种（CNY.人民币；USD.美元；HKD.港元；JPY.日元；KRW.韩元）
     *
     * @param currency
     *            币种（CNY.人民币；USD.美元；HKD.港元；JPY.日元；KRW.韩元）
     */
    public void setCurrency(String currency) {
        this.currency = currency == null ? null : currency.trim();
    }

    /**
     * 获取毛重
     *
     * @return
     *            毛重
     */
    public BigDecimal getWeight() {
        return weight;
    }

    /**
     * 设置毛重
     *
     * @param weight
     *            毛重
     */
    public void setWeight(BigDecimal weight) {
        this.weight = weight;
    }

    /**
     * 获取重量
     *
     * @return
     *            重量
     */
    public String getWeightUnit() {
        return weightUnit;
    }

    /**
     * 设置重量
     *
     * @param weightUnit
     *            重量
     */
    public void setWeightUnit(String weightUnit) {
        this.weightUnit = weightUnit == null ? null : weightUnit.trim();
    }

    /**
     * 获取重量单位说明
     *
     * @return
     *            重量单位说明
     */
    public String getWeightUnitDesc() {
        return weightUnitDesc;
    }

    /**
     * 设置重量单位说明
     *
     * @param weightUnitDesc
     *            重量单位说明
     */
    public void setWeightUnitDesc(String weightUnitDesc) {
        this.weightUnitDesc = weightUnitDesc == null ? null : weightUnitDesc.trim();
    }

    /**
     * 获取是否停用(0.否 1.是)
     *
     * @return
     *            是否停用(0.否 1.是)
     */
    public Integer getIsDisable() {
        return isDisable;
    }

    /**
     * 设置是否停用(0.否 1.是)
     *
     * @param isDisable
     *            是否停用(0.否 1.是)
     */
    public void setIsDisable(Integer isDisable) {
        this.isDisable = isDisable;
    }

    /**
     * 获取备注
     *
     * @return
     *            备注
     */
    public String getRemark() {
        return remark;
    }

    /**
     * 设置备注
     *
     * @param remark
     *            备注
     */
    public void setRemark(String remark) {
        this.remark = remark == null ? null : remark.trim();
    }

    /**
     * 获取创建日期
     *
     * @return
     *            创建日期
     */
    public Date getCreateDate() {
        return createDate;
    }

    /**
     * 设置创建日期
     *
     * @param createDate
     *            创建日期
     */
    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    /**
     * 获取更新时间
     *
     * @return
     *            更新时间
     */
    public Date getUpdateDate() {
        return updateDate;
    }

    /**
     * 设置更新时间
     *
     * @param updateDate
     *            更新时间
     */
    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }

    /**
     * 编码
     *
     * @param code
     *            
     */
	public String getCode() {
		return code;
	}

	
	 /**
     * 编码
     *
     * @param code
     *            
     */
	public void setCode(String code) {
		this.code = code;
	}

    public String getDeviceTypeId() {
        return deviceTypeId;
    }

    public void setDeviceTypeId(String deviceTypeId) {
        this.deviceTypeId = deviceTypeId;
    }

    public Integer getPartInventoryCount() {
        return partInventoryCount;
    }

    public void setPartInventoryCount(Integer partInventoryCount) {
        this.partInventoryCount = partInventoryCount;
    }

    public Integer getPurchasingCycle() {
        return purchasingCycle;
    }

    public void setPurchasingCycle(Integer purchasingCycle) {
        this.purchasingCycle = purchasingCycle;
    }

    public Date getStoreDate() {
        return storeDate;
    }

    public void setStoreDate(Date storeDate) {
        this.storeDate = storeDate;
    }

    public Integer getSafeInventoryCount() {
        return safeInventoryCount;
    }

    public Part setSafeInventoryCount(Integer safeInventoryCount) {
        this.safeInventoryCount = safeInventoryCount;
        return this;
    }

    public String getPicNum() {
        return picNum;
    }

    public void setPicNum(String picNum) {
        this.picNum = picNum;
    }

    public String getPartType() {
        return partType;
    }

    public void setPartType(String partType) {
        this.partType = partType;
    }

    public String getPartLife() {
        return partLife;
    }

    public void setPartLife(String partLife) {
        this.partLife = partLife;
    }

    public String getPartLifeWarning() {
        return partLifeWarning;
    }

    public void setPartLifeWarning(String partLifeWarning) {
        this.partLifeWarning = partLifeWarning;
    }

    public Integer getIsLifeWarning() {
        return isLifeWarning;
    }

    public void setIsLifeWarning(Integer isLifeWarning) {
        this.isLifeWarning = isLifeWarning;
    }

    public String getPurchasingCycleWarning() {
        return purchasingCycleWarning;
    }

    public void setPurchasingCycleWarning(String purchasingCycleWarning) {
        this.purchasingCycleWarning = purchasingCycleWarning;
    }

    public Integer getIsPurchasingCycle() {
        return isPurchasingCycle;
    }

    public void setIsPurchasingCycle(Integer isPurchasingCycle) {
        this.isPurchasingCycle = isPurchasingCycle;
    }

    public Integer getIsLifeMonitoring() {
        return isLifeMonitoring;
    }

    public void setIsLifeMonitoring(Integer isLifeMonitoring) {
        this.isLifeMonitoring = isLifeMonitoring;
    }

    @Override
    public String toString() {
        return "Part{" +
                "id=" + id +
                ", partId='" + partId + '\'' +
                ", tenantId='" + tenantId + '\'' +
                ", partCode='" + partCode + '\'' +
                ", partName='" + partName + '\'' +
                ", partNameEn='" + partNameEn + '\'' +
                ", model='" + model + '\'' +
                ", isKeyPart=" + isKeyPart +
                ", serialNo='" + serialNo + '\'' +
                ", price=" + price +
                ", unit='" + unit + '\'' +
                ", unitDesc='" + unitDesc + '\'' +
                ", currency='" + currency + '\'' +
                ", weight=" + weight +
                ", weightUnit='" + weightUnit + '\'' +
                ", weightUnitDesc='" + weightUnitDesc + '\'' +
                ", isDisable=" + isDisable +
                ", remark='" + remark + '\'' +
                ", createDate=" + createDate +
                ", updateDate=" + updateDate +
                ", code='" + code + '\'' +
                ", deviceTypeId='" + deviceTypeId + '\'' +
                ", partInventoryCount=" + partInventoryCount +
                ", safeInventoryCount=" + safeInventoryCount +
                ", purchasingCycle=" + purchasingCycle +
                ", storeDate=" + storeDate +
                ", picNum='" + picNum + '\'' +
                ", partType='" + partType + '\'' +
                ", partLife='" + partLife + '\'' +
                ", partLifeWarning='" + partLifeWarning + '\'' +
                ", isLifeWarning=" + isLifeWarning +
                ", purchasingCycleWarning='" + purchasingCycleWarning + '\'' +
                ", isPurchasingCycle=" + isPurchasingCycle +
                '}';
    }
}