package com.rootcloud.domain.entity.sp;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.ToString;

import java.io.Serializable;

/**
 * @ClassName NxTiggerCondition
 * @Description 触发条件实体
 * @Author w-liuyi01
 * @Date 2022/4/28 16:07
 * @Version 1.0
 */
@Data
@ToString
@TableName("nx_trigger_condition")
public class NxTriggerConditionEntity implements Serializable {

    @TableId
    private String nxTriggerConditionId;

    @ApiModelProperty("服务计划ID")
    private String servicePlanId;

    @ApiModelProperty("触发类型")
    private String triggerCondition;

    @ApiModelProperty("条件")
    private String conditionTj;

    @ApiModelProperty("条件值")
    private String conditionValue;

    @ApiModelProperty("触发类型名称")
    private String triggerConditionName;

    @ApiModelProperty("条件名称")
    private String conditionTjName;

    @ApiModelProperty("条件值名称")
    private String conditionValueName;

    @ApiModelProperty("设置值")
    private String setValue;

    @ApiModelProperty("设置值的名称")
    private String setValueName;

    @ApiModelProperty("创建时间")
    private String createTime;

    @ApiModelProperty("数据单位")
    private String dataUnit;

    /**
     * 这里更新策略需要添加空值，需要设置null值
     */
    @ApiModelProperty("平台报警规则id")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String alarmTypeId;
}
