package com.rootcloud.domain.entity.sp;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.ToString;

import java.io.Serializable;

/**
 * @ClassName NxUserInfo
 * @Description 推送消息用户
 * @Author w-liuyi01
 * @Date 2022/4/28 15:59
 * @Version 1.0
 */
@Data
@ToString
@TableName("nx_user_info")
public class NxUserInfoEntity implements Serializable {

    @TableId
    private String nxUserInfoId;

    @ApiModelProperty("服务计划ID")
    private String servicePlanId;

    @ApiModelProperty("部门ID")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String departmentId;

    @ApiModelProperty("用户ID")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String userId;

    @ApiModelProperty("角色ID")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String roleId;

    @ApiModelProperty("部门ID名称")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String departmentIdName;

    @ApiModelProperty("用户ID名称")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String userIdName;

    @ApiModelProperty("角色ID名称")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String roleIdName;

    @ApiModelProperty("是否外部提醒（1：勾选外部提醒）")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String externalReminders;


    @ApiModelProperty("站内信提醒（1：勾选站内信提醒）")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String stationReminders;


    @ApiModelProperty("邮件提醒（1：勾选邮件提醒）")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String emailReminders;

    @ApiModelProperty("短信提醒（1：勾选短信提醒）")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String smsReminders;


    @ApiModelProperty("消息模板类型")
    private String infoType;

    @ApiModelProperty("消息模板内容")
    private String infoContent;

    @ApiModelProperty("消息模板Id")
    private String  infoXxmbid;

    @ApiModelProperty("创建时间")
    private String createTime;

}
