package com.rootcloud.domain.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.rootcloud.domain.dto.*;
import com.rootcloud.domain.entity.device.DeviceEntity;
import com.rootcloud.domain.vo.PrinterEfficiencyWorkVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * TODO
 *
 * @author wei.liao
 * @version 1.0
 * @date 2022/4/18 14:13
 */
@Mapper
public interface DeviceMapper extends BaseMapper<DeviceEntity> {

    public List<DeviceDTO> findAll();

    List<DeviceSpecialDTO> findSpecialAll();


    public List<DeviceWorkTimeDTO> findAllWithMonthWorkTime(@Param("deviceId") String deviceId, @Param("searchDate") Date searchDate);

    public List<DeviceWorkTimeDTO> findAllWithMonthWorkBetweenTime(@Param("deviceId") String deviceId, @Param("startDate") Date startDate, @Param("endDate") Date endDate);

    public List<DeviceWorkTimeDTO> findAllWithDayWorkTime(@Param("deviceId") String deviceId, @Param("startDate") Date startDate, @Param("endDate") Date endDate);

    public List<NxDeviceDTO> findCameraList(@Param("no") String no, @Param("name") String name, @Param("type") String type,@Param("startNo") Integer startNo,@Param("endNo") Integer endNo);
    public List<CameraDTO> selectCameras(@Param("deviceId") String deviceId);

    public Integer findCameraCount(@Param("no") String no, @Param("name") String name, @Param("type") String type);


    List<DeviceDTO> findAllByUserId(@Param("userIds") String userIds);

    List<Map<String,String>> statisticsDeviceTimesMonth(Map<String,Object> month);

    int clearDeviceTimesDay(Map<String,Object> map);

    int batchAddDeviceTimesDay(Map<String,Object> map);

    //统计月时长

    List<Map<String,String>> getDeviceTimesMonth(Map<String,Object> map);
    int updateDeviceTimesMonth(Map<String,Object> map);

    //统计月时长
    int insertDeviceTimesMonth(Map<String,Object> map);
}
