package com.rootcloud.domain.service.auth;


import com.rootcloud.common.JsonResult;
import com.rootcloud.common.OAuthResult;

import java.util.Map;

/**
 * 认证授权
 */

public interface RootCloudAuthService {

    /**
     * ouath2.0 passsword 验证方式
     *
     * @param username
     * @param desEncrypt
     * @return
     */
    public OAuthResult login(String username, String desEncrypt, String code);
    public String getUserProfile(String accessToken);
    public String publicKey();
    public String logout(String accessToken);
    /**
     * 客户端模式认证
     *
     * @return
     */

    public OAuthResult clientCredentials() ;

    /**
     * 刷新token
     *
     * @param refreshToken
     * @return
     */

    public OAuthResult refreshAccessToken(String refreshToken) ;

    public OAuthResult switchTenant(String tenantId, String accessToken);

    /**
     * 获取验证码 逻辑：当用户在小程序页面输入手机号点击获取验证码，判断该用户是否存在。如果存在，直接后端调用应用大师发送验证码接口
     * 如果不存在，后端调用应用大师注册用户接口，先注册用户再调发送验证码接口
     * @return
     */
    JsonResult<Object> getCode(Map<String, Object> param);

    JsonResult<Object> findPassWord(Map<String, Object> param);

    JsonResult<Object> modifyPassWord(Map<String, Object> param);

    //更新邮箱
    JsonResult<Object> updateEmail(Map<String, Object> param);
}
