package com.rootcloud.domain.service.device;

import com.rootcloud.domain.entity.MyMessageEntity;
import com.rootcloud.domain.entity.ds.DeviceListEntity;
import com.rootcloud.vo.rest.AppDeviceAlarmParam;
import com.rootcloud.vo.rest.DeviceAlarmParam;

import java.util.List;
import java.util.Map;

public interface DeviceAlarmService {
    /**
     * pc端规则报警查询接口
     * @param deviceAlarmParam
     * @return
     */
    Map<String,Object> getDeviceRuleAlarmInfo(DeviceAlarmParam deviceAlarmParam);

    /**
     * pc端故障码报警查询接口
     * @param deviceAlarmParam
     * @return
     */
    Map<String,Object> getDeviceCodeAlarmInfo(DeviceAlarmParam deviceAlarmParam);

    /**
     * app端规则报警查询接口
     */
    Map<String,Object> getDeviceRuleAlarmCount(AppDeviceAlarmParam appDeviceAlarmParam);

    /**
     * app端故障码报警查询接口
     */
    Map<String,Object> getDeviceCodeAlarmCount(AppDeviceAlarmParam appDeviceAlarmParam);

    /**
     * app端ALL查询接口
     */
    Map<String,Object> getDeviceAllAlarmCount(AppDeviceAlarmParam appDeviceAlarmParam);

    /**
     * 根据设备ID查询故障码报警和规则报警条数
     */
    Integer getDeviceAlarmCount(String deviceId,String startTime,String endTime);

    /**
     * 查询报警推送app的消息
     */
    List<MyMessageEntity> queryAlarmMessages(List<DeviceListEntity> deviceListEntities);

}
