package com.rootcloud.domain.service.device;

import com.baomidou.mybatisplus.extension.service.IService;
import com.rootcloud.common.JsonResult;
import com.rootcloud.domain.dto.DeviceDTO;
import com.rootcloud.domain.dto.DeviceSpecialDTO;
import com.rootcloud.domain.entity.device.DeviceEntity;
import com.rootcloud.vo.device.DeviceMonthWorkTimeStatistics;
import com.rootcloud.vo.device.DeviceVO;
import com.rootcloud.vo.device.DeviceView;

import java.util.Date;
import java.util.List;

/**
 * TODO
 *
 * @author wei.liao
 * @version 1.0
 * @date 2022/4/18 14:07
 */
public interface DeviceService extends IService<DeviceEntity> {
    /**
     * 设备总览
     * @return
     */
    public JsonResult<DeviceView> display();

    /**
     * 获取这边信息，年度月工时折现图
     * @return
     */
    public JsonResult<DeviceVO> getDeviceInfoWithMonthWorkTimeLineChart(String deviceId);

    /**
     * 获取设备月工时统计
     * @return
     */
    public JsonResult<DeviceMonthWorkTimeStatistics> getMonthWorkTimeStatistics(String deviceId, Date searchDate);


    /**
     * 服务计划查询所有设备编码
     * @return
     */
    List<DeviceSpecialDTO> selectAllDevice();


    /**
     * 通过设备编码返回地址
     * @param sblbSbbm
     * @return
     */
    String returnAddress(String sblbSbbm);


    /**
     * 通过角色查询设备
     * @return
     */
    List<DeviceDTO> deviceDTOListByRole();

}
