package com.rootcloud.domain.service.ds;

import com.baomidou.mybatisplus.extension.service.IService;
import com.rootcloud.domain.entity.ds.ModelPropertySyncEntity;

import java.util.List;

public interface ModelPropertySyncService extends IService<ModelPropertySyncEntity> {
    void syncModelPropertyData(String clientId,String clientSecret);

    List<String> queryPropertysByModelId(String modelId);

    void updateModelProperty(List<ModelPropertySyncEntity> entitys);

    void delModelProperty(ModelPropertySyncEntity entity);

    /**
     * 根据modelId查询属性列表
     *
     * @param modelId
     *            modelId
     * @return 列表数据
     */
    List<ModelPropertySyncEntity> queryListByModelId(String modelId);

    /**
     * 根据modelId和属性Id查询属性
     *
     * @param modelId
     *            modelId
     * @param propertyId 属性ID
     * @return 属性数据
     */
    ModelPropertySyncEntity queryByModelIdAndPropertyId(String modelId, String propertyId);
}
