package com.rootcloud.domain.service.fittings.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.rootcloud.domain.dao.FittingsListMapper;
import com.rootcloud.domain.entity.NxFittingsListEntity;
import com.rootcloud.domain.service.fittings.FittingsService;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.math.BigDecimal;
import java.util.List;

@Service("fittingsServiceImpl")
public class FittingsServiceImpl extends ServiceImpl<FittingsListMapper, NxFittingsListEntity> implements FittingsService {
    @Override
    public String getTotalPrice(String fittingsSellId) {
       LambdaQueryWrapper<NxFittingsListEntity> lambdaQueryWrapper = Wrappers.lambdaQuery(NxFittingsListEntity.class);
       lambdaQueryWrapper.eq(NxFittingsListEntity::getPjxspjlbglPjglwybs,fittingsSellId);
       List<NxFittingsListEntity> list = this.list(lambdaQueryWrapper);
       BigDecimal result = new BigDecimal("0.00");
       if(!CollectionUtils.isEmpty(list)){
           for(NxFittingsListEntity entity :list){
               BigDecimal bigDecimal = new BigDecimal(entity.getPjxspjlbglCjxj());
               result = result.add(bigDecimal);
           }
       }
       return result.toString();
    }
}
