package com.rootcloud.domain.service.gbsj.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.rootcloud.common.HttpUtils;
import com.rootcloud.common.JEUuidUtil;
import com.rootcloud.common.ResourceUtil;
import com.rootcloud.common.constant.Properties;
import com.rootcloud.config.auth.LoginUserInfo;
import com.rootcloud.config.auth.UserContext;
import com.rootcloud.config.auth.UserInfo;
import com.rootcloud.domain.dao.GbsjbDao;
import com.rootcloud.domain.dao.JeCoreEnduserDao;
import com.rootcloud.domain.dao.JeSysUsermsgDao;
import com.rootcloud.domain.entity.GbsjbEntity;
import com.rootcloud.domain.entity.JeSysUsermsgEntity;
import com.rootcloud.domain.service.gbsj.GbsjbService;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.*;


@Service("gbsjService")
@Slf4j
public class GbsjbServiceImpl extends ServiceImpl<GbsjbDao, GbsjbEntity> implements GbsjbService {

    @Autowired
    Properties wfProperties;

    @Autowired
    private RedisTemplate redisTemplate;

    @Autowired
    GbsjbDao gbsjbDao;

    @Autowired
    JeSysUsermsgDao jeSysUsermsgDao;
    @Autowired
    JeCoreEnduserDao jeCoreEnduserDao;
    @Override
    public boolean sendGbsjTipMsg() {
        boolean flag = false;
        //获取触发条件
        Map<String, String> maps = gbsjbDao.selectOne();


        //JP推送消息地址与接口路径
        String host = wfProperties.getWfHost();
        String url = Properties.dwr_sender_uri;


        //根据通知角色找到对应需要通知的人
        String userIds = gbsjbDao.queryUserIds(Arrays.asList(maps.get("CFTJPZB_TZDX").split(",")));

        //组装请求调用JP的发起站内信接口
        JSONObject params = new JSONObject();
        params.put("userId", userIds);
        params.put("title", ResourceUtil.getI18nMessage("60013"));
        params.put("context", maps.get("CFTJPZB_TZNR"));
        Map<String, String> headers = new HashMap<>();
        try {
            Map<String, String> querys = new HashMap<>();
            HttpResponse response = HttpUtils.doPost(host + url, "", "post", headers, querys, params.toString());
            if (response.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {
                flag = true;
            }
        } catch (Exception e) {
            log.error("error", e);
        }
        String[] split = userIds.split(",");
        for (String userId:split) {
            JeSysUsermsgEntity usermsgEntity = new JeSysUsermsgEntity();
            usermsgEntity.setUsermsgJsrId(userId);//接收人id
            usermsgEntity.setUsermsgYd("0");//默认已读
            usermsgEntity.setUsermsgNr(maps.get("CFTJPZB_TZNR"));//内容
            usermsgEntity.setUsermsgBt(ResourceUtil.getI18nMessage("60013"));//标题
            usermsgEntity.setUsermsgJssj(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()).toString());//接受时间
            UserInfo user = jeCoreEnduserDao.getUser(userId);
            usermsgEntity.setUsermsgJsrName(user.getUserName());//接收人姓名
            usermsgEntity.setUsermsgMsgtypeName(ResourceUtil.getI18nMessage("60013"));//用户消息类型_NAME
            usermsgEntity.setUsermsgMsgtypeCode("NX");//用户消息类型
            usermsgEntity.setJeSysUsermsgId(JEUuidUtil.uuid());//主键
            usermsgEntity.setSyCreatetime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()).toString());//创建时间
            LoginUserInfo current = UserContext.current();
            usermsgEntity.setSyCreateuser(current.getUserName());//当前登陆人姓名
            jeSysUsermsgDao.insert(usermsgEntity);
        }
        return flag;
    }

    @Override
    public void userUnlock() {
        List<Map<String, String>> users = gbsjbDao.queryLockUser();
        if (users != null && users.size() > 0) {
            gbsjbDao.unLockUser();
            for (Map<String,String> user : users) {
                //清理用户所有登陆关键字
                String[] fileds = new String[]{"USERID", "USERNAME", "BACKUSERCODE", "PHONE", "COMPANYEMAIL", "JOBNUM", "USERCARD"};
                for (String filed : fileds) {
                    if (StringUtils.isNotBlank(user.get(filed))) {
                        String key = "__CODE__" + user.get(filed);
                        redisTemplate.delete(user.get(filed));
                        redisTemplate.delete(key);
//                        UserErrorPwCacheManager.removeCache(user.getStr(filed));
//                        UserErrorPwCacheManager.removeCache("__CODE__" + user.getStr(filed));
                    }
                }
            }
        }
    }
}