package com.rootcloud.domain.service.gbsj.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.rootcloud.config.auth.LoginUserInfo;
import com.rootcloud.config.auth.UserInfo;
import com.rootcloud.domain.dao.JeCoreEnduserDao;
import com.rootcloud.domain.dto.EnterpriseInfoDTO;
import com.rootcloud.domain.dto.UserRoleDeptDTO;
import com.rootcloud.domain.entity.JeCoreEnduserEntity;
import com.rootcloud.domain.entity.SiteDTO;
import com.rootcloud.domain.entity.base.ModelPropertyEntity;
import com.rootcloud.domain.service.gbsj.JeCoreEnduserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("endUserService")
public class JeCoreEnduserServiceImpl extends ServiceImpl<JeCoreEnduserDao, JeCoreEnduserEntity> implements JeCoreEnduserService {

    @Autowired
    JeCoreEnduserDao enduserDao;

    @Override
    public LoginUserInfo getUserInfo(String userId) {
        return enduserDao.getUserInfo(userId);
    }

    @Override
    public SiteDTO getSiteByUserId(String userId) {
        return enduserDao.getSiteByUserId(userId);
    }

    @Override
    public String getCustomsBySiteAreaName(String areaName) {
        return enduserDao.getCustomsBySiteAreaName(areaName);
    }


    @Override
    public String getCustomsByUserId(String userId) {
        return enduserDao.getCustomByUserId(userId);
    }

    @Override
    public EnterpriseInfoDTO getTenantInfo(String userId) {
        return enduserDao.getTenantInfo(userId);
    }

    @Override
    public String getTenantInfoNOSQL(String userId) {
        return enduserDao.getTenantInfoNOSQL(userId);
    }

    @Override
    public UserRoleDeptDTO getUserLoginInfo(String userId) {
        return enduserDao.getUserLoginInfo(userId);
    }

    @Override
    public UserInfo getUser(String userId) {
        return enduserDao.getUser(userId);
    }

    /**
     * @param key
     * @return
     */
    @Override
    public String getDataByKey(String key) {
        return enduserDao.getDataByKey(key);
    }

    @Override
    public boolean getBackusercode(String phone) {
        //判断手机号码或者邮件
        LambdaQueryWrapper<JeCoreEnduserEntity> mpeWrapper = new LambdaQueryWrapper<JeCoreEnduserEntity>();
        mpeWrapper.eq(JeCoreEnduserEntity::getBackusercode,phone).or().eq(JeCoreEnduserEntity::getCompanyemail,phone);
        List<JeCoreEnduserEntity> list = enduserDao.selectList(mpeWrapper);
        if(list.size()>0){
            return true;
        }
        return false;
    }
}