package com.rootcloud.domain.service.network;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.rootcloud.common.JEUuidUtil;
import com.rootcloud.common.constant.BusinessConstant;
import com.rootcloud.domain.dao.JeCoreEnduserDao;
import com.rootcloud.domain.entity.JeCoreEnduserEntity;
import com.rootcloud.domain.entity.NetworkUserEntity;
import com.rootcloud.domain.entity.NxOrderEntity;
import com.rootcloud.domain.mapper.NetworkUserMapper;
import com.rootcloud.domain.mapper.NxOrderMapper;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * TODO
 *
 * @author wei.liao
 * @version 1.0
 * @date 2022/4/27 10:30
 */
@Service
public class NetworkService {


    @Autowired
    private JeCoreEnduserDao jeCoreEnduserDao;
    @Autowired
    private NetworkUserMapper networkUserMapper;
    @Autowired
    private NxOrderMapper nxOrderMapper;

    public void bindUser(String networkId, List<String> userId,String yhJs) {
        List<JeCoreEnduserEntity> userList = jeCoreEnduserDao.selectList(new QueryWrapper<JeCoreEnduserEntity>().lambda().in(JeCoreEnduserEntity::getUserid, userId));
        for (JeCoreEnduserEntity itm : userList) {
            NetworkUserEntity networkUserEntity = new NetworkUserEntity();
            networkUserEntity.setFwryWdid(networkId);
            networkUserEntity.setUserid(itm.getUserid());
            networkUserEntity.setNxgxJcdaFwryId(JEUuidUtil.uuid());
            networkUserEntity.setFwryYx(itm.getCompanyemail());
            networkUserEntity.setFwryYhxm(itm.getUsername());
            //networkUserEntity.setFwrySjh(itm.getPhone());
            networkUserEntity.setFwrySjh(itm.getBackusercode());
            //networkUserEntity.setFwryJs(itm.getRolenames());
            networkUserEntity.setFwryJs(yhJs);
            networkUserEntity.setFwryJscode(itm.getRolecodes());
            networkUserEntity.setFwrySsbm(itm.getDeptname());
            // 关联订单 ，是否存在绑定的订单
            //筛选    订单处于待报工、待审核，他就是忙碌的 其他状态的单，就是空闲
            List<NxOrderEntity> collect = nxOrderMapper.getOrderByEngineerId(itm.getUserid()).stream().filter(NxOrderEntity -> "4".equals(NxOrderEntity.getOrderOrderstatusCode())
                    || "5".equals(NxOrderEntity.getOrderOrderstatusCode())).collect(Collectors.toList());
            if ("服务经理".equals(yhJs)){
               /* networkUserEntity.setFwryZt("--");
                networkUserEntity.setFwryZtcode(BusinessConstant.NETWORK_USER_STATUS_UNKNOWN);*/
                networkUserEntity.setFwryZt("忙碌");
                networkUserEntity.setFwryZtcode(BusinessConstant.NETWORK_USER_STATUS_BUSY);
            }else{
                if(CollectionUtils.isNotEmpty(collect)){
                    networkUserEntity.setFwryZt("忙碌");
                    networkUserEntity.setFwryZtcode(BusinessConstant.NETWORK_USER_STATUS_BUSY);
                }else{
                    networkUserEntity.setFwryZt("空闲");
                    networkUserEntity.setFwryZtcode(BusinessConstant.NETWORK_USER_STATUS_FREE);
                }
            }

            networkUserMapper.insert(networkUserEntity);
        }

    }
}
