package com.rootcloud.domain.service.part;

import com.rootcloud.common.WebServiceClient;
import com.rootcloud.common.net.NetworkHelper;
import com.rootcloud.domain.entity.Part;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author Administrator
 * 配件档案同步   库存数量、基本单位、实际价格
 */
@Component
public class PartTask {
    private static final Logger logger = LoggerFactory.getLogger(PartTask.class);

    // 命名空间
    public static final String ACTION = "http://sap.com/xi/WebService/soap1.1";
    // 调用方法
    public static final String METHODNAME = "ZMM_RP002";
    //webservice地址
    public static final String WSDLLOCATION = "http://61.133.215.5:50000/XISOAPAdapter/MessageServlet?senderParty=&senderService=BS_LIMS_PRD&receiverParty=&receiverService=&interface=SI_ZMM_RP002&interfaceNamespace=http://www.kocel.com/lims/zmm_rp002";

//    @Autowired
//	private PartMapper partMapper;

//    @Autowired
//	private SysConfigService sysConfigService;

    private static final String CONFIG_TYPE = "icsm";
    private static final String CONFIG_CODE = "S_WERKS";

    @Autowired
//    private SmsClient smsClient;

//    private static final String DEFAULTSWERKS = "1100,11X0,1200,12X0,1300,13X0,1410,1420,1430,14X0,1500,15X0,1600,1610,1620,1630,1640,1650,1670,1680,1690,16A0,16B0,16C0,16K0,16L0,16M0,16N0,16P0,1700,1800,1900,19X0,2000,2100,2200,2300,3000,3100,3200,3300,3400";
    private static final String DEFAULTSWERKS = "1100,11X0,1200,12X0,1300,13X0,1430,1500,15X0,1600,1610,1620,1630,1640,1650,1670,1680,1690,16A0,16B0,16C0,16K0,16L0,16M0,16N0,16P0,1700,1800,1900,19X0,2000,2100,2200,2300,3000,3100,3200,3300,3400";

    private static final String DEFAULTSWERKS2 = "1430";

    //验证是否为数字
    public boolean isNumeric(String code) {
        Pattern pat = Pattern.compile("[0-9]*");
        Matcher isNum = pat.matcher(code);
        if (!isNum.matches()) {
            return false;
        }
        return true;
    }

    public static void main(String[] args) {
        if (NetworkHelper.getInstance().isReachIp("61.133.215.5")) {
            logger.debug("=======本机可以ping通ip：" + "61.133.215.5");
        } else {
            logger.debug("=======本机ping不通ip：" + "61.133.215.5");
        }
        if (NetworkHelper.getInstance().isReachNetworkInterfaces("61.133.215.5")) {
            logger.debug("=======本机所有网卡可以ping通ip：" + "61.133.215.5");
        } else {
            logger.debug("=======本机所有网卡ping不通ip：" + "61.133.215.5");
        }
        String localIp = NetworkHelper.getInstance().getReachableIP("61.133.215.5", 50000);
        if (!StringUtils.isBlank(localIp)) {
            logger.debug("=======本机可以与ip：" + "61.133.215.5" + ",port:" + 50000 + "建立连接的IP：" + localIp);
        } else {
            logger.debug("=======本机不能与ip：" + "61.133.215.5" + ",port:" + 50000 + "建立连接的IP");
        }

        WebServiceClient client = new WebServiceClient(WSDLLOCATION, ACTION, METHODNAME, new HashMap<>(16));
//        List<Part> partList = client.getPartData();
//        System.out.println(partList);
    }
}

