package com.rootcloud.domain.service.sp;

import com.baomidou.mybatisplus.extension.service.IService;
import com.rootcloud.domain.ao.TriggerConditionAO;
import com.rootcloud.domain.entity.sp.NxTriggerConditionEntity;

/**
 * <p>
 * 触发条件service
 * </p>
 *
 * @author hejia
 */
public interface NxTriggerConditionService extends IService<NxTriggerConditionEntity> {

    /**
     * 添加触发条件
     * 
     * @param conditionAo
     *            触发条件Ao
     * @param planId
     *            计划主键
     * @param deviceNo
     *            设备编号
     */
    void add(TriggerConditionAO conditionAo, String planId, String deviceNo);

    /**
     * 添加触发条件
     *
     * @param conditionAo
     *            触发条件Ao
     * @param planId
     *            计划主键
     * @param deviceNo
     *            设备编号
     * 
     */
    void update(TriggerConditionAO conditionAo, String planId, String deviceNo);

    /**
     * 通过服务计划主键删除触发条件
     *
     * @param servicePlanId
     *            服务计划主键
     * @param deviceNo
     *            设备编码
     */
    void removeByPlanId(String servicePlanId, String deviceNo);
}
