package com.rootcloud.domain.service.sp;

import com.baomidou.mybatisplus.extension.service.IService;
import com.rootcloud.domain.entity.sp.NxUserInfoEntity;
import com.rootcloud.vo.service.NxUserInfoVo;

import java.util.List;
import java.util.Map;

public interface NxUserInfoService extends IService<NxUserInfoEntity> {


    /**
     *  根据服务计划id设置提醒
     * @param servicePlanId  服务服务计划id
     */
    void setReminders(String servicePlanId);


    /**
     * 发送站内信
     * @param userIds
     * @param title
     * @param context
     * @return
     */
    boolean sendStationReminders(String userIds,String title,String context);


    /**
     * 根据服务计划id 和设备编码查询详情
     * @param servicePlanId
     * @param serviceCode
     * @return
     */
    NxUserInfoVo selectByServicePlanId(String servicePlanId,String serviceCode,String syZhid);


    /**
     * 删除提醒内容
     * @param servicePlanId
     * @return
     */
    int  deleteByServicePlanId(String servicePlanId);


    /**
     * 新增数据
     * @param nxUserInfoEntity
     * @return
     */
    int  saveNxUserInfo(NxUserInfoEntity nxUserInfoEntity);


    /**
     * 修改数据
     * @param nxUserInfoEntity
     * @return
     */
    int  updateNxUserInfo(NxUserInfoEntity nxUserInfoEntity);



    boolean sendEmail(Map<String, Object> param);

    /**
     * 根据任务计划IDs查询计划信息
     */
    List<NxUserInfoEntity> queryUserInfoByPlanIds(List<String> servicePlanIds);


    /**
     * 通过计划任务获取模板内容
     * @param servicePlanId
     * @return
     */
    String  getTemplateContent(String servicePlanId);


    /**
     * 通过设备编码返回对应客户以及服务经理角色
     * @param deviceCode
     * @return
     */
    List<String> getCustomerAndRoles(String deviceCode);
}
