package com.rootcloud.domain.service.todo;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.rootcloud.domain.entity.MyAdviceEntity;
import com.rootcloud.domain.entity.MyMessageEntity;
import com.rootcloud.domain.entity.NxTodoLibrary;
import com.rootcloud.vo.todo.TodoVo;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 宁夏_待办库 服务类
 * </p>
 *
 * @author yangyijun
 * @since 2022-05-27
 */
public interface NxTodoLibraryService extends IService<NxTodoLibrary> {

    /**
     * 分页查询待办库
     * @param page
     * @param size
     * @param queryData
     * @param userId
     * @return
     */
    IPage<TodoVo> getPage(int page, int size, String queryData,String userId);


    /**
     * 改变代办库状态
     * @param nxTodoLibraryId
     */
    void updateStatus(String nxTodoLibraryId);


    /**
     * 将订单主键写到代办库
     * @param nxTodoLibraryId
     * @param nxOrderId
     */
    void updateLibrary(String nxTodoLibraryId,String nxOrderId);

    /**
     * 将消息移入代办库
     */
    void insertMessageLibarary(MyMessageEntity myMessageEntity);

    /**
     * 将通知移入代办库
     */
    void insertAdviceToLibarary(MyAdviceEntity myAdviceEntity);



    List<NxTodoLibrary> selectBySign(String adviceCode,String signData,String time);

    void delTodoLibrary(String nxTodoLibraryId);

    List<String> selectByData(String adviceCode,List<String> list);
}
