package com.rootcloud.service;

import com.rootcloud.web.dto.PrinterReportDTO;

import java.time.LocalDate;
import java.util.Calendar;
import java.util.List;
import java.util.Map;

public interface PrinterEfficiencyService {

    List<Map<String, Object>> getPrinterEfficiencyData();


    /**
     * 0-24h内跑批打印效率(打印耗时)报表数据（单台机单日开动率指标）
     * */
//    void run0(Calendar calendar) throws Exception;
//
//    void runEurop0(Calendar calendar) throws Exception;


    /**
     * 跑批打印效率(打印耗时)报表数据（单台机单日开动率指标）
     * */
    void run1(Calendar calendar) throws Exception;

    /**
     * 跑批打印产量（单台机单日开动率指标）
     * */
    void run2(LocalDate calendar) throws Exception;

    /**
     * 获取打印机效率报表图像结构数据(设备维度)
     */
    Map<String, Object> getReportBarDataByDevice(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData, Map<String, Object> targetmap) throws Exception;


    void run0_statistics_month(Calendar calendar)  throws Exception;
}
