package com.rootcloud.service;


import com.alibaba.fastjson.JSONObject;
import com.rootcloud.common.JsonResult2;
import com.rootcloud.domain.vo.RepPrinterReportItemVO;
import com.rootcloud.domain.vo.RepPrinterReportVO;
import com.rootcloud.service.condition.QueryUserReportCondition;

import java.util.Calendar;
import java.util.List;
import java.util.Map;

/**
 * 打印机运维报告接口
 * @author whl
 */
public interface RepPrinterReportService {

    /**
     * 产创设备跑批
     * */
    void run(Calendar calendar) throws Exception;
    /**
     * 全部3DP设备跑批
     * */
    void run1(Calendar calendar) throws Exception;

    void createUserReportV2(QueryUserReportCondition c) throws Exception;

    /**
     * 分页查找用户报告列表
     */
    public JsonResult2 reportPageList(String tenantId, String user_id, QueryUserReportCondition c) throws Exception;

    /**
     * 	根据租户id与用户报告ID 得到用户报告
     */
    public RepPrinterReportVO getUserReport(Map<String, Object> params) throws Exception;

    /**
     * 	根据id删除用户报告
     */
    public JsonResult2 deleteReportById(Long reportId) ;


    List<RepPrinterReportItemVO> getReportItem(Long reportId);

    void updateReportItem(List<RepPrinterReportItemVO> items);

    void updateUserReportValue(RepPrinterReportVO vo);



    /**
     * 产线级-指定邮箱发送打印机用户运维报告
     */
    String sendUserReportByUser(Map<String, Object> params) throws Exception;

    List<JSONObject> queryUserReport(String tenantId, QueryUserReportCondition condition) throws Exception;

}
