package com.rootcloud.service;

import com.rootcloud.common.JsonResult2;
import com.rootcloud.domain.vo.RepPrinterStarPassrateVO;
import com.rootcloud.web.dto.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import java.util.Map;


/**
 * 数据导入逻辑服务接口
 * */
public interface RepPrinterService {

    //分页查找废品原因统计列表
    public JsonResult2 deviceWastePageList(String tenantId, RepPrinterWastereasonDTO c) throws Exception;
    //分页查找砂型强度、密度合格率统计列表
    public JsonResult2 sandPassratePageList(String tenantId, RepPrinterSandPassrateDTO c) throws Exception;
    //分页查找打印产量统计列表
    public JsonResult2 outputPageList(String tenantId, RepPrinterOutputDTO c) throws Exception;
    //精度、尺寸、外观数据excel文件批量导入
    void starPassrate(MultipartFile file, Integer sxType)throws  Exception;
    //删除精度、尺寸、外观数据
    public JsonResult2 deleteStarPassrate(String tenantId, RepPrinterStarPassrateVO c) throws Exception;
    //分页查找砂型尺寸、外观、精度、合格率统计列表
    public JsonResult2 starPassratePageList(String tenantId, RepPrinterStarPassrateDTO c) throws Exception;


    Map<String, Object> sumWastereasonData(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData) throws Exception;
    //产线运维报告- 取废品原因
    Map<String, Object> sumDeviceProductWasteData(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData) throws Exception;
    Map<String, Object> sumPrinterSandPassrateData(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData) throws Exception;


    List<ChanNengLiYongLvDto> chanNengLiYongLv(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData, Map<String, Object> targetmap);
    Map<String, Object> sumPrinterSandPassrateData1(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData) throws Exception;


    /**
     * 删除操作
     * */
//    public JsonResult2 deleteDeviceWaste(String tenantId, RepPrinterWastereasonVO c) throws Exception;
//    public JsonResult2 deleteSandPassrate(String tenantId, RepPrinterSandPassrateVO c) throws Exception;
//    public JsonResult2 deleteOutput(String tenantId, RepPrinterOutputVO c) throws Exception;
//


//
//    public JsonResult2 outputPageList2(String tenantId, RepPrinterOutputDTO c) throws Exception;
//    void deviceWaste(MultipartFile file)throws  Exception;
//    void deviceWastereason(MultipartFile file)throws  Exception;
//    void sandPassrate(MultipartFile file,Integer sxType)throws  Exception;
//    void starPassrate(MultipartFile file,Integer sxType)throws  Exception;

//    Map<String, Object> sumWastereasonData(PrinterReportDTO printerReportDTO, String tenantId, Map<String,String> printerDeviceRelationData) throws CommonException;
//    Map<String, Object> sumPrinterSandPassrateData(PrinterReportDTO printerReportDTO, String tenantId, Map<String,String> printerDeviceRelationData) throws CommonException;
//    Map<String, Object> sumPrinterSandPassrateData1(PrinterReportDTO printerReportDTO, String tenantId, Map<String,String> printerDeviceRelationData) throws CommonException;
//    Map<String, Object> sumDeviceProductWasteData(PrinterReportDTO printerReportDTO, String tenantId, Map<String,String> printerDeviceRelationData) throws CommonException;


//
//
//
//
//    public JsonResult2 getRepPrinterWasteTypes();
//
//    List<ChanNengLiYongLvDto> chanNengLiYongLv(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData, Map<String, Object> targetmap);

    //    List<ChanNengLiYongLvDto> chanNengLiYongLv2(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData, Map<String, Object> targetmap);


//    List<WeiXuFeiYongTongJiDto> weiXuFeiYongTongJi(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData);
//    List<WeiXuFeiYongTongJiDto> weiXuFeiYongTongJi2(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData);
//    List<WeiXuFeiYongTongJiDto> weiXuFeiYongTongJiWeiBo(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData);
}
