package com.rootcloud.service;

import com.rootcloud.common.JsonResult2;
import com.rootcloud.domain.vo.RepPrinterTargetDicVO;
import com.rootcloud.service.condition.QueryRepPrinterTargetDicCondition;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface RepPrinterTargetDicService {

    /***
     *
     * @Title: insert
     * @Description: 新增
     * @param vo
     * @return
     */
    JsonResult2 insert(RepPrinterTargetDicVO vo);

    /***
     *
     * @Title: update
     * @Description: 更新
     * @param vo
     * @return
     */
    JsonResult2 update(RepPrinterTargetDicVO vo);

    /***
     *
     * @Title: deleteById
     * @Description: 删除
     * @param id
     * @return
     */
    JsonResult2 deleteById(@Param("id") Long id);

    /***
     *
     * @Title: getRepPrinterTargetDicById
     * @Description: 获取数据集
     * @param params id
     * @return RepPrinterTargetDicVO
     */
    RepPrinterTargetDicVO getRepPrinterTargetDicById(@Param("id") Long id);
    RepPrinterTargetDicVO getRepPrinterTargetDicByKey(@Param("statisticsType") String statisticsType, @Param("customerId") String customerId);

    /***
     *
     * @Title: getRepPrinterTargetDicList
     * @Description: 获取数据集
     * @param params
     * @return List
     */
    List<RepPrinterTargetDicVO> getRepPrinterTargetDicList(Map<String, Object> params);
    JsonResult2 getRepPrinterTargetDicList(String tenantId, QueryRepPrinterTargetDicCondition query);

    /**
     * 按统计类型分组获取最新目标值
     */
    List<RepPrinterTargetDicVO> groupByPrinterTargetDic();

}
