package com.rootcloud.service.condition;

import com.rootcloud.common.vo.RepPageVO;
import com.rootcloud.validate.annotation.NotBlank;
import io.swagger.annotations.ApiModelProperty;

public class QueryRepPrinterTargetDicCondition extends RepPageVO {

    private String customerId;  //客户编号
    private String customerName;  //客户名称

    /** 统计类型 */
    @ApiModelProperty(value = "统计类型", required = false)
    @NotBlank(message="统计类型不可以为空")
    private String statisticsType;

    /** 目标值 */
    @ApiModelProperty(value = "目标值", required = false)
    @NotBlank(message="目标值不可以为空")
    private String targetValue;


    /** 目标值(显示) */
    @ApiModelProperty(value = "目标值(显示)", required = false)
    @NotBlank(message="目标值(显示)不可以为空")
    private String targetShow;

    /** 开始日期 */
    @ApiModelProperty(value = "开始日期", required = false)
    @NotBlank(message="开始日期不可以为空")
    private String startDate;

    /** 结束日期 */
    @ApiModelProperty(value = "结束日期", required = false)
    @NotBlank(message="结束日期不可以为空")
    private String endDate;


    public String getTargetShow() {
        return targetShow;
    }

    public void setTargetShow(String targetShow) {
        this.targetShow = targetShow;
    }

    public String getStatisticsType() {
        return statisticsType;
    }

    public void setStatisticsType(String statisticsType) {
        this.statisticsType = statisticsType;
    }

    public String getTargetValue() {
        return targetValue;
    }

    public void setTargetValue(String targetValue) {
        this.targetValue = targetValue;
    }

    public String getStartDate() {
        return startDate;
    }

    public void setStartDate(String startDate) {
        this.startDate = startDate;
    }

    public String getEndDate() {
        return endDate;
    }

    public void setEndDate(String endDate) {
        this.endDate = endDate;
    }

    public String getCustomerId() {
        return customerId;
    }

    public void setCustomerId(String customerId) {
        this.customerId = customerId;
    }

    public String getCustomerName() {
        return customerName;
    }

    public void setCustomerName(String customerName) {
        this.customerName = customerName;
    }

}
