package com.rootcloud.service.impl;

import com.rootcloud.domain.dao.ConfigDao;
import com.rootcloud.domain.vo.ConfigVO;
import com.rootcloud.service.ConfigService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;


@Service("configServices")
public class ConfigServiceImpl implements ConfigService {

    @Autowired
    private ConfigDao configDao;

    @Override
    public void add(ConfigVO configVO) {
        if (null == configVO) {
            return;
        }

        configDao.add(configVO);
    }

    @Override
    public void delete(String code) {
        configDao.delete(code);
    }

    @Override
    public List<ConfigVO> find(String code) {
        return Optional.ofNullable(configDao.find(code)).orElse(new ArrayList<>(0));
    }

    @Override
    public List<ConfigVO> list() {
        return Optional.ofNullable(configDao.list()).orElse(new ArrayList<>(0));
    }

    @Override
    public Optional<ConfigVO> findOne(String code) {
        Optional<List<ConfigVO>> list = Optional.ofNullable(configDao.find(code));
        if (list.isPresent() && 0 != list.get().size()) {
            return Optional.of(list.get().get(0));
        }

        return Optional.empty();
    }

    @Override
    public void update(String code, String value) {
        ConfigVO configVO = new ConfigVO();
        configVO.setCode(code);
        configVO.setValue(value);
        configDao.update(configVO);
    }
    @Override
    public void update(ConfigVO vo) {
        ConfigVO configVO = new ConfigVO();
        configVO.setCode(vo.getCode());
        configVO.setValue(vo.getValue());
        configDao.update(configVO);
    }
}
