package com.rootcloud.service.impl;


import com.rootcloud.common.JsonResult2;
import com.rootcloud.domain.dao.CustomerDao;
import com.rootcloud.domain.dao.NxDeviceDao;
import com.rootcloud.domain.vo.CustomerVO;
import com.rootcloud.domain.vo.DeviceListVO;
import com.rootcloud.service.RepCustomerService;
import com.rootcloud.service.condition.QueryUserReportCondition;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Service("customerServices")
public class RepCustomerServiceImpl implements RepCustomerService {

    private static final Logger logger = LoggerFactory.getLogger(PrinterEfficiencyServiceImpl.class);

    @Autowired
    private CustomerDao nxCustomerDao;
    @Autowired
    private NxDeviceDao nxDeviceDao;


    //获取所有客户信息列表
    public JsonResult2 getAllCustomerList(String tenantId) throws Exception{

        JsonResult2 jsonResult=new JsonResult2();
        QueryUserReportCondition vo =new QueryUserReportCondition();
        List<CustomerVO> customers = nxCustomerDao.getAllCustomer(vo);
        try
        {
            if(customers.size() >0)
            {
                jsonResult.setData(customers);
            }
        }catch (Exception ex){}
        return  jsonResult;
    }


    //查询指定客户(机构)下所有的设备列表
    public JsonResult2 getCustomerListByUserId(String tenantId, String user_id) throws Exception{

        JsonResult2 jsonResult=new JsonResult2();
//        CustomerVO vo =new CustomerVO();
//        vo.setUserCode(user_id);
        List<CustomerVO> customers = nxCustomerDao.getCustomerListByUserId(user_id);
        try
        {
            if(customers.size() >0)
            {
                jsonResult.setData(customers);
            }
        }catch (Exception ex){}
        return  jsonResult;
    }


    //查询指定客户(机构)下所有的设备列表
    public JsonResult2 getDeviceListByCustomerCode(String tenantId, String officeId) throws Exception{

        JsonResult2 jsonResult=new JsonResult2();
        List<DeviceListVO> deviceList = nxDeviceDao.getDeviceListByCustomerId(officeId, tenantId);
        if(deviceList!=null && deviceList.size()>0){
            jsonResult.setData(deviceList);
        }
        return  jsonResult;
    }

    //查询指定客户(机构)下所有的设备编号列表
    public JsonResult2 getDeviceCodeListByCustomerCode(String tenantId, String officeId) throws Exception{

        JsonResult2 jsonResult=new JsonResult2();
        List<String> officeIds = new ArrayList<>(Arrays.asList(officeId));
        List<String> deviceCodeList = nxDeviceDao.getDeviceCodeListByCustomerCode(officeIds, tenantId); //查询设备编号（单项）
        Object[] deviceArray = new String[deviceCodeList.size()];
        for (int i = 0; i < deviceCodeList.size(); i++) {
            String[] spString = deviceCodeList.get(i).toString().split("\\s+"); //按照空格分隔
            deviceArray[i] = spString[0].toString();//截取空格前面的部分
        }
        jsonResult.setData(deviceArray);
        return  jsonResult;
    }



}
