package com.rootcloud.service.impl;

import com.rootcloud.common.util.PlatformDeviceTransUtil;
import com.rootcloud.domain.dao.RepPrinterSandPercentDAO;
import com.rootcloud.service.RepPrinterSandPercentService;
import com.rootcloud.web.dto.GuHuaJiDanHaoDto;
import com.rootcloud.web.dto.PinJunDaYinGaoDuDto;
import com.rootcloud.web.dto.PrinterReportDTO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

@Service("sandPercentServices")
public class RepPrinterSandPercentServiceImpl implements RepPrinterSandPercentService {

    private static final Logger logger = LoggerFactory.getLogger(PlatformDeviceTransUtil.class);

    @Resource
    private RepPrinterSandPercentDAO repPrinterSandPercentDAO;


    public Map<String, Object> getRepPrinterSandPercentBarData(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData)throws Exception{
        Map<String, Object> data = new HashMap<String, Object>();
        if( printerReportDTO.getStartDate()==null && printerReportDTO.getEndDate()==null ){
            return data;
        }

        Map<String, Object> result = this.getRepPrinterSandPercentList(printerReportDTO, tenantId, "",printerDeviceRelationData);
        if( result.isEmpty() ){
            return data ;
        }
        //树脂加入比
        List<Map<String, Object>> dataListSXMD = (List)result.get("dataListSXMD");
        int length = dataListSXMD==null?0:dataListSXMD.size();
        String[] xListSXMD = new String[length];//设备结果集(x轴)
        List<String> sxmdList = new ArrayList<String>();//树脂加入比
        for( int i=0; i<length;i++ ){
            Map<String, Object> map = (Map)dataListSXMD.get(i);

            xListSXMD[i]= map.get("deviceId").toString();
            sxmdList.add(map.get("sxmd").toString());
        }
        data.put("xListSXMD", xListSXMD);
        data.put("sxmdList", sxmdList);

        //漏砂量
        List<Map<String, Object>> dataListLSL = (List)result.get("dataListLSL");
        if (!CollectionUtils.isEmpty(dataListLSL)) {
            float[] avgArray = new float[dataListLSL.size()];
            Arrays.fill(avgArray,(float)result.get("rate9"));
            data.put("xListLSL", dataListLSL.stream().map(x->x.getOrDefault("deviceId","")).collect(Collectors.toList()));
            data.put("hszlArray", dataListLSL.stream().map(x->x.getOrDefault("hszl",0)).collect(Collectors.toList()));
            data.put("wsyslArray", dataListLSL.stream().map(x->x.getOrDefault("wsysl",0)).collect(Collectors.toList()));
            data.put("slylArray", dataListLSL.stream().map(x->x.getOrDefault("slyl",0)).collect(Collectors.toList()));
            data.put("avgArray", avgArray);
        }

        //新旧砂加入占比
        List<Map<String, Object>> dataListXJSZB = (List)result.get("dataListXJSZB");
        length = dataListXJSZB==null?0:dataListXJSZB.size();
        String[] xListXJSZB = new String[length];//设备结果集(x轴)
        List<String> xjszbList = new ArrayList<String>();//新旧砂加入占比
        for( int i=0; i<length;i++ ){
            Map<String, Object> map = (Map)dataListXJSZB.get(i);
            xListXJSZB[i]= map.get("deviceId").toString();
            xjszbList.add(map.get("xjszb").toString());
        }
        data.put("xListXJSZB", xListXJSZB);
        data.put("xjszbList", xjszbList);

        data.put("rate6",  result.get("rate6"));
        data.put("rate7",  result.get("rate7"));
        data.put("rate8",  result.get("rate8"));
        data.put("rate9",  result.get("rate9"));
        data.put("value4",  result.get("value4"));
        data.put("value5",  result.get("value5"));
        data.put("value5_1", result.get("value5_1"));
        data.put("value6",  result.get("value6"));

        return data;
    }

    public Map<String, Object> getRepPrinterSandPercentList(PrinterReportDTO printerReportDTO, String tenantId, String pUid, Map<String, String> printerDeviceRelationData) throws Exception{

        Map<String, Object> result = new HashMap<String, Object>();
        if( printerReportDTO.getStartDate()==null && printerReportDTO.getEndDate()==null ){
            return result;
        }

		/*
        List<Map<String, Object>> list  =  new ArrayList();
        for(int k=0;k<printerReportDTO.getDeviceIdList().size();k++)
        {
            String devicesid = printerReportDTO.getDeviceIdList().get(k).toString();
            Double cur_totalxmd =0.0;
            boolean ischanchuang =false;
            String[] deviceCodeArrys ={"2215-18","Max-A","Max-B","1800-7","2215-12","2215-27","2215-7","2215-17","2215-10","1800-4","Max-C", "2600A-1",
                    "1800-12","1800-11","1800-8","1800-10","1800-15","2500-2","2215-24","2215-13","2215-16","2215-19"};//产业创业中心\潍坊
            if(isHave(deviceCodeArrys,devicesid))
            {
                ischanchuang =true;   //判断是否产业创新中心

                List<String> liis = new ArrayList<>();
                liis = Arrays.asList(devicesid);
                PrinterReportDTO dts = new PrinterReportDTO();
                dts.setStartDate(printerReportDTO.getStartDate());
                dts.setEndDate(printerReportDTO.getEndDate());
                dts.setDeviceIdList(liis);

                List<Map<String, Object>> list1 = repPrinterSandPercentDAO.getRepPrinterSandSXMDListV3(dts);
                String firtDay = getFirstDayOfMonth1(Integer.valueOf(printerReportDTO.getStartDate().substring(0,4)), Integer.valueOf(printerReportDTO.getStartDate().substring(5,7))); //2021-02-01
                String lastDay = getLastDayOfMonth1(Integer.valueOf(printerReportDTO.getStartDate().substring(0,4)), Integer.valueOf(printerReportDTO.getStartDate().substring(5,7)));  //2021-02-28
                //遍历该月的每一天
                SimpleDateFormat dateformat = new SimpleDateFormat("yyyy-MM-dd");
                Date date = new Date(); //2020-09-01
                try {
                    date = dateformat.parse(firtDay); //2020-09-01
                }catch (Exception ex){}
//              Date date = dateformat.parse(firtDay); //2020-09-01
                Calendar cal = Calendar.getInstance();
                cal.setTime(date);//month 为指定月份任意日期
                int year1 = cal.get(Calendar.YEAR);
                int m = cal.get(Calendar.MONTH) + 1;
                //int dayNumOfMonth = getDaysByYearMonth(year1, m);
//			    int dayNumOfMonth = getDaysOfMonth(year, month);
                int dayNumOfMonth = getDaysByYearMonth2(Integer.valueOf(printerReportDTO.getStartDate().substring(0,4)), Integer.valueOf(printerReportDTO.getStartDate().substring(5,7)));
                cal.set(Calendar.DAY_OF_MONTH, 1);// 从一号开始
                int curday_Ncount =0;
                for (int i = 0; i < dayNumOfMonth; i++, cal.add(Calendar.DATE, 1))
                {
                    Date d = cal.getTime();
                    SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
                    String cur_date = simpleDateFormat.format(d);

                    Double szjrb = 0.0; //当日的树脂加入比
                    int curday_count =0;
                    for(int j=0;j<list1.size();j++)
                    {
                        String cur_year = list1.get(j).getOrDefault("data_year","0").toString();
                        String cur_month = list1.get(j).getOrDefault("data_month","0").toString();
                        String cur_day = list1.get(j).getOrDefault("data_day","0").toString();
                        if(Integer.valueOf(cur_month) <10)
                            cur_month ="0"+cur_month;
                        if(Integer.valueOf(cur_day)<10)
                            cur_day ="0"+cur_day;
                        String cur_dt = cur_year+"-"+cur_month+"-"+cur_day;
                        if(cur_date.equals(cur_dt))
                        {
                            curday_count++;

                            String hmi_jobid = list1.get(j).getOrDefault("hmi_jobid","0").toString();
                            if(hmi_jobid.indexOf("陶粒砂") > 0)
                            {
                                Double gk_sc_dy_sxmd = Double.valueOf(list1.get(j).getOrDefault("gk_sc_dy_sxmd","0").toString());
                                Double hmi_volume = Double.valueOf(list1.get(j).getOrDefault("hmi_volume","0").toString());
                                szjrb += 100* (gk_sc_dy_sxmd * hmi_volume * 1.5 * 10) /(hmi_volume * 1.5 * 1000);
                            }
                            else
                            {
                                Double gk_sc_dy_sxmd = Double.valueOf(list1.get(j).getOrDefault("gk_sc_dy_sxmd","0").toString());
                                Double hmi_volume = Double.valueOf(list1.get(j).getOrDefault("hmi_volume","0").toString());
                                szjrb += 100* (gk_sc_dy_sxmd * hmi_volume * 1.4 * 10) /(hmi_volume * 1.4 * 1000);
                            }
                        }
                    }
                    //list.get(j).getOrDefault("hmi_jobid","0").toString();
                    //当日的树脂加入比
                    if(curday_count > 0)
                    {
                        szjrb = szjrb / curday_count;
                        cur_totalxmd += Double.valueOf(String.valueOf(szjrb));
                        curday_Ncount++;
                    }

                }
                //所有天数的求均值
                String avg_xmd ="";
                if(curday_Ncount > 0)
                {
                    avg_xmd =  String.format("%.1f", cur_totalxmd / curday_Ncount);
                    Map map = new HashMap();
                    map.put("device_id",devicesid);
                    map.put("sxmd",avg_xmd);
                    list.add(map); //重组集合
                }
//                else
//                    avg_xmd ="0";
            }
            else
            {

                List<String> lis = new ArrayList<>();
                lis = Arrays.asList(devicesid);
                PrinterReportDTO dto = new PrinterReportDTO();
                dto.setStartDate(printerReportDTO.getStartDate());
                dto.setEndDate(printerReportDTO.getEndDate());
                dto.setDeviceIdList(lis);
                //树脂加入比
                List<Map<String, Object>> list1 = repPrinterSandPercentDAO.getRepPrinterSandSXMDList(dto);
                if(list1.size() > 0)
                {
                    Map map = new HashMap();
                    map.put("device_id",list1.get(0).getOrDefault("device_id","0").toString());
                    map.put("sxmd",list1.get(0).getOrDefault("sxmd","0").toString());
                    list.add(map); //重组集合
                }

            }
        }
        */

        //树脂加入比
        List<Map<String, Object>> list = repPrinterSandPercentDAO.getRepPrinterSandSXMDList(printerReportDTO);
        if( list==null || list.size()==0 ){
//        	return result; //bug, 无树脂的时候直接返回
        }
//        list.sort(Comparator.comparingDouble(str -> Double.parseDouble(str.get("sxmd").toString())));//顺序
//        Collections.sort(list,Collections.reverseOrder()); //倒序

        list = PlatformDeviceTransUtil.repalceDevice(printerDeviceRelationData, list);//平台编码转用户编码
        // 数据结果转换成前台需要的格式
        List<Map<String, Object>> dataListSXMD = list.stream().map(item -> {
            Map<String, Object> map = new HashMap<>(3);
            // 树脂加入比
            float dyhs = Float.parseFloat(item.getOrDefault("sxmd", "0").toString());
            map.put("sxmd", String.format("%.1f", dyhs));
            map.put("deviceId", item.get("device_id"));
            return map;
        }).collect(Collectors.toList());
        //计算平均值
        float total_sxmd=0;
        String ave_sxmd="0.0";//平均树脂加入占比
        float max_sxmd=0;//树脂最大加入占比
        int i=0;
        String maxDeviece = "";//树脂最大加入占比的设备
        for( Map<String, Object> item : list ){
            // 树脂加入比
            float sxmd = Float.parseFloat(item.getOrDefault("sxmd", "0").toString());
            total_sxmd +=sxmd;
            if(i==0) {
                max_sxmd = sxmd;
                maxDeviece = item.get("device_id").toString();
            }
            i++;
        }
        if( list!=null && list.size()>0 ){
            ave_sxmd =  String.format("%.1f", total_sxmd/list.size());
        }
        Map<String, Object> ave_map = new HashMap<String, Object>();
        ave_map.put("sxmd", ave_sxmd);
        ave_map.put("deviceId", "平均值");
        dataListSXMD.add(ave_map);

        //新砂占比
        list = repPrinterSandPercentDAO.getRepPrinterSandXJSZBList(printerReportDTO);
        if( list==null || list.size()==0 ){
            //return result;  //bug, 无A、B砂用量的时候直接返回造成树脂占比缺失，不能直接返回
        }
        list = PlatformDeviceTransUtil.repalceDevice(printerDeviceRelationData, list);//平台编码转用户编码
        // 数据结果转换成前台需要的格式
        List<Map<String, Object>> dataListXJSZB = list.stream().map(item -> {
            Map<String, Object> map = new HashMap<>(3);

            //新旧砂加入占比
            float dyxl = Float.parseFloat(item.getOrDefault("xjszb", "0").toString());
            map.put("xjszb", String.format("%.4f", dyxl));
            map.put("deviceId", item.get("device_id"));

            return map;
        }).collect(Collectors.toList());
        //计算平均值
        float total_xjszb=0;
        String ave_xjszb="0.0";
        int j=0;
        String xjszbTopTree = "";
        //新旧砂占比最高三台机器的xjszb值  2020-12-1加
        String TopXjszbTree = "";
        for( Map<String, Object> item : list ){
            //新旧砂加入占比
            float xjszb = Float.parseFloat(item.getOrDefault("xjszb", "0").toString());
            total_xjszb += xjszb ;
            if(j<3) {
                xjszbTopTree += item.get("device_id").toString()+"、";
                TopXjszbTree += item.getOrDefault("xjszb", "0").toString()+"、";
            }
            j++;
        }
        logger.info("总新旧砂占比为"+ total_xjszb + "；漏砂量前三的设备："+xjszbTopTree+"，这三台设备的漏砂量为"+TopXjszbTree+";" );
        if( list!=null && list.size()>0 ){
            ave_xjszb =  String.format("%.3f", total_xjszb/list.size());
        }
        Map<String, Object> ave_mapXJSZB = new HashMap<String, Object>();
        ave_mapXJSZB.put("xjszb", ave_xjszb);
        ave_mapXJSZB.put("deviceId", "平均值");
        dataListXJSZB.add(ave_mapXJSZB);

        //漏砂量
        list = repPrinterSandPercentDAO.getRepPrinterSandLSLList(printerReportDTO);
        list = PlatformDeviceTransUtil.repalceDevice(printerDeviceRelationData, list);//平台编码转用户编码
        // 数据结果转换成前台需要的格式
        List<Map<String, Object>> dataListLSL = list.stream().map(item -> {
            Map<String, Object> map = new HashMap<>(3);
            //漏砂总量
            float hszl = Float.parseFloat(item.getOrDefault("hszl", "0").toString());
            float wsysl = Float.parseFloat(item.getOrDefault("wsysl", "0").toString());
            float slyl = Float.parseFloat(item.getOrDefault("slyl", "0").toString());
            map.put("hszl", String.format("%.1f", hszl));
            map.put("wsysl", String.format("%.2f", wsysl));
            map.put("slyl", String.format("%.1f", slyl));
            map.put("deviceId", item.get("device_id"));
            return map;
        }).collect(Collectors.toList());

//        //计算平均值
        float tota_lsl=0;
        String ave_lsl="0.0";
        int k=0;
        String lslTopTree = "";
        //漏砂量前三设备的lsl值  2020-12-1加
        String ToplslTree = "";

        for( Map<String, Object> item : list ){
            //漏砂量
            float wsysl = Float.parseFloat(item.getOrDefault("wsysl", "0").toString());
            tota_lsl += wsysl ;

            if(k >= list.size()-3) {
                lslTopTree = item.get("device_id").toString()+"、"+lslTopTree;
                ToplslTree = item.getOrDefault("wsysl", "0").toString()+"、"+ToplslTree;
            }
            k++;
        }
        logger.info("总漏砂量为"+ tota_lsl + "；漏砂量前三的设备："+lslTopTree+"，这三台设备的漏砂量为"+ToplslTree+";" );
        if( list!=null && list.size()>0 ){
            ave_lsl =  String.format("%.2f", tota_lsl/list.size());
        }

        result.put("dataListSXMD", dataListSXMD);
        result.put("dataListXJSZB", dataListXJSZB);
        result.put("dataListLSL", dataListLSL);

        result.put("rate6",  Float.parseFloat(ave_sxmd));
        result.put("rate7",  max_sxmd);
        result.put("rate8",  Float.parseFloat(ave_xjszb));
        result.put("rate9",  Float.parseFloat(ave_lsl));
        result.put("value4",  maxDeviece);
        result.put("value5",  xjszbTopTree.endsWith("、")?xjszbTopTree.substring(0, xjszbTopTree.length()-1):xjszbTopTree); //新旧砂占比最高的三台设备ID
        result.put("value5_1",  TopXjszbTree.endsWith("、")?TopXjszbTree.substring(0, TopXjszbTree.length()-1):TopXjszbTree); //这三台设备的新旧砂占比值
        result.put("value6",  lslTopTree.endsWith("、")?lslTopTree.substring(0, lslTopTree.length()-1):lslTopTree);  //漏砂量最高的三台设备ID
        result.put("value6_1",  ToplslTree.endsWith("、")?ToplslTree.substring(0, ToplslTree.length()-1):ToplslTree);    //这三台设备的漏砂量

        return result;
    }


    public List<PinJunDaYinGaoDuDto> pinJunDaYinGaoDu(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData) {
        List<PinJunDaYinGaoDuDto> list = repPrinterSandPercentDAO.pinJunDaYinGaoDu(printerReportDTO);
        if( list==null || list.size()==0 ){
            return new ArrayList<>();
        }
        //设备编码转换
        for (PinJunDaYinGaoDuDto dto: list) {
            String userDeviceId = printerDeviceRelationData.get(dto.getDeviceId())==null?
                    dto.getDeviceId():printerDeviceRelationData.get(dto.getDeviceId());
            dto.setDeviceId(userDeviceId);
        }
        return list;
    }

    public List<GuHuaJiDanHaoDto> guHuaJiDanHao(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData) {
        List<GuHuaJiDanHaoDto> list = repPrinterSandPercentDAO.guHuaJiDanHao(printerReportDTO);
        if( list==null || list.size()==0 ){
            return new ArrayList<>();
        }
        //设备编码转换
        for (GuHuaJiDanHaoDto dto: list) {
            String userDeviceId = printerDeviceRelationData.get(dto.getDeviceId())==null?
                    dto.getDeviceId():printerDeviceRelationData.get(dto.getDeviceId());
            dto.setDeviceId(userDeviceId);
        }
        return list;
    }





}
