package com.rootcloud.service.impl;

import com.github.pagehelper.PageInfo;
import com.rootcloud.common.JsonResult2;
import com.rootcloud.common.JsonResultStatus;
import com.rootcloud.common.util.PlatformDeviceTransUtil;
import com.rootcloud.domain.dao.RepPrinterOutputDao;
import com.rootcloud.domain.dao.RepPrinterSandPassrateDao;
import com.rootcloud.domain.dao.RepPrinterStarPassrateDao;
import com.rootcloud.domain.dao.RepPrinterWastereasonDao;
import com.rootcloud.domain.vo.*;
import com.rootcloud.service.RepPrinterService;
import com.rootcloud.web.dto.*;
import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.CellType;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.time.LocalDate;
import java.time.Period;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.stream.Collectors;

//import com.rootcloud.saas.common.page.Paging;
//import org.apache.commons.lang.StringUtils;

//@Service("printerService")
@Service("repPrinterServices")
public class RepPrinterServiceImpl implements RepPrinterService {

    private static final org.slf4j.Logger log = LoggerFactory.getLogger(RepPrinterServiceImpl.class);

//    @Autowired

    @Autowired
    private RepPrinterOutputDao repPrinterOutputDao;
//    @Autowired

    @Autowired
    private RepPrinterWastereasonDao repPrinterWastereasonDao;

    @Autowired
    private RepPrinterSandPassrateDao repPrinterSandPassrateDao;

    @Autowired
    private RepPrinterStarPassrateDao repPrinterStarPassrateDao;

//    @Autowired
//    private RepPrinterReportDAO repPrinterReportDAO;
//

//    @Autowired
//    private RepPrinterSandPercentService repPrinterSandPercentService ;

    public JsonResult2 deviceWastePageList(String tenantId, RepPrinterWastereasonDTO c) throws Exception {
        Integer pageNum = StringUtils.isNotBlank(c.getPageNo())?Integer.parseInt(c.getPageNo()):1;
        Integer pageSize = StringUtils.isNotBlank(c.getPageSize())?Integer.parseInt(c.getPageSize()):10;

        JsonResult2 jsonResult=new JsonResult2();
        int startIndex  = (pageNum -1 ) * pageSize;

        RepPrinterWastereasonVO v = new RepPrinterWastereasonVO();
        PropertyUtils.copyProperties(v, c.getVo());
        v.setStartNo(startIndex);
        v.setEndNo(pageNum * pageSize);
        List<RepPrinterWastereasonVO> reasonlist = repPrinterWastereasonDao.listPage(v);
        Integer count = repPrinterWastereasonDao.list(v).size();
        PageInfo<RepPrinterWastereasonVO> pageInfo = new PageInfo<>(reasonlist);
        pageInfo.setPageNum(pageNum);
        pageInfo.setPageSize(pageSize);
        pageInfo.setTotal(count);
        return new JsonResult2(pageInfo);
    }


    public JsonResult2 sandPassratePageList(String tenantId, RepPrinterSandPassrateDTO c) throws Exception {
        Integer pageNum = StringUtils.isNotBlank(c.getPageNo())?Integer.parseInt(c.getPageNo()):1;
        Integer pageSize = StringUtils.isNotBlank(c.getPageSize())?Integer.parseInt(c.getPageSize()):10;

        JsonResult2 jsonResult=new JsonResult2();
        int startIndex  = (pageNum -1 ) * pageSize;

        RepPrinterSandPassrateVO v = new RepPrinterSandPassrateVO();
        PropertyUtils.copyProperties(v, c.getVo());
        v.setStartNo(startIndex);
        v.setEndNo(pageNum * pageSize);
        List<RepPrinterSandPassrateVO> list = repPrinterSandPassrateDao.listPage(v);
        Integer count = repPrinterSandPassrateDao.list(v).size();

        PageInfo<RepPrinterSandPassrateVO> pageInfo = new PageInfo<>(list);
        pageInfo.setPageNum(pageNum);
        pageInfo.setPageSize(pageSize);
        pageInfo.setTotal(count);
        return new JsonResult2(pageInfo);
    }
//
    public JsonResult2 outputPageList(String tenantId, RepPrinterOutputDTO c) throws Exception{
        Integer pageNum = StringUtils.isNotBlank(c.getPageNo())?Integer.parseInt(c.getPageNo()):1;
        Integer pageSize = StringUtils.isNotBlank(c.getPageSize())?Integer.parseInt(c.getPageSize()):10;

        JsonResult2 jsonResult=new JsonResult2();
        int startIndex  = (pageNum -1 ) * pageSize;

        RepPrinterOutputVO v = new RepPrinterOutputVO();
        PropertyUtils.copyProperties(v, c.getVo());
        v.setStartNo(startIndex);
        v.setEndNo(pageNum * pageSize);
        List<RepPrinterOutputVO> list = repPrinterOutputDao.listPage(v);
        Integer count = repPrinterOutputDao.list(v).size();

        PageInfo<RepPrinterOutputVO> pageInfo = new PageInfo<>(list);
        pageInfo.setPageNum(pageNum);
        pageInfo.setPageSize(pageSize);
        pageInfo.setTotal(count);
        return new JsonResult2(pageInfo);
    }

    //砂型尺寸、外观、精度 Excel批量导入
    public void starPassrate(MultipartFile file,Integer sxType) throws Exception {
        HSSFWorkbook wb = new HSSFWorkbook(file.getInputStream()); // 根据页面index 获取sheet页

        HSSFSheet sheet = wb.getSheetAt(0);

        List<RepPrinterStarPassrateVO> repPrinterStarPassrateVOList = new ArrayList<RepPrinterStarPassrateVO>();// 实体类集合

        HSSFRow row = null;
        // 循环sesheet页中数据从第二行开始，第一行是标题

        for (int i = 1; i < sheet.getPhysicalNumberOfRows(); i++) {
            // 获取每一行数据
            row = sheet.getRow(i);

            // 单元格数据格式化
            row.getCell(0).setCellType(CellType.STRING);
            row.getCell(1).setCellType(CellType.STRING);
            row.getCell(2).setCellType(CellType.STRING);
            row.getCell(3).setCellType(CellType.STRING);
            row.getCell(4).setCellType(CellType.STRING);
            row.getCell(5).setCellType(CellType.STRING);
            row.getCell(6).setCellType(CellType.STRING);

            try{
                RepPrinterStarPassrateVO repPrinterSandPassrateVO = new RepPrinterStarPassrateVO();
                repPrinterSandPassrateVO.setSxType(sxType);
                repPrinterSandPassrateVO.setDeviceId(row.getCell(0).getStringCellValue());
                repPrinterSandPassrateVO.setStartDate(row.getCell(1).getStringCellValue() );
                repPrinterSandPassrateVO.setEndDate(row.getCell(2).getStringCellValue() );
                repPrinterSandPassrateVO.setCustomerName(row.getCell(3).getStringCellValue());

                repPrinterSandPassrateVO.setItemInspect( Integer.parseInt( row.getCell(4).getStringCellValue() ) );
                repPrinterSandPassrateVO.setItemHgnum( Integer.parseInt( row.getCell(5).getStringCellValue() ) );
                repPrinterSandPassrateVO.setItemHglv(BigDecimal.valueOf(Float.parseFloat(row.getCell(6).getStringCellValue())));
                repPrinterStarPassrateVOList.add(repPrinterSandPassrateVO);
            }catch(Exception e){}
            // 去除重复项
//			List<RepPrinterSandPassrateVO> repPrinterSandPassrateVOS = repPrinterSandPassrateDao.list(repPrinterSandPassrateVO);
//			if (CollectionUtils.isEmpty(repPrinterSandPassrateVOS)) {
//				repPrinterSandPassrateVOList.add(repPrinterSandPassrateVO);
//			}
        }
        if(repPrinterStarPassrateVOList!=null && repPrinterStarPassrateVOList.size()>0){
            repPrinterStarPassrateDao.add(repPrinterStarPassrateVOList);
        }

    }

    //删除精度、尺寸、外观数据
    public JsonResult2 deleteStarPassrate(String tenantId, RepPrinterStarPassrateVO c) throws Exception{
        JsonResult2 jsonResult=new JsonResult2();
        try {
            repPrinterStarPassrateDao.deleteStarPassrate(c);
        }catch(Exception e) {
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), "星级评价指标数据删除失败！");
        }
        return jsonResult;
    }
    //分页查找砂型尺寸、外观、精度、合格率统计列表
    public JsonResult2 starPassratePageList(String tenantId, RepPrinterStarPassrateDTO c) throws Exception {
        Integer pageNum = StringUtils.isNotBlank(c.getPageNo())?Integer.parseInt(c.getPageNo()):1;
        Integer pageSize = StringUtils.isNotBlank(c.getPageSize())?Integer.parseInt(c.getPageSize()):10;

        JsonResult2 jsonResult=new JsonResult2();
        int startIndex  = (pageNum -1 ) * pageSize;

        RepPrinterStarPassrateVO v = new RepPrinterStarPassrateVO();
        PropertyUtils.copyProperties(v, c.getVo());
        v.setStartNo(startIndex);
        v.setEndNo(pageNum * pageSize);
        List<RepPrinterStarPassrateVO> list = repPrinterStarPassrateDao.listPage(v);

        PageInfo<RepPrinterStarPassrateVO> pageList = new PageInfo<RepPrinterStarPassrateVO>(list);
        Integer count = repPrinterStarPassrateDao.list(v).size();

        PageInfo<RepPrinterStarPassrateVO> pageInfo = new PageInfo<>(list);
        pageInfo.setPageNum(pageNum);
        pageInfo.setPageSize(pageSize);
        pageInfo.setTotal(count);
        return new JsonResult2(pageInfo);
    }


    //产线运维报告- 取废品原因
    public Map<String, Object> sumWastereasonData(PrinterReportDTO printerReportDTO, String tenantId, Map<String,String> printerDeviceRelationData) throws Exception {
        Map<String, Object> result = new HashMap<String, Object>();

        List<Map<String,Object>> list = repPrinterWastereasonDao.sumWastereasonData(printerReportDTO);
        if( list==null || list.size()==0 ){
            return result;
        }

        List<String> waste_types = list.stream().map(item -> item.get("waste_type").toString()).collect(Collectors.toList());
        String[] typeArray = new String[waste_types.size()];
        String top3Types = "";
        for(int i=0;i<waste_types.size();i++) {
            String type = waste_types.get(i);
            typeArray[i] = type;
            if(i<3) {
                top3Types += type +"、";
            }
        }

        BigDecimal total = new BigDecimal(0);
        for(Map<String,Object> m : list) {
            BigDecimal count = (BigDecimal) m.get("count");
            total = total.add(count);
        }
        String[] countArray = new String[list.size()];
        for(int i=0;i<list.size();i++) {
            Map<String,Object> m = list.get(i);
            BigDecimal count = (BigDecimal) m.get("count");
            DecimalFormat df =new DecimalFormat("0.0");
            countArray[i] = df.format(count.multiply(new BigDecimal(100)).divide(total, 2, BigDecimal.ROUND_HALF_UP))+"%";
        }

        result.put("types", typeArray);
        result.put("proportions", countArray);
        result.put("top3WastereasonTypes", top3Types.endsWith("、")?top3Types.substring(0, top3Types.length()-1):top3Types);
        return result;
    }

    public Map<String, Object> sumDeviceProductWasteData(PrinterReportDTO printerReportDTO, String tenantId, Map<String, String> printerDeviceRelationData) throws Exception {
        Map<String, Object> result = new HashMap<String, Object>();
        List<Map<String,Object>> list = repPrinterOutputDao.sumDeviceProductWasteData(printerReportDTO);
        list = PlatformDeviceTransUtil.repalceDevice(printerDeviceRelationData, list);
        if( list==null || list.size()==0 ){
            return result;
        }
        String[] deviceArray = new String[list.size()];
        Object[] clArray = new String[list.size()];
        Object[] hglArray = new String[list.size()];
        Object[] fplArray = new String[list.size()];
        Object[] devfplArray = new String[list.size()];

        DecimalFormat df =new DecimalFormat("0.0");
        DecimalFormat df1 =new DecimalFormat("0.000");
        BigDecimal avgDevfpnum = new BigDecimal(0);
        BigDecimal avgFpnum = new BigDecimal(0);
        BigDecimal clSum =  new BigDecimal(0);

        Map<String, Object> topThreeDevfplMap = new HashMap<String, Object>();

        for(int i=0;i<list.size();i++) {
            Map<String,Object> m = list.get(i);
            String device_id = (String) m.get("device_id");
            BigDecimal cl = (BigDecimal) m.get("cl");//产量
            BigDecimal hgl = (BigDecimal) m.get("hgl");//合格量
            BigDecimal fpl = (BigDecimal) m.get("fpl");
            BigDecimal devfpl = (BigDecimal) m.get("devfpl");
            BigDecimal devfpnum = (BigDecimal) m.get("devfpnum");//设备废品量
            BigDecimal fpnum = (BigDecimal) m.get("fpnum");//总废品量
            deviceArray[i] = device_id;
            try {
                clArray[i] = df.format(cl.doubleValue());
                hglArray[i] = df.format(hgl.doubleValue());
                fplArray[i] = df1.format(fpl.doubleValue());
                devfplArray[i] = df1.format(devfpl.doubleValue());
            } catch (Exception e) {
                clArray[i] = "0";
                hglArray[i] = "0";
                fplArray[i] = "0";
                devfplArray[i] = "0";
            }

            clSum = clSum.add(cl);
            avgDevfpnum = avgDevfpnum.add(devfpnum);
            avgFpnum = avgFpnum.add(fpnum);

            topThreeDevfplMap = getTopThree(topThreeDevfplMap, devfpl.floatValue(), device_id);
        }

        result.put("deviceArray", deviceArray);
        result.put("clArray", clArray);
        result.put("hglArray", hglArray);
        result.put("fplArray", fplArray);
        result.put("devfplArray", devfplArray);

        String top3Devfpl = "";
        String[] deviceIds = (String[])topThreeDevfplMap.get("deviceIds");
        for(String id:deviceIds ){
            top3Devfpl += id+"、" ;
        }

        result.put("avgFpl", df1.format(avgFpnum.divide(clSum, 4, BigDecimal.ROUND_HALF_UP)));
        result.put("avgDevFpl", df1.format(avgDevfpnum.divide(clSum, 4, BigDecimal.ROUND_HALF_UP)));
        result.put("top3DevfplDevices", top3Devfpl.endsWith("、")?top3Devfpl.substring(0, top3Devfpl.length()-1):top3Devfpl);
        return result;
    }

    //获取前三数据
    private Map<String, Object> getTopThree(Map<String, Object> map, float number, String deviceId){
        float[] topThree ;
        String[] deviceIds ;
        if(map.isEmpty()){
            topThree = new float[3];
            deviceIds = new String[3];
            topThree[0]=number;
            deviceIds[0]=deviceId;
        }else{
            topThree = (float[])map.get("topThree");
            deviceIds = (String[])map.get("deviceIds");
            for( int i=0;i<3;i++ ){
                if( topThree[i]<number ){
                    topThree[i] = number ;
                    deviceIds[i] = deviceId ;
                    break ;
                }
            }
        }
        //数组从小到大自排序
        final float THRESHOLD = 0.000000f;
        String[] newDeviceIds = new String[3];
        float index1=topThree[0], index2=topThree[1], index3=topThree[2];
        Arrays.sort(topThree);
        for( int i=0;i<3;i++ ){
            if( Math.abs(topThree[i]-index1) == THRESHOLD){
                newDeviceIds[i]=deviceIds[0];
            }
            if( Math.abs(topThree[i]-index2) == THRESHOLD ){
                newDeviceIds[i]=deviceIds[1];
            }
            if( Math.abs(topThree[i]-index3) == THRESHOLD ){
                newDeviceIds[i]=deviceIds[2];
            }
        }

        map.put("topThree", topThree);
        map.put("deviceIds", newDeviceIds);
        return map ;
    }

    public Map<String, Object> sumPrinterSandPassrateData(PrinterReportDTO printerReportDTO, String tenantId, Map<String,String> printerDeviceRelationData) throws Exception {
        Map<String, Object> result = new HashMap<String, Object>();
        List<Map<String,Object>> list = repPrinterSandPassrateDao.sumPrinterSandPassrateData(printerReportDTO);
        if( list==null || list.size()==0 ){
            return result;
        }
        list = PlatformDeviceTransUtil.repalceDevice(printerDeviceRelationData, list);
        String[] deviceArray = new String[list.size()];
        Object[] rateArray = new String[list.size()];
        Object[] aveArray = new String[list.size()];

        DecimalFormat df =new DecimalFormat("0.000");
        DecimalFormat df1 =new DecimalFormat("0.00");
        BigDecimal sxmd_total = new BigDecimal(0);
        Long count_total = new Long(0);
        String top3MdbhgDevices = "";
        for(int i=0;i<list.size();i++) {
            Map<String,Object> m = list.get(i);
            String device_id = (String) m.get("device_id");
            BigDecimal sxmd = (BigDecimal) m.get("sxmd");
            BigDecimal sxmdAve = (BigDecimal) m.get("sxmdAve");
            Long count = (Long) m.get("count");
            deviceArray[i] = device_id;
            rateArray[i] = df.format(sxmd.divide(new BigDecimal(count), 3, BigDecimal.ROUND_HALF_UP));
            aveArray[i] = df1.format(sxmdAve.divide(new BigDecimal(count), 3, BigDecimal.ROUND_HALF_UP));
            sxmd_total = sxmd_total.add(sxmd);
            count_total = count_total + count;
            if (i >= list.size() -3) {
                top3MdbhgDevices = "、"+device_id+top3MdbhgDevices;
            }
        }
        result.put("deviceArray", deviceArray);
        result.put("rateArray", rateArray);//合格率
        result.put("aveArray", aveArray);//密度平均值
        result.put("top3MdbhgDevices", top3MdbhgDevices.startsWith("、")?top3MdbhgDevices.substring(1):top3MdbhgDevices);
        result.put("avgSxmd", df.format(sxmd_total.divide(new BigDecimal(count_total), 2, BigDecimal.ROUND_HALF_UP)));
        return result;
    }

    public List<ChanNengLiYongLvDto> chanNengLiYongLv(PrinterReportDTO printerReportDTO, String tenantId,
                                                      Map<String, String> printerDeviceRelationData, Map<String, Object> targetmap) {
        List<ChanNengLiYongLvDto> list = repPrinterOutputDao.chanNengLiYongLv(printerReportDTO);
        if( list==null || list.size()==0 ){
            return new ArrayList<>();
        }
        //设备编码转换
        for (ChanNengLiYongLvDto dto: list) {
            String userDeviceId = printerDeviceRelationData.get(dto.getDeviceId())==null?
                    dto.getDeviceId():printerDeviceRelationData.get(dto.getDeviceId());
            dto.setDeviceId(userDeviceId);
        }
        int days = daysDiff(printerReportDTO.getStartDate(),printerReportDTO.getEndDate());
        for(ChanNengLiYongLvDto dto: list) {
            String device_id = dto.getDeviceId();//设备
            Double cl = dto.getChanLiang();//产量
            Double cn = 0d;//产能
            String deviceType = device_id.startsWith("SDream") ? "SDream" : device_id.split("-")[0];
            dto.setDeviceType(deviceType);
            RepPrinterTargetDicVO v = (RepPrinterTargetDicVO)targetmap.get("CN_" + deviceType);
            if (v != null ) {
                cn = days * v.getTargetValue().doubleValue();
            }
            if (cn > 0) {
                dto.setLiYongLv(cl.doubleValue() / cn);
            }
            dto.setChanNeng(cn);
        }
        Map<String,List<ChanNengLiYongLvDto>> ChanNengLiYongLvMap = list.stream().collect(Collectors.groupingBy(ChanNengLiYongLvDto::getDeviceType));
        ChanNengLiYongLvMap.forEach(
                (x,y)->{
                    double avg = y.stream().mapToDouble(ChanNengLiYongLvDto::getLiYongLv).average().orElse(0d);
                    y.forEach(
                            yy -> yy.setAvg(avg)
                    );
                }
        );
        //排序
        Collections.sort(list,new Comparator<ChanNengLiYongLvDto>() {
            @Override
            public int compare(ChanNengLiYongLvDto o1, ChanNengLiYongLvDto o2) {
                if (o1 != null && o2 != null) {
                    if (o1.getChanLiang().equals(o2.getChanLiang())) {
                        return o1.getDeviceId().compareTo(o2.getDeviceId());
                    } else {
                        return o2.getChanLiang().compareTo(o1.getChanLiang());
                    }
                }
                return 0;
            }
        });
        return list;
    }
    public Map<String, Object> sumPrinterSandPassrateData1(PrinterReportDTO printerReportDTO, String tenantId, Map<String,String> printerDeviceRelationData) throws Exception {
        Map<String, Object> result = new HashMap<String, Object>();
        List<Map<String,Object>> list = repPrinterSandPassrateDao.sumPrinterSandPassrateQiangDuData(printerReportDTO);
        if( list==null || list.size()==0 ){
            return result;
        }
        list = PlatformDeviceTransUtil.repalceDevice(printerDeviceRelationData, list);
        String[] deviceArray = new String[list.size()];
        Object[] rateArray = new String[list.size()];
        Object[] aveArray = new String[list.size()];
        DecimalFormat df =new DecimalFormat("0.000");
        DecimalFormat df1 =new DecimalFormat("0.00");
        BigDecimal sxmd_total = new BigDecimal(0);
        Long count_total = new Long(0);
        String top3MdbhgDevices = "";
        for(int i=0;i<list.size();i++) {
            Map<String,Object> m = list.get(i);
            String device_id = (String) m.get("device_id");
            BigDecimal sxmd = (BigDecimal) m.get("sxmd");
            BigDecimal sxmdAve = (BigDecimal) m.get("sxmdAve");
            Long count = (Long) m.get("count");
            deviceArray[i] = device_id;
            rateArray[i] = df.format(sxmd.divide(new BigDecimal(count), 3, BigDecimal.ROUND_HALF_UP));
            aveArray[i] = df1.format(sxmdAve.divide(new BigDecimal(count), 3, BigDecimal.ROUND_HALF_UP));

            sxmd_total = sxmd_total.add(sxmd);
            count_total = count_total + count;

            if (i >= list.size() -3) {
                top3MdbhgDevices = "、"+device_id+top3MdbhgDevices;
            }
        }
        result.put("deviceArray", deviceArray);
        result.put("rateArray", rateArray);//合格率
        result.put("aveArray", aveArray);//密度平均值
        result.put("top3MdbhgDevices", top3MdbhgDevices.startsWith("、")?top3MdbhgDevices.substring(1):top3MdbhgDevices);
        result.put("avgSxmd", df.format(sxmd_total.divide(new BigDecimal(count_total), 2, BigDecimal.ROUND_HALF_UP)));
        return result;
    }





    private int daysDiff(String startDate, String endDate) {
        DateTimeFormatter dtf = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        LocalDate start = LocalDate.parse(startDate, dtf);
        LocalDate end = LocalDate.parse(endDate, dtf);
        return Period.between(start,end).getDays()+1;
    }


}
