package com.rootcloud.service.impl;

import com.github.pagehelper.PageInfo;
import com.rootcloud.common.JsonResult2;
import com.rootcloud.domain.dao.RepPrinterTargetDicDAO;
import com.rootcloud.domain.vo.RepPrinterTargetDicVO;
import com.rootcloud.service.RepPrinterTargetDicService;
import com.rootcloud.service.condition.QueryRepPrinterTargetDicCondition;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service("targetService")
public class RepPrinterTargetDicServiceImpl implements RepPrinterTargetDicService {

    @Resource
    private RepPrinterTargetDicDAO repPrinterTargetDicDAO;

    @Override
    public JsonResult2 insert(RepPrinterTargetDicVO vo) {
        JsonResult2 jr = new JsonResult2();

        repPrinterTargetDicDAO.insert(vo);

        return jr ;
    }

    @Override
    public JsonResult2 update(RepPrinterTargetDicVO vo) {
        repPrinterTargetDicDAO.update(vo);
        return new JsonResult2();
    }

    @Override
    public JsonResult2 deleteById(Long id) {
        repPrinterTargetDicDAO.deleteById(id);

        return new JsonResult2();
    }

    @Override
    public RepPrinterTargetDicVO getRepPrinterTargetDicById(Long id) {
        return repPrinterTargetDicDAO.getRepPrinterTargetDicById(id);
    }

    @Override
    public RepPrinterTargetDicVO getRepPrinterTargetDicByKey(String statisticsType,String customerId) {
        return repPrinterTargetDicDAO.getRepPrinterTargetDicByKey(statisticsType,customerId);
    }

    @Override
    public JsonResult2  getRepPrinterTargetDicList(String tenantId, QueryRepPrinterTargetDicCondition c) {

        JsonResult2 jsonResult=new JsonResult2();
        try{
            Integer pageNum = StringUtils.isNotBlank(c.getPageNo())?Integer.parseInt(c.getPageNo()):1;
            Integer pageSize = StringUtils.isNotBlank(c.getPageSize())?Integer.parseInt(c.getPageSize()):10;

            int startIndex  = (pageNum -1 ) * pageSize;
            Map<String,Object> params = new HashMap<String,Object>();
//            params.put("tenantId", tenantId);
            params.put("statisticsType", c.getStatisticsType());
            params.put("customerId", c.getCustomerId());
            params.put("customerId", c.getCustomerId());
            params.put("startNo", startIndex);
            params.put("endNo",pageNum * pageSize);

            List<RepPrinterTargetDicVO> list = repPrinterTargetDicDAO.getRepPrinterTargetDicList(params);
            PageInfo<RepPrinterTargetDicVO> pageInfo = new PageInfo<RepPrinterTargetDicVO>(list);

            Integer count = repPrinterTargetDicDAO.getRepPrinterTargetDicListCount(params).size();
            pageInfo.setPageNum(pageNum);
            pageInfo.setPageSize(pageSize);
            pageInfo.setTotal(count);

        }catch (Exception e){
            e.printStackTrace();
//            JsonResult2.setRet(JsonResultStatus.DEVICE_FAIL.getRet());
//            JsonResult2.setMsg(JsonResultStatus.DEVICE_FAIL.getMsg());
        }
        return jsonResult;
    }

    @Override
    public List<RepPrinterTargetDicVO> groupByPrinterTargetDic() {
        return repPrinterTargetDicDAO.groupByPrinterTargetDic();
    }

    @Override
    public List<RepPrinterTargetDicVO> getRepPrinterTargetDicList(Map<String, Object> params) {
        return repPrinterTargetDicDAO.getRepPrinterTargetDicList(params);
    }
}
