package com.rootcloud.timer;

import com.rootcloud.common.JsonResult2;
import com.rootcloud.common.util.DateUtils;
import com.rootcloud.service.PrinterEfficiencyService;
import com.rootcloud.service.RepPrinterReportService;
import com.rootcloud.service.RepPrinterStarEvaluateService;
import jline.internal.Log;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.util.Calendar;
import java.util.Date;

@Component
public class MainTimer {

    private static final Logger logger = LoggerFactory.getLogger(MainTimer.class);

    @Resource(name = "efficiency")
    private PrinterEfficiencyService printerEfficiencyService;
    @Resource(name = "reportService")
    private RepPrinterReportService repPrinterReportService;
    @Resource(name = "starPrinterServices")
    private RepPrinterStarEvaluateService starEvaluateServices;



//    /** 2点整开始执行批任务- 有效打印时间、打印效率*/
//    @Scheduled(cron = "0 30 4 * * ?")
//    public void runDayEfficiencyService() {
//
//        Calendar c = Calendar.getInstance();
//        c.add(Calendar.DAY_OF_MONTH, -1);
        // 2022-09-16  由温海龙那边跑p统一处理
//        try{
//            logger.info("2点整开始执行批任务- 按照批次计算 有效打印时间、打印效率、补图率...");
//            printerEfficiencyService.run0((Calendar) c.clone());
//            //跑完后，需要统计一下月时长
//            printerEfficiencyService.run0_statistics_month((Calendar) c.clone());
//        }catch (Exception ex1){
//            logger.error("出现异常2点整开始执行批任务- 按照批次计算 有效打印时间、打印效率、补图率...");
//        }

        // 2022-12-13 由温海龙提出注掉
//        try {
//            logger.info("定时生成按批次跑批工作时长、打印效率、布图率(rep_printer_efficiency)等报表数据...");
//            printerEfficiencyService.run1((Calendar) c.clone());
//        } catch (Exception ex2) {
//            logger.error("定时生成按批次跑批工作时长、打印效率、布图率(rep_printer_efficiency)等报表数据失败...",ex2);
//        }
//        try {
//            logger.info("定时生成工作时长(IROOTECH/gk_day_wktime_info、gk_day_volume_info表)报表时长、产量数据...");
//            printerEfficiencyService.run2(LocalDate.now().minusDays(1));
//        } catch (Exception ex) {
//            logger.error("定时生成工作时长、产量报表数据失败...", ex);
//        }
//    }

    /** 7点整开始执行批任务- 海外奥钢联设备 按照批次计算 有效打印时间、打印效率、补图率*/
    // 2022-09-16  由温海龙那边跑p统一处理
//    @Scheduled(cron = "0 0 7 * * ?")
//    public void runDayEfficiencyService2() {
//        Calendar c = Calendar.getInstance();
//        c.add(Calendar.DAY_OF_MONTH, -1);//前一天
//        try {
//            //定时生成单日打印耗时 24H内（每日01:00:00定时执行 rep_printer_efficiency2）-单台机运维报告统计单日开动率用
//            printerEfficiencyService.runEurop0((Calendar) c.clone());
//            //跑完后，需要统计一下月时长
//            printerEfficiencyService.run0_statistics_month((Calendar) c.clone());
//        } catch (Exception e) {
//            logger.error("定时生成打印机单日打印耗时数据失败...", e);
//        }
//    }

    // 2022-12-13 由温海龙提出注掉 定时任务
    /** 2点30分整开始执行批任务- 产创设备密度过滤详细数据*/
//    @Scheduled(cron = "0 30 2 * * ?")
//    public void runDayPrinteProcessDataService() {
//        Calendar c = Calendar.getInstance();
//        c.add(Calendar.DAY_OF_MONTH, -1);
//        try {
//            logger.info("定时生成按批次跑批打印耗时、树脂加入、漏砂、打印体积、AB砂、打印耗时、打印层数、固化剂等(rep_printer_sand_percent)等报表数据...");
//            repPrinterReportService.run((Calendar) c.clone());
//        } catch (Exception ex) {
//            logger.error("定时生成按批次跑批打印耗时、树脂加入、漏砂、打印体积、AB砂、打印耗时、打印层数、固化剂等(rep_printer_sand_percent)等报表数据失败...", ex);
//        }
//    }
//    /** 2点50分整开始执行批任务- 全部设备打印过程详细数据*/
//    @Scheduled(cron = "0 50 2 * * ?")
//    public void runDayPrinteProcessDataService2() {
//        Calendar c = Calendar.getInstance();
//        c.add(Calendar.DAY_OF_MONTH, -1);
//        try {
//            logger.info("定时生成按批次跑批打印耗时、树脂加入、漏砂、打印体积、AB砂、打印耗时、打印层数、固化剂等(rep_printer_sand_percent2)等报表数据...");
//            repPrinterReportService.run1((Calendar) c.clone());
//        } catch (Exception ex) {
//            logger.error("定时生成按批次跑批打印耗时、树脂加入、漏砂、打印体积、AB砂、打印耗时、打印层数、固化剂等(rep_printer_sand_percent2)等报表数据失败...", ex);
//        }
//    }
//
//    /**
//     * 跑批设备星级评价 统计数据 （每日05:00:00定时执行）
//     * @Scheduled(cron = "0 0/5 0-23 * * ?")
//     */
//    @Scheduled(cron = "0 0 5 * * ?")
//    public void runstarEvaluateReport() {
//        try {
//            Calendar c = Calendar.getInstance();
//            c.add(Calendar.DAY_OF_MONTH, -1); //前一天
//            starEvaluateServices.run((Calendar) c.clone());
//            logger.info("定时任务生成星级评价统计数据成功...");
//        } catch (Exception e) {
//            logger.error("定时任务设备星级评价统计跑批失败...", e);
//        }
//    }
//
//
//
//
//
//    /**
//     * 30分钟检查一次运行状态
//     */
//    @Scheduled(cron = "0 */30 * * * ?")
//    public void checkWorkData() {
//        try {
//
//            Date dtNow = new Date();
//            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//            try
//            {
//                String nowString = formatter.format(dtNow);
//                logger.info("正在检测系统运行状态......"+nowString);
////                logger.info("正在检测设备工况数据......"+new Date());
////                logger.info("正在检测设备工况数据1......"+nowString);
////                logger.info("正在检测设备工况数据2......"+new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
//            }catch (Exception ex){}
//
//        } catch (Exception e) {
//            logger.error("工况检查失败", e);
//        }
//    }
//
//    /**
//     * 2分钟检查一次
//     */
//    @Scheduled(cron = "0 0/10 8-20 * * ?")
//    public void cron() {
//        try {
////            logger.info("cron打印时间......"+new Date());
//        } catch (Exception e) {
//            logger.error("工况检查失败", e);
//        }
//    }
}
