package com.rootcloud.timer;

import com.rootcloud.domain.service.sp.ServicePlanService;
import jline.internal.Log;
import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * @author lujiumin
 * @date 2023/1/9
 * 描述：
 */
@Component
@Slf4j
@EnableScheduling
public class ServicePlanTimer {

    @Resource(name = "servicePlanServiceImpl")
    ServicePlanService planService;


    /**
     * 定时处理设置了触发条件为系统时间的
     */
    @Scheduled(cron = "0 * 5,6,7,8,9,10,11,12,14 * * ?")
    public void scheduledProcessing(){
        log.info("服务计划自动触发定时任务开始....");
        planService.scheduledProcessing();
        log.info("服务计划自动触发定时任务结束....");
    }

    /**
     * 定时修改服务状态
     */
    @Scheduled(cron = "0 0 7,23 * * ?")
    public void updateStatusScheduled(){
        planService.updateStatusScheduled();
    }



    //@Scheduled(cron = "0 0 10 * * ?")
    public void execute(){
        planService.execute();
    }


    /**
     * 定时查询报警
     */
    @Scheduled(cron = "0 0/15 * * * ?")
    public void queryAlarm(){
        planService.queryAlarmQz();
    }

}
