package com.rootcloud.timer;

import com.rootcloud.domain.service.fittings.SparePartService;
import io.swagger.annotations.ApiOperation;
import jline.internal.Log;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;

import javax.annotation.Resource;

/**
 * @author lujiumin
 * @date 2023/1/11
 * 描述：
 */
@Component
@EnableScheduling
public class SparePartTimer {

    @Resource(name = "sparePartServiceImpl")
    private SparePartService sparePartService;

    /**
     * 定时处理设置了触发条件为系统时间的
     */
    @Scheduled(cron = "0 */5 * * * ?")
    public void scheduledProcessing() {
        Log.info("自动填充租户ID定时任务启动....");
        try {
            sparePartService.paddingZhid();
        } catch (Exception e) {
            Log.error("自动填充租户失败，失败原因：" + e.getMessage());
        }
        Log.info("自动填充租户ID定时任务结束....");
    }

    @Scheduled(cron = "0 0 23 * * ?")
    public void partLifeWarning() {
        Log.info("备件寿命预警定时任务启动....");
        sparePartService.uptPartSmyj();
        Log.info("备件寿命预警定时任务启动....");
    }
    @Scheduled(cron = "0 0 6 * * ?")
    public void syncWorkingTime(){    //2024-06whl 20231012 小时改天数
        Log.info("同步备件工作时长开始");
        sparePartService.syncWorkingTime();
        Log.info("同步备件工作时长结束");
    }


}
