package com.rootcloud.vo.device;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;

import java.sql.Timestamp;

/**
 * TODO
 *
 * @author wei.liao
 * @version 1.0
 * @date 2022/4/18 17:26
 */
@Data
@ApiModel("设备信息")
@Builder
public class DeviceInfo {
    @ApiModelProperty("设备id")
    private String id;
    //设备详情：设备编号、设备名称，地址详情、定位时间、在线时间、在线时长、设备别名、设备监控、设备在线状态
    @ApiModelProperty("设备编号")
    private String code;
    @ApiModelProperty("设备名称")
    private String name;
    private String typeName;
    private String modelName;
    @ApiModelProperty("地址详情")
    private String address;
    @ApiModelProperty("定位时间")
    private Timestamp locationTime;
    @ApiModelProperty("在线时间")
    private String onlineTime;
    @ApiModelProperty("设备别名")
    private String alias;
    private String clientUserName;
    @ApiModelProperty("设备监控")
    private String monitor;
    @ApiModelProperty("设备在线状态")
    private Integer status;
    @ApiModelProperty(value = "设备经纬度",example = "[123.2,22]")
    private String[] location;
    @ApiModelProperty("设备联网状态")
    private Integer networkStatus;
    @ApiModelProperty("设备入云时间")
    private String cloudTime;


    @ApiModelProperty("维保结束时间")
    private String warrantyTime;

    @ApiModelProperty("保修状态")
    private String warrantyStatus;

    @ApiModelProperty("客户名称")
    private String customerName;

    @ApiModelProperty("设备出厂日期")
    private String deviceStartTime;

    @ApiModelProperty("设备状态")
    private String deviceStatus;

}
