package com.rootcloud.vo.device;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.math.RoundingMode;


@Data
@ApiModel("设备首页详情")
public class DeviceTypeVO {

    @ApiModelProperty("设备名称")
    private String  deviceName;

    @ApiModelProperty("设备类型")
    private String  deviceType;

    @ApiModelProperty("设备编码")
    private String  deviceCode;


    @ApiModelProperty("设备型号")
    private String  deviceSbxh;

    @ApiModelProperty("设备运行时长")
    private String  onlineTime;

    @ApiModelProperty("设备出厂日期")
    private String deviceFactoryDate;

    @ApiModelProperty("任务名称")
    private String  taskName;

    @ApiModelProperty("开始时间")
    private String  startTime;

    @ApiModelProperty("结束时间")
    private String  endTime;

    @ApiModelProperty("打印耗时")
    private String  printTime;

    @ApiModelProperty("打印层厚")
    private String  printLayer;

    @ApiModelProperty("打印体积")
    private String  printVolume;

    @ApiModelProperty("打印层耗时")
    private String  printLayerTime;

    @ApiModelProperty("打印总层数")
    private String  printAllLayer;

    @ApiModelProperty("当前打印层数")
    private String nowPrintLayer;

    @ApiModelProperty("任务进度= 当前打印层数/打印总层数 *100%")
    private String  taskProgress;


    @ApiModelProperty("1.打印中 2.待机 3.离线")
    private String deviceStatus;


    @ApiModelProperty("报警")
    private Boolean alarm;


    @ApiModelProperty("设备来源")
    private String deviceSource;


    public String getTaskProgress(){
        if(StringUtils.isNotBlank(this.printAllLayer)  && StringUtils.isNotBlank(this.nowPrintLayer)){
            if(new BigDecimal(this.printAllLayer).compareTo(BigDecimal.ZERO)  == 0){
                return "0%";
            }else{
                BigDecimal divide = new BigDecimal(this.nowPrintLayer).divide(new BigDecimal(this.printAllLayer), 4, RoundingMode.HALF_UP);
                return divide.multiply(new BigDecimal(100)).setScale( 2, BigDecimal.ROUND_HALF_UP) + "%";
            }
        }
        return "0%";
    }

}
