package com.rootcloud.vo.device;

import com.rootcloud.domain.entity.sp.NxTriggerConditionEntity;
import com.rootcloud.vo.service.MaintenanceListVo;
import com.rootcloud.vo.service.NxUserInfoVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@Data
@ApiModel("计划任务详情")
public class ServicePlanDetailVO {

    @ApiModelProperty("服务计划主键")
    private String servicePlanId;

    @ApiModelProperty("设备编码")
    private String  deviceCode;

    @ApiModelProperty("计划名称")
    private String  planName;

    @ApiModelProperty("计划类型")
    private String  planType;

    @ApiModelProperty("设备类型")
    private String  deviceType;

    @ApiModelProperty("设备型号")
    private String  deviceSbxh;

    @ApiModelProperty("设备类型名称")
    private String  deviceTypeName;

    @ApiModelProperty("设备型号名称")
    private String dviceModelName;

    @ApiModelProperty("计划周期【1：日2：周3：月4：年】")
    private Integer  planCycle;

    @ApiModelProperty("计划间隔")
    private Integer  planInterval;

    @ApiModelProperty("计划状态【0：待启动1：进行中2：已完成3：已暂停】")
    private Integer  planStatus;

    @ApiModelProperty("创建时间")
    private String  createTime;

    @ApiModelProperty("计划时间段开始时间")
    private String  planStartTime;

    @ApiModelProperty("计划时间段结束时间")
    private String  planEndTime;

    @ApiModelProperty("是否超时【0：未超时 1：已超时】")
    private Integer  isTimeout;

    @ApiModelProperty("提醒方式【0：邮件1：短信 2：站内信")
    private String  planRemindWay;

    @ApiModelProperty("完成时间节点【几天内】")
    private Integer  finishTimeNode;

    @ApiModelProperty("保养")
    private String  maintainContent;

    @ApiModelProperty("起停状态0停止1启动")
    private Integer  isStart;

    @ApiModelProperty("处理状态【0.不需要处理，1.需要处理】")
    private Integer detailStatus;

    @ApiModelProperty("下一个周期时间")
    private String nextCycleTime;

    @ApiModelProperty("计划类型名称")
    private String planTypeName;

    @ApiModelProperty("计划周期名称")
    private String planCycleName;

    @ApiModelProperty("计划状态名称")
    private String planStatusName;

    @ApiModelProperty("是否超时名称")
    private String isTimeoutName;

    @ApiModelProperty("提醒方式名称")
    private String planRemindWayName;

    @ApiModelProperty("保养内容名称")
    private String maintainContentName;

    @ApiModelProperty("临时触发时间")
    private String  planLscfsj;

    @ApiModelProperty("保养类型：一级保养、二级保养、三级保养、专项保养")
    private String maintenanceType;


    @ApiModelProperty("触发条件集合")
    private NxTriggerConditionEntity condition;

    @ApiModelProperty("设置提醒用户信息")
    private NxUserInfoVo nxUserInfoVo;


    @ApiModelProperty("服务项目名称")
    private List<MaintenanceListVo> maintenanceListVo;

    @ApiModelProperty("设备ID")
    private String  deviceId;


}
