package com.rootcloud.vo.order;


import com.rootcloud.common.NotBlank;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel(value = "APP订单签到入参")
public class OrderSignInParam {

    @ApiModelProperty("签到时间")
    private String orderSigntime;


    @ApiModelProperty(value = "签到地址", required = true)
    @NotBlank(message="签到地址不能为空")
    private String orderSignaddress;


    @ApiModelProperty(value = "签到地址_经度", required = true)
    @NotBlank(message="签到地址经度不能为空")
    private String orderSignaddressLongitude;


    @ApiModelProperty(value = "签到地址_维度", required = true)
    @NotBlank(message="签到地址维度不能为空")
    private String orderSignaddressDimension;


    @ApiModelProperty("签到图片")
    private String orderSignfile;


    @ApiModelProperty(value = "订单主键", required = true)
    @NotBlank(message="订单主键不能为空")
    private String nxOrderId;

    @ApiModelProperty("订单流程对象")
    private OrderLcinfoParam orderLcinfo;
}
