package com.rootcloud.vo.service;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;


@Data
@AllArgsConstructor
@NoArgsConstructor
public class ServicePlanInfoVO {

    private String servicePlanId;

    @ApiModelProperty("设备编码")
    private String  deviceCode;

    @ApiModelProperty("计划名称")
    private String  planName;

    @ApiModelProperty("计划类型")
    private String  planType;

    @ApiModelProperty("设备类型")
    private String  deviceType;

    @ApiModelProperty("设备型号")
    private String  deviceSbxh;

    @ApiModelProperty("设备类型名称")
    private String  deviceTypeName;

    @ApiModelProperty("设备型号名称")
    private String dviceModelName;

    @ApiModelProperty("计划周期【1：日2：周3：月4：年】")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private Integer  planCycle;

    @ApiModelProperty("计划间隔")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private Integer  planInterval;

    @ApiModelProperty("计划状态【0：待启动1：进行中2：已完成3：已暂停】")
    private Integer  planStatus;

    @ApiModelProperty("创建时间")
    private String  createTime;

    @ApiModelProperty("计划时间段开始时间")
    private String  planStartTime;

    @ApiModelProperty("计划时间段结束时间")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String  planEndTime;

    @ApiModelProperty("是否超时【0：未超时 1：已超时】")
    private Integer  isTimeout;

    @ApiModelProperty("提醒方式【0：邮件1：短信 2：站内信")
    private String  planRemindWay;

    @ApiModelProperty("完成时间节点【几天内】")
    private Integer  finishTimeNode;

    @ApiModelProperty("保养")
    private String  maintainContent;

    @ApiModelProperty("起停状态0停止1启动")
    private Integer  isStart;

    @ApiModelProperty("处理状态【0.不需要处理，1.需要处理】")
    private Integer detailStatus;

    @ApiModelProperty("下一个周期时间")
    private String nextCycleTime;

    @ApiModelProperty("计划类型名称")
    private String planTypeName;

    @ApiModelProperty("计划周期名称")
    private String planCycleName;

    @ApiModelProperty("计划状态名称")
    private String planStatusName;

    @ApiModelProperty("是否超时名称")
    private String isTimeoutName;

    @ApiModelProperty("提醒方式名称")
    private String planRemindWayName;

    @ApiModelProperty("保养内容名称")
    private String maintainContentName;

    @ApiModelProperty("保养类型：一级保养、二级保养、三级保养、专项保养")
    private String maintenanceType;

    @ApiModelProperty("最新触发时间")
    private String latestTriggerTime;

    @ApiModelProperty("是否解决")
    private String planSfjj;

    @ApiModelProperty("设备名称")
    private String deviceName;

    @ApiModelProperty("客户名称")
    private String customerName;

}
