package com.rootcloud.web;

import com.alibaba.fastjson.JSON;
import com.rootcloud.common.JsonResult2;
import com.rootcloud.common.JsonResultStatus;
import com.rootcloud.common.util.DateUtils;
import com.rootcloud.domain.dao.RepPrinterOutputDao;
import com.rootcloud.domain.dao.RepPrinterSandPassrateDao;
import com.rootcloud.domain.dao.RepPrinterWastereasonDao;
import com.rootcloud.domain.dao.TargetTypeDAO;
import com.rootcloud.domain.vo.*;
import com.rootcloud.service.RepPrinterService;
import com.rootcloud.web.dto.*;
import groovy.util.logging.Slf4j;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

@Api(tags = "生产过程数据上传统计控制器")
@RestController
@Slf4j
@RequestMapping("/import")
public class RepPrinterController {

    private static final Logger logger = LoggerFactory.getLogger(RepPrinterController.class);
    @Autowired
    private RepPrinterWastereasonDao repPrinterWastereasonDao;
    @Autowired
    private RepPrinterOutputDao repPrinterOutputDao;

    @Autowired
    private RepPrinterSandPassrateDao repPrinterSandPassrateDao;

    @Autowired
    private TargetTypeDAO repTargetTypeDao;

    @Resource(name = "repPrinterServices")
    private RepPrinterService service;

    @RequestMapping(method = RequestMethod.POST, value = "/addDeviceWastereasonBatch")
    @ResponseBody
    @ApiOperation("设备废品原因数据批量写入")
    public JsonResult2 addDeviceWastereasonBatch(@RequestBody List<RepPrinterWastereasonVO> params) throws Exception {
        try
        {
            List<RepPrinterWastereasonVO> repPrinterWastereasonVOList = new ArrayList<RepPrinterWastereasonVO>();// 实体类集合
            if(!CollectionUtils.isEmpty(params)){
                for(int i=0;i<params.size();i++)
                {
                    RepPrinterWastereasonVO repPrinterWastereasonVO = new RepPrinterWastereasonVO();
                    repPrinterWastereasonVO.setStartDate(params.get(i).getStartDate());
                    repPrinterWastereasonVO.setEndDate(params.get(i).getEndDate());
                    repPrinterWastereasonVO.setWasteType(params.get(i).getWasteType());
                    repPrinterWastereasonVO.setGkScDyCount(params.get(i).getGkScDyCount());
                    repPrinterWastereasonVO.setCustomerName(params.get(i).getCustomerName());
                    repPrinterWastereasonVO.setCustomerCode(params.get(i).getCustomerCode());
                    repPrinterWastereasonVO.setOfficeId(params.get(i).getOfficeId());
                    repPrinterWastereasonVOList.add(repPrinterWastereasonVO);
                }

            }
            if( repPrinterWastereasonVOList!=null && repPrinterWastereasonVOList.size()>0 ){
                for(int i=0;i<params.size();i++)
                {
                    RepPrinterWastereasonVO vo =new RepPrinterWastereasonVO();
                    vo.setStartDate(params.get(i).getStartDate());
                    vo.setEndDate(params.get(i).getEndDate());
                    vo.setWasteType(params.get(i).getWasteType());
                    vo.setCustomerName(params.get(i).getCustomerName());
                    vo.setCustomerCode(params.get(i).getCustomerCode());
                    vo.setOfficeId(params.get(i).getOfficeId());
                    List<RepPrinterWastereasonVO> list = repPrinterWastereasonDao.list(vo);
                    if(!CollectionUtils.isEmpty(list))
                    {
                        RepPrinterWastereasonVO vo1 =new RepPrinterWastereasonVO();
                        vo1.setStartDate(params.get(i).getStartDate());
                        vo1.setEndDate(params.get(i).getEndDate());
                        vo1.setWasteType(params.get(i).getWasteType());
                        vo1.setCustomerName(params.get(i).getCustomerName());
                        vo1.setCustomerCode(params.get(i).getCustomerCode());
                        vo1.setOfficeId(params.get(i).getOfficeId());
                        vo1.setId(list.get(0).getId());
                        repPrinterWastereasonDao.deleteDeviceWasteUpload(vo1);
                    }
                }
                repPrinterWastereasonDao.add(repPrinterWastereasonVOList);
            }
            return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "设备废品原因写入成功！");
        }
        catch (Exception ex){
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), JsonResultStatus.DEVICE_FAIL.getMsg());
        }

    }



    @RequestMapping(method = RequestMethod.POST, value = "/addDeviceWasteBacth")
    @ResponseBody
    @ApiOperation("设备废品率数据批量写入")
    public JsonResult2 addDeviceWasteBach(@RequestBody List<RepPrinterOutputVO> params) throws Exception {
        try
        {
            List<RepPrinterOutputVO> repPrinterOutputVOList = new ArrayList<RepPrinterOutputVO>();// 实体类集合
            if(!CollectionUtils.isEmpty(params)){
                for(int i=0;i<params.size();i++)
                {
                    RepPrinterOutputVO repPrinterOutputVO = new RepPrinterOutputVO();
                    repPrinterOutputVO.setDeviceId(params.get(i).getDeviceId());
                    repPrinterOutputVO.setStartDate(params.get(i).getStartDate());
                    repPrinterOutputVO.setEndDate(params.get(i).getEndDate());
                    repPrinterOutputVO.setGkScDyCl(params.get(i).getGkScDyCl());
                    repPrinterOutputVO.setGkScDyHgl(params.get(i).getGkScDyHgl());
                    repPrinterOutputVO.setGkScDyFpnum(params.get(i).getGkScDyFpnum());
                    repPrinterOutputVO.setGkScDyDevfpnum(params.get(i).getGkScDyDevfpnum());
                    repPrinterOutputVO.setGkScDyFpl(params.get(i).getGkScDyFpl());
                    repPrinterOutputVO.setGkScDyDevfpl(params.get(i).getGkScDyDevfpl());
                    repPrinterOutputVOList.add(repPrinterOutputVO);
                }

            }
            if( repPrinterOutputVOList!=null && repPrinterOutputVOList.size()>0 ){
                for(int i=0;i<params.size();i++)
                {
                    RepPrinterOutputVO vo =new RepPrinterOutputVO();
                    vo.setDeviceId(params.get(i).getDeviceId());
                    vo.setStartDate(params.get(i).getStartDate());
                    vo.setEndDate(params.get(i).getEndDate());
                    List<RepPrinterOutputVO> list = repPrinterOutputDao.list(vo);
                    if(!CollectionUtils.isEmpty(list))
                    {
                        RepPrinterOutputVO vo1 =new RepPrinterOutputVO();
                        vo1.setDeviceId(params.get(i).getDeviceId());
                        vo1.setStartDate(params.get(i).getStartDate());
                        vo1.setEndDate(params.get(i).getEndDate());
                        vo1.setId(list.get(0).getId());
                        repPrinterOutputDao.deleteOutputUpload(vo1);
                    }
                }
                repPrinterOutputDao.add(repPrinterOutputVOList);
            }
            return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "设备废品率写入成功！");
        }
        catch (Exception ex){
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), JsonResultStatus.DEVICE_FAIL.getMsg());
        }

    }



    @RequestMapping(method = RequestMethod.POST, value = "/addSandPassrateQiangDuBatch")
    @ResponseBody
    @ApiOperation("砂型强度数据批量写入")
    public JsonResult2 addSandPassrateQiangDuBatch(@RequestBody List<RepPrinterSandPassrateVO> params) throws Exception {
        try
        {
            List<RepPrinterSandPassrateVO> repPrinterSandPassrateVOList = new ArrayList<RepPrinterSandPassrateVO>();// 实体类集合
            if(!CollectionUtils.isEmpty(params)){
                for(int i=0;i<params.size();i++)
                {
                    RepPrinterSandPassrateVO repPrinterSandPassrateVO = new RepPrinterSandPassrateVO();
                    repPrinterSandPassrateVO.setSxType(1); //0表示砂型密度，1表示砂型强度
                    repPrinterSandPassrateVO.setDeviceId(params.get(i).getDeviceId());
                    repPrinterSandPassrateVO.setStartDate(params.get(i).getStartDate());
                    repPrinterSandPassrateVO.setEndDate(params.get(i).getEndDate());
                    repPrinterSandPassrateVO.setSxmdHgnum(params.get(i).getSxmdHgnum());
                    repPrinterSandPassrateVO.setSxmdTotal(params.get(i).getSxmdTotal());
                    repPrinterSandPassrateVO.setGkScDySxmd(params.get(i).getGkScDySxmd());
                    repPrinterSandPassrateVO.setSxmdAve(params.get(i).getSxmdAve());
                    repPrinterSandPassrateVOList.add(repPrinterSandPassrateVO);
                }
            }
            if(repPrinterSandPassrateVOList!=null && repPrinterSandPassrateVOList.size()>0){
                for(int i=0;i<params.size();i++)
                {
                    RepPrinterSandPassrateVO vo =new RepPrinterSandPassrateVO();
                    vo.setStartDate(params.get(i).getStartDate());
                    vo.setEndDate(params.get(i).getEndDate());
                    vo.setDeviceId(params.get(i).getDeviceId());
                    vo.setSxType(1);
                    List<RepPrinterSandPassrateVO> list = repPrinterSandPassrateDao.list(vo);
                    if(!CollectionUtils.isEmpty(list))
                    {
                        RepPrinterSandPassrateVO vo1 =new RepPrinterSandPassrateVO();
                        vo1.setStartDate(params.get(i).getStartDate());
                        vo1.setEndDate(params.get(i).getEndDate());
                        vo1.setDeviceId(params.get(i).getDeviceId());
                        vo1.setSxType(1);
                        vo1.setId(list.get(0).getId());
                        repPrinterSandPassrateDao.deleteSandPassrateUpload(vo1);
                    }
                }
                repPrinterSandPassrateDao.add(repPrinterSandPassrateVOList);
            }
            return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "砂型强度数据写入成功！");
        }
        catch (Exception ex){
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), JsonResultStatus.DEVICE_FAIL.getMsg());
        }

    }


    @RequestMapping(method = RequestMethod.POST, value = "/addSandPassrateBatch")
    @ResponseBody
    @ApiOperation("砂型密度数据批量写入")
    public JsonResult2 addSandPassrateBatch(@RequestBody List<RepPrinterSandPassrateVO> params) throws Exception {
        try
        {
            List<RepPrinterSandPassrateVO> repPrinterSandPassrateVOList = new ArrayList<RepPrinterSandPassrateVO>();// 实体类集合
            if(!CollectionUtils.isEmpty(params)){
                for(int i=0;i<params.size();i++)
                {
                    RepPrinterSandPassrateVO repPrinterSandPassrateVO = new RepPrinterSandPassrateVO();
                    repPrinterSandPassrateVO.setSxType(0);//0表示砂型密度，1表示砂型强度
                    repPrinterSandPassrateVO.setDeviceId(params.get(i).getDeviceId());
                    repPrinterSandPassrateVO.setStartDate(params.get(i).getStartDate());
                    repPrinterSandPassrateVO.setEndDate(params.get(i).getEndDate());
                    repPrinterSandPassrateVO.setSxmdHgnum(params.get(i).getSxmdHgnum());
                    repPrinterSandPassrateVO.setSxmdTotal(params.get(i).getSxmdTotal());
                    repPrinterSandPassrateVO.setGkScDySxmd(params.get(i).getGkScDySxmd());
                    repPrinterSandPassrateVO.setSxmdAve(params.get(i).getSxmdAve());
                    repPrinterSandPassrateVOList.add(repPrinterSandPassrateVO);
                }

            }
            if(repPrinterSandPassrateVOList!=null && repPrinterSandPassrateVOList.size()>0){
                for(int i=0;i<params.size();i++)
                {
                    RepPrinterSandPassrateVO vo =new RepPrinterSandPassrateVO();
                    vo.setStartDate(params.get(i).getStartDate());
                    vo.setEndDate(params.get(i).getEndDate());
                    vo.setDeviceId(params.get(i).getDeviceId());
                    vo.setSxType(0);
                    List<RepPrinterSandPassrateVO> list = repPrinterSandPassrateDao.list(vo);
                    if(!CollectionUtils.isEmpty(list))
                    {
                        RepPrinterSandPassrateVO vo1 =new RepPrinterSandPassrateVO();
                        vo1.setStartDate(params.get(i).getStartDate());
                        vo1.setEndDate(params.get(i).getEndDate());
                        vo1.setDeviceId(params.get(i).getDeviceId());
                        vo1.setSxType(0);
                        vo1.setId(list.get(0).getId());
                        repPrinterSandPassrateDao.deleteSandPassrateUpload(vo1);
                    }
                }
                repPrinterSandPassrateDao.add(repPrinterSandPassrateVOList);
            }
            return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "砂型密度数据写入成功！");
        }
        catch (Exception ex){
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), JsonResultStatus.DEVICE_FAIL.getMsg());
        }

    }


    //----------------------------运维报告目标类型变量操作 start---------------------------------------------------
    @ApiOperation(value = "运维报告目标类型变量写入", notes = "运维报告目标类型变量写入")
    @RequestMapping(method = RequestMethod.POST, value = "/addTargetTypeValue")
    @ResponseBody
    public JsonResult2 addTargetTypeValue(@RequestBody RepPrinterTargetTypeDTO condition) throws Exception {
        try
        {
            TargetTypeVO vo =new TargetTypeVO();
            vo.setTargetName(condition.getTargetName());
            vo.setTargetCode(condition.getTargetCode());
            List<TargetTypeVO> list = repTargetTypeDao.list(vo);
            if(!CollectionUtils.isEmpty(list))
            {
                return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "当前目标类型已存在，请检查！");
            }
            else
            {
                repTargetTypeDao.insert(vo);
                return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "目标类型写入成功！");
            }
        }
        catch (Exception ex){
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), JsonResultStatus.DEVICE_FAIL.getMsg());
        }
    }

    @RequestMapping(method = RequestMethod.POST, value = "/updateTargetTypeValue")
    @ResponseBody
    @ApiOperation("运维报告目标类型变量更新")
    public JsonResult2 updateTargetTypeValue(@RequestBody RepPrinterTargetTypeDTO condition) throws Exception {

        try
        {
            TargetTypeVO vo =new TargetTypeVO();
            vo.setTargetName(condition.getTargetName());
            vo.setTargetCode(condition.getTargetCode());
            vo.setId(Long.valueOf(condition.getId()));
            repTargetTypeDao.update(vo);
            return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "目标类型更新成功！");
        }
        catch (Exception ex){
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), JsonResultStatus.DEVICE_FAIL.getMsg());
        }
    }

    @RequestMapping(method = RequestMethod.POST, value = "/delTargetTypeValue")
    @ResponseBody
    @ApiOperation("运维报告目标类型变量删除")
    public JsonResult2 delTargetTypeValue(@RequestBody RepPrinterTargetTypeDTO condition) throws Exception {

        try
        {
            repTargetTypeDao.deleteById(Long.valueOf(condition.getId()));
            return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "目标类型删除成功！");
        }
        catch (Exception ex){
//            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), JsonResultStatus.DEVICE_FAIL.getMsg());
            return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "目标类型删除失败！");
        }
    }

    @RequestMapping(method = RequestMethod.POST, value = "/getTargetTypeList")
    @ResponseBody
    @ApiOperation("运维报告目标类型变量查询")
    public JsonResult2 getTargetTypeList() throws Exception {
        JsonResult2 json = new JsonResult2();
        try
        {
            json.setData(repTargetTypeDao.getTargetTypeList());
            return json;
        }
        catch (Exception ex){
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), JsonResultStatus.DEVICE_FAIL.getMsg());
        }
    }
    //----------------------------运维报告目标类型变量操作 end---------------------------------------------------


    @ApiOperation(value="分页查找废品原因统计列表", notes="分页查找废品原因统计列表")
    @PostMapping("/deviceWastePageList")
    public JsonResult2 deviceWastePageList(@RequestHeader("tenant_id") String tenant_id, @RequestHeader("user_id") String user_id, @RequestBody RepPrinterWastereasonDTO c) {
        try {
            String startDate = c.getVo().getStartDate();
            if(StringUtils.isNotBlank(startDate)) {
                startDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", startDate), "yyyy-M-d");
                c.getVo().setStartDate(startDate);
            }
            String endDate = c.getVo().getEndDate();
            if(StringUtils.isNotBlank(endDate)) {
                endDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", endDate), "yyyy-M-d");
                c.getVo().setEndDate(endDate);
            }
            JsonResult2 res = service.deviceWastePageList(tenant_id, c);
            return res;
        } catch (Exception e) {
            logger.error("分页查找列表失败", e);
            String msg = e.getMessage()!=null?e.getMessage():JsonResultStatus.SYS_EXCEPTION.getMsg();
            return new JsonResult2(JsonResultStatus.SYS_EXCEPTION.getRet(), msg);
        }
    }

    @ApiOperation(value="分页查找砂型密度合格率统计列表", notes="分页查找砂型密度合格率统计列表")
    @PostMapping("/sandPassratePageList")
    public JsonResult2 sandPassratePageList(@RequestHeader("tenant_id") String tenant_id, @RequestHeader("user_id") String user_id, @RequestBody RepPrinterSandPassrateDTO c) {
        try {
            String startDate = c.getVo().getStartDate();
            if(StringUtils.isNotBlank(startDate)) {
                startDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", startDate), "yyyy-M-d");
                c.getVo().setStartDate(startDate);
            }
            String endDate = c.getVo().getEndDate();
            if(StringUtils.isNotBlank(endDate)) {
                endDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", endDate), "yyyy-M-d");
                c.getVo().setEndDate(endDate);
            }
            c.getVo().setSxType(0);
            JsonResult2 res = service.sandPassratePageList(tenant_id, c);
            return res;
        } catch (Exception e) {
            logger.error("分页查找列表失败", e);
            String msg = e.getMessage()!=null?e.getMessage():JsonResultStatus.SYS_EXCEPTION.getMsg();
            return new JsonResult2(JsonResultStatus.SYS_EXCEPTION.getRet(), msg);
        }
    }

    @ApiOperation(value="分页查找砂型强度合格率统计列表", notes="分页查找砂型密度合格率统计列表")
    @PostMapping("/sandPassrateQiangDuPageList")
    public JsonResult2 sandPassrateQiangDuPageList(@RequestHeader("tenant_id") String tenant_id, @RequestHeader("user_id") String user_id, @RequestBody RepPrinterSandPassrateDTO c) {
        try {
            String startDate = c.getVo().getStartDate();
            if(StringUtils.isNotBlank(startDate)) {
                startDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", startDate), "yyyy-M-d");
                c.getVo().setStartDate(startDate);
            }
            String endDate = c.getVo().getEndDate();
            if(StringUtils.isNotBlank(endDate)) {
                endDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", endDate), "yyyy-M-d");
                c.getVo().setEndDate(endDate);
            }
            c.getVo().setSxType(1);
            JsonResult2 res = service.sandPassratePageList(tenant_id, c);
            return res;
        } catch (Exception e) {
            logger.error("分页查找列表失败", e);
            String msg = e.getMessage()!=null?e.getMessage():JsonResultStatus.SYS_EXCEPTION.getMsg();
            return new JsonResult2(JsonResultStatus.SYS_EXCEPTION.getRet(), msg);
        }
    }

    @ApiOperation(value="分页查找打印产量统计列表", notes="分页查找打印产量统计列表")
    @PostMapping("/outputPageList")
    public JsonResult2 outputPageList(@RequestHeader("tenant_id") String tenant_id, @RequestHeader("user_id") String user_id, @RequestBody RepPrinterOutputDTO c) {
        try {
            String startDate = c.getVo().getStartDate();
            if(StringUtils.isNotBlank(startDate)) {
                startDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", startDate), "yyyy-M-d");
                c.getVo().setStartDate(startDate);
            }
            String endDate = c.getVo().getEndDate();
            if(StringUtils.isNotBlank(endDate)) {
                endDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", endDate), "yyyy-M-d");
                c.getVo().setEndDate(endDate);
            }
            JsonResult2 res = service.outputPageList(tenant_id, c);
            return res;
        } catch (Exception e) {
            logger.error("分页查找列表失败", e);
            String msg = e.getMessage()!=null?e.getMessage():JsonResultStatus.SYS_EXCEPTION.getMsg();
            return new JsonResult2(JsonResultStatus.SYS_EXCEPTION.getRet(), msg);
        }
    }


    //-----------------------------------------星级评价合格率指标库操作-----------------------------------------------
    @PostMapping("/starPassrateSize")
    @ResponseBody
    @ApiOperation("砂型尺寸导入数据")
    public JsonResult2 starPassrateSize(@RequestParam("file") MultipartFile file) {
        try {
            if (file.isEmpty()) {
                return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), "文件为空！");
            }
            service.starPassrate(file,0);
        } catch (Exception e) {
            e.printStackTrace();
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), "读取砂型尺寸文件失败！");
        }
        return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "砂型尺寸导入成功！");

    }
    @PostMapping("/starPassrateOutward")
    @ResponseBody
    @ApiOperation("砂型外观导入数据")
    public JsonResult2 starPassrateOutward(@RequestParam("file") MultipartFile file) {
        try {
            if (file.isEmpty()) {
                return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), "文件为空！");
            }
            service.starPassrate(file,1);
        } catch (Exception e) {
            e.printStackTrace();
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), "读取砂型外观文件失败！");
        }
        return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "砂型外观导入成功！");

    }
    @PostMapping("/starPassratePrecision")
    @ResponseBody
    @ApiOperation("砂型精度导入数据")
    public JsonResult2 starPassratePrecision(@RequestParam("file") MultipartFile file) {
        try {
            if (file.isEmpty()) {
                return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), "文件为空！");
            }
            service.starPassrate(file,2);
        } catch (Exception e) {
            e.printStackTrace();
            return new JsonResult2(JsonResultStatus.DEVICE_FAIL.getRet(), "读取砂型精度文件失败！");
        }
        return new JsonResult2(JsonResultStatus.SUCCESS.getRet(), "砂型精度导入成功！");

    }
    @ApiOperation(value="根据导入日期删除砂型检验的合格率", notes="根据导入日期(格式：yyyy-MM-dd)根据导入日期删除砂型检验的合格率")
    @PostMapping("/deleteStarPassrate")
    public JsonResult2 deleteStarPassrate(@RequestHeader("tenant_id") String tenant_id, @RequestHeader("user_id") String user_id, @RequestBody RepPrinterStarPassrateVO c) {
        String vc = JSON.toJSONString(c);
        logger.info("start method : deleteStarPassrate, tenant_id ="+tenant_id+" user_id = "+user_id+" RepPrinterStarPassrateVO : "+ vc);
        try {
            JsonResult2 res = service.deleteStarPassrate(tenant_id, c);
            logger.info("end method : deleteStarPassrate,  tenant_id ="+tenant_id+" user_id = "+user_id+" RepPrinterStarPassrateVO : "+ vc+" result: "+JSON.toJSONString(res));
            return res;
        } catch (Exception e) {
            logger.error("method : deleteStarPassrate, tenant_id ="+tenant_id+" user_id = "+user_id+" RepPrinterStarPassrateVO : "+ vc + " exception:", e);
            String msg = e.getMessage()!=null?e.getMessage():JsonResultStatus.SYS_EXCEPTION.getMsg();
            return new JsonResult2(JsonResultStatus.SYS_EXCEPTION.getRet(), msg);
        }
    }
    //-----------------------------------------------------------------------------------------------------------------------------------


    @RequestMapping(method = RequestMethod.POST, value = "/querySandPassrateQiangDuImportDate")
    @ResponseBody
    @ApiOperation("查询砂型强度数据最新导入记录时间") //2021/06/26
    public JsonResult2 querySandPassrateQiangDuImportDate()
    {
        List<RepMttDataVO> listAll = new ArrayList<>();
        RepMttDataVO vo = new RepMttDataVO();
        RepPrinterSandPassrateVO passratevo =new RepPrinterSandPassrateVO();
        //查询最新一条导入数据的日期
        List<RepPrinterSandPassrateVO> list = repPrinterSandPassrateDao.listnew(passratevo);
        String startDT="";
        String endDT="";
        for(int i=0;i<list.size();i++)
        {
            startDT= list.get(i).getStartDate();
            endDT = list.get(i).getEndDate();
        }
        vo.setValue1(startDT);
        vo.setValue2(endDT);
        listAll.add(vo);
        return new JsonResult2(listAll);

    }

    @ApiOperation(value="分页查找砂型尺寸合格率统计列表", notes="分页查找砂型尺寸合格率统计列表")
    @PostMapping("/sandPassrateSizePageList")
    public JsonResult2 sandPassrateSizePageList(@RequestHeader("tenant_id") String tenant_id, @RequestHeader("user_id") String user_id, @RequestBody RepPrinterStarPassrateDTO c) {
        try {
            String startDate = c.getVo().getStartDate();
            if(StringUtils.isNotBlank(startDate)) {
                startDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", startDate), "yyyy-M-d");
                c.getVo().setStartDate(startDate);
            }
            String endDate = c.getVo().getEndDate();
            if(StringUtils.isNotBlank(endDate)) {
                endDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", endDate), "yyyy-M-d");
                c.getVo().setEndDate(endDate);
            }
            c.getVo().setSxType(0);
            JsonResult2 res = service.starPassratePageList(tenant_id, c);
            return res;
        } catch (Exception e) {
            logger.error("分页查找列表失败", e);
            String msg = e.getMessage()!=null?e.getMessage():JsonResultStatus.SYS_EXCEPTION.getMsg();
            return new JsonResult2(JsonResultStatus.SYS_EXCEPTION.getRet(), msg);
        }
    }


    @ApiOperation(value="分页查找砂型外观合格率统计列表", notes="分页查找砂型尺寸合格率统计列表")
    @PostMapping("/sandPassrateOutwardPageList")
    public JsonResult2 sandPassrateOutwardPageList(@RequestHeader("tenant_id") String tenant_id, @RequestHeader("user_id") String user_id, @RequestBody RepPrinterStarPassrateDTO c) {
        try {
            String startDate = c.getVo().getStartDate();
            if(StringUtils.isNotBlank(startDate)) {
                startDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", startDate), "yyyy-M-d");
                c.getVo().setStartDate(startDate);
            }
            String endDate = c.getVo().getEndDate();
            if(StringUtils.isNotBlank(endDate)) {
                endDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", endDate), "yyyy-M-d");
                c.getVo().setEndDate(endDate);
            }
            c.getVo().setSxType(1);
            JsonResult2 res = service.starPassratePageList(tenant_id, c);
            return res;
        } catch (Exception e) {
            logger.error("分页查找列表失败", e);
            String msg = e.getMessage()!=null?e.getMessage():JsonResultStatus.SYS_EXCEPTION.getMsg();
            return new JsonResult2(JsonResultStatus.SYS_EXCEPTION.getRet(), msg);
        }
    }
    @ApiOperation(value="分页查找砂型精度合格率统计列表", notes="分页查找砂型尺寸合格率统计列表")
    @PostMapping("/sandPassratePrecisionPageList")
    public JsonResult2 sandPassratePrecisionPageList(@RequestHeader("tenant_id") String tenant_id, @RequestHeader("user_id") String user_id, @RequestBody RepPrinterStarPassrateDTO c) {
        try {
            String startDate = c.getVo().getStartDate();
            if(StringUtils.isNotBlank(startDate)) {
                startDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", startDate), "yyyy-M-d");
                c.getVo().setStartDate(startDate);
            }
            String endDate = c.getVo().getEndDate();
            if(StringUtils.isNotBlank(endDate)) {
                endDate = DateUtils.format(DateUtils.parseDate("yyyy-MM-dd", endDate), "yyyy-M-d");
                c.getVo().setEndDate(endDate);
            }
            c.getVo().setSxType(2);
            JsonResult2 res = service.starPassratePageList(tenant_id, c);
            return res;
        } catch (Exception e) {
            logger.error("分页查找列表失败", e);
            String msg = e.getMessage()!=null?e.getMessage():JsonResultStatus.SYS_EXCEPTION.getMsg();
            return new JsonResult2(JsonResultStatus.SYS_EXCEPTION.getRet(), msg);
        }
    }




}
