package com.rootcloud.web.dto;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.List;

/**
 * 打印机效率DTO
 *
 * @author LiuQI 2018/8/29 17:40
 * @version V1.0
 **/
@ApiModel("打印机效率DTO")
public class PrinterEfficiencyDTO {

    @ApiModelProperty(value = "机构编号")
    private String officeId;

    @ApiModelProperty(value = "设备编号")
    private String deviceId;

    @ApiModelProperty(value = "年份", required = true)
    private Integer year;

    @ApiModelProperty("月份")
    private Integer month;

    @ApiModelProperty("日期")
    private Integer day;

    @ApiModelProperty(hidden = true)
    private List<String> deviceIdList;

    public String getOfficeId() {
        return officeId;
    }

    public void setOfficeId(String officeId) {
        this.officeId = officeId;
    }

    public String getDeviceId() {
        return deviceId;
    }

    public void setDeviceId(String deviceId) {
        this.deviceId = deviceId;
    }

    public Integer getYear() {
        return year;
    }

    public void setYear(Integer year) {
        this.year = year;
    }

    public Integer getMonth() {
        return month;
    }

    public void setMonth(Integer month) {
        this.month = month;
    }

    public Integer getDay() {
        return day;
    }

    public void setDay(Integer day) {
        this.day = day;
    }

    public List<String> getDeviceIdList() {
        return deviceIdList;
    }

    public void setDeviceIdList(List<String> deviceIdList) {
        this.deviceIdList = deviceIdList;
    }

    @Override
    public String toString() {
        return "PrinterEfficiencyDTO{" +
                "officeId='" + officeId + '\'' +
                ", deviceId='" + deviceId + '\'' +
                ", year=" + year +
                ", month=" + month +
                ", day=" + day +
                ", deviceIdList=" + deviceIdList +
                '}';
    }

}
