package com.rootcloud.web.dto;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.List;

/**
 * 打印机运维报告DTO
 *
 * @author
 * @version V1.0
 **/
@ApiModel("打印机运维报告DTO")
public class PrinterReportDTO {
    @ApiModelProperty(value = "机构编号")
    private String officeId;

    @ApiModelProperty(value = "设备编号")
    private String deviceId;

    private String tenantId;

    @ApiModelProperty(value = "年份", required = true)
    private Integer year;

    @ApiModelProperty("季度")
    private Integer quarter;

    @ApiModelProperty("月份")
    private Integer month;

    @ApiModelProperty("星期")
    private Integer week;

    @ApiModelProperty(hidden = true)
    private String startDate; 		//报告开始时间

    @ApiModelProperty(hidden = true)
    private String endDate; 		//报告结束日期

    @ApiModelProperty(hidden = true)
    private List<String> deviceIdList;

    @ApiModelProperty(hidden = true)
    private Integer queryedDeviceIdList;

    @ApiModelProperty(hidden = true)
    private Integer queryedType;

    @ApiModelProperty(hidden = true)
    private Double sandPassrateTargetValue;//砂型密度标准值

    public String getTenantId() {
        return tenantId;
    }

    public void setTenantId(String tenantId) {
        this.tenantId = tenantId;
    }

    public String getStartDate() {
        return startDate;
    }

    public void setStartDate(String startDate) {
        this.startDate = startDate;
    }

    public String getEndDate() {
        return endDate;
    }

    public void setEndDate(String endDate) {
        this.endDate = endDate;
    }

    public Double getSandPassrateTargetValue() {
        return sandPassrateTargetValue;
    }

    public void setSandPassrateTargetValue(Double sandPassrateTargetValue) {
        this.sandPassrateTargetValue = sandPassrateTargetValue;
    }

    public Integer getQueryedDeviceIdList() {
        return queryedDeviceIdList;
    }

    public void setQueryedDeviceIdList(Integer queryedDeviceIdList) {
        this.queryedDeviceIdList = queryedDeviceIdList;
    }

    public Integer getQueryedType() {
        return queryedType;
    }

    public void setQueryedType(Integer queryedType) {
        this.queryedType = queryedType;
    }

    public List<String> getDeviceIdList() {
        return deviceIdList;
    }

    public void setDeviceIdList(List<String> deviceIdList) {
        this.deviceIdList = deviceIdList;
    }

    public String getOfficeId() {
        return officeId;
    }


    public void setOfficeId(String officeId) {
        this.officeId = officeId;
    }

    public String getDeviceId() {
        return deviceId;
    }

    public void setDeviceId(String deviceId) {
        this.deviceId = deviceId;
    }

    public Integer getYear() {
        return year;
    }

    public void setYear(Integer year) {
        this.year = year;
    }

    public Integer getMonth() {
        return month;
    }

    public void setMonth(Integer month) {
        this.month = month;
    }

    public Integer getQuarter() {
        return quarter;
    }

    public void setQuarter(Integer quarter) {
        this.quarter = quarter;
    }

    public Integer getWeek() {
        return week;
    }

    public void setWeek(Integer week) {
        this.week = week;
    }

    @Override
    public String toString() {
        return "PrinterEfficiencyDTO{" +
                "officeId='" + officeId + '\'' +
                ", deviceId='" + deviceId + '\'' +
                ", year=" + year +
                ", quarter=" + quarter +
                ", month=" + month +
                ", week=" + week +
                '}';
    }
}
