package com.everyone.test;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import com.rootcloud.NXGXBaseApp;
import com.rootcloud.common.DateUtil;
import com.rootcloud.common.HttpClientUtil;
import com.rootcloud.common.TokenUtil;
import com.rootcloud.common.enums.HttpRequestMethedEnum;
import com.rootcloud.vo.device.BaseDeviceVO;
import com.rootcloud.vo.device.CommonDeviceHistorySituationVO;
import com.rootcloud.vo.device.DeviceHistorySituationVO;
import jline.internal.Log;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.util.ObjectUtils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @ClassName DemoTest
 * @Description TODO
 * @Author w-liuyi01
 * @Date 2022/4/20 17:16
 * @Version 1.0
 */

@RunWith(SpringRunner.class)
@SpringBootTest(classes = NXGXBaseApp.class)
public class DemoTest {

    @Autowired
    private TokenUtil tokenUtil;

    @Value("${os.iam.superToken}")
    private String superToken;

    @Value("${os.iam.domain}")
    private String reqUrl;


    @Test
    public void Test01() throws ParseException {
        // TODO: 2022/4/20
        callHistoryInterface("191QapNZHUY","191JYHoO4N2","2022-04-07T02:00:02.123Z","2022-04-21T02:00:02.123Z",1,10);
    }


    public void callHistoryInterface(String deviceId, String modelId, String startTime ,String endTime,Integer skip,Integer limit) throws ParseException {
        Map<String, String> headers = new HashMap<>();
        headers.put("Authorization", "Bearer "+tokenUtil.getToken());
        CommonDeviceHistorySituationVO situationVO = new CommonDeviceHistorySituationVO();
        try {
             String resp = HttpClientUtil.sendHttp(HttpRequestMethedEnum.HttpGet, reqUrl+"historian-manage/v1/historian/models/" + modelId + "/things/" + deviceId+"?startTime="+startTime+"&endTime="+endTime+"&skip="+skip+"&limit="+limit, null, headers);
//            Log.info("平台历史工况接口返回数据：{}",resp);
           JSONObject jsonObject = new JSONObject(resp);
            JSONArray array = jsonObject.getJSONArray("payload");
            array.stream().forEach(temp->{
                JSONObject obj = (JSONObject)temp;
                List<Map<String,Object>> list = new ArrayList<>();
                List<BaseDeviceVO> baseDeviceVOS = new ArrayList<>();
                JSONArray array2=obj.getJSONArray("rows");
                array2.stream().forEach(temp1->{
                    JSONArray array1=obj.getJSONArray("columns");
                    JSONArray array3 = (JSONArray)temp1;
                    Map<String,Object> map = new HashMap<>();
                    for(int i=0;i<array1.size();i++){
                        map.put(array1.get(i).toString(),array3.get(i));
                    }
                    list.add(map);
                });
                for (int i=0;i<list.size();i++){
                    BaseDeviceVO baseDeviceVO = new BaseDeviceVO();
                    baseDeviceVO.setDeviceId(obj.get("thingId").toString());
                    baseDeviceVO.setModelId(obj.get("modelId").toString());
                    if (!ObjectUtils.isEmpty(baseDeviceVO)){
                        baseDeviceVO.setDeviceSbbm("jeDeviceEntity.getDeviceSbbm()");
                        baseDeviceVO.setDeviceSblx("jeDeviceEntity.getDeviceSblx()");
                        baseDeviceVO.setDeviceSbmc("jeDeviceEntity.getDeviceSbmc()");
                        baseDeviceVO.setDeviceSbxh("jeDeviceEntity.getDeviceSbxh()");
                    }
                    baseDeviceVO.setUpdateTime(list.get(i).get("time").toString());
                    baseDeviceVOS.add(baseDeviceVO);
                }
                situationVO.setMapList(list);
                situationVO.setBaseDeviceVOList(baseDeviceVOS);
            });
        } catch (Exception e) {
            System.out.println("调用平台历史工况信息error");
        }
    }

    @Test
    public void Test03() {
        String deviceId = "191QapNZHUY";
        String modelId = "191JYHoO4N2";
        CommonDeviceHistorySituationVO situationVO = new CommonDeviceHistorySituationVO();
        HttpRequest request = HttpRequest.get(reqUrl +"historian-manage/v1/historian/models/" + modelId + "/things/" + deviceId);
        Map<String, Object> map = new HashMap<>(16);
        String startTime ="2022-04-07T02:00:02.123Z";
        String endTime ="2022-04-21T02:00:02.123Z";
        map.put("startTime", startTime);
        map.put("endTime", endTime);
        com.alibaba.fastjson.JSONArray properties = new com.alibaba.fastjson.JSONArray();
        properties.add("__location__.state");
        properties.add("__location__.city");
        map.put("properties",properties.toString());
        request.form(map);
        request.header("Authorization", "Bearer " + tokenUtil.getToken());
        request.header("accept", "application/json");
        request.header("Content-Type", "application/json");

        HttpResponse response = request.execute();
        String result = response.body();
        JSONObject jsonObject = new JSONObject(result);
        JSONArray array = jsonObject.getJSONArray("payload");

        array.stream().forEach(temp->{
            JSONObject obj = (JSONObject)temp;
            List<Map<String,Object>> list = new ArrayList<>();
            List<BaseDeviceVO> baseDeviceVOS = new ArrayList<>();
            JSONArray array2=obj.getJSONArray("rows");
            array2.stream().forEach(temp1->{
                JSONArray array1=obj.getJSONArray("columns");
                JSONArray array3 = (JSONArray)temp1;
                Map<String,Object> map1 = new HashMap<>();
                for(int i=0;i<array1.size();i++){
                    map1.put(array1.get(i).toString(),array3.get(i));
                }
                list.add(map1);
            });
            for (int i=0;i<list.size();i++){
                BaseDeviceVO baseDeviceVO = new BaseDeviceVO();
                baseDeviceVO.setDeviceId(obj.get("thingId").toString());
                baseDeviceVO.setModelId(obj.get("modelId").toString());
                if (!ObjectUtils.isEmpty(baseDeviceVO)){
                    baseDeviceVO.setDeviceSbbm("jeDeviceEntity.getDeviceSbbm()");
                    baseDeviceVO.setDeviceSblx("jeDeviceEntity.getDeviceSblx()");
                    baseDeviceVO.setDeviceSbmc("jeDeviceEntity.getDeviceSbmc()");
                    baseDeviceVO.setDeviceSbxh("jeDeviceEntity.getDeviceSbxh()");
                }
                baseDeviceVO.setUpdateTime(list.get(i).get("time").toString());
                baseDeviceVOS.add(baseDeviceVO);
            }
            situationVO.setMapList(list);
            situationVO.setBaseDeviceVOList(baseDeviceVOS);
        });

        //List<ModelEntity> list = JSONUtil.toList(array.toString(), ModelEntity.class);
    }

    @Test
    public void testTime() throws ParseException {
        String dtime1 = "2021-06-10 22:04:34";
        Date date = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").parse(dtime1);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        //format将Date型转换为String型，parse将String型转换为Date型
        String UTCDate = sdf.format(date);
        System.out.println(UTCDate);
    }

    @Test
    public void testTime1() {
        String s = DateUtil.reverseHandlerTime("2022-04-07T02:00:02.05Z");
        System.out.println(s);
    }


}
